/* A Bison parser, made by GNU Bison 3.7.3.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.7.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 79 "cfg.y"


#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "route.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "pvar.h"
#include "blacklists.h"
#include "xlog.h"
#include "db/db_insertq.h"
#include "bin_interface.h"
#include "net/trans.h"
#include "config.h"

#ifdef SHM_EXTRA_STATS
#include "mem/module_info.h"
#endif

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H


extern int yylex();
static void yyerror(char* s);
static void yyerrorf(char* fmt, ...);
static char* tmp;
static int i_tmp, rc;
static void* cmd_tmp;
static struct socket_id* lst_tmp;
static int rt;  /* Type of route block for find_export */
static str s_tmp;
static str tstr;
static struct net* net_tmp;
static pv_spec_t *spec;
static pv_elem_t *pvmodel;
static struct bl_rule *bl_head = 0;
static struct bl_rule *bl_tail = 0;

action_elem_t elems[MAX_ACTION_ELEMS];
static action_elem_t route_elems[MAX_ACTION_ELEMS];
action_elem_t *a_tmp;

static inline void warn(char* s);
static struct socket_id* mk_listen_id(char*, enum sip_protos, int);
static struct socket_id* set_listen_id_adv(struct socket_id *, char *, int);
static struct multi_str *new_string(char *s);
static int parse_ipnet(char *in, int len, struct net **ipnet);

extern int line;
extern int column;
extern int startcolumn;
extern char *finame;

#ifndef SHM_EXTRA_STATS
struct multi_str{
	char *s;
	struct multi_str* next;
};
#else 
static struct multi_str *tmp_mod;
#endif

#define get_cfg_file_name \
	((finame) ? finame : cfg_file ? cfg_file : "default")



#define mk_action_(_res, _type, _no, _elems) \
	do { \
		_res = mk_action(_type, _no, _elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action0(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		_res = mk_action(_type, 0, 0, line, get_cfg_file_name); \
	} while(0)
#define mk_action1(_res, _type, _p1_type, _p1) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		_res = mk_action(_type, 1, elems, line, get_cfg_file_name); \
	} while(0)
#define	mk_action2(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		_res = mk_action(_type, 2, elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action3(_res, _type, _p1_type, _p2_type, _p3_type, _p1, _p2, _p3) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		elems[2].type = _p3_type; \
		elems[2].u.data = _p3; \
		_res = mk_action(_type, 3, elems, line, get_cfg_file_name); \
	} while(0)


#line 196 "cfg.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cfg.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_FORWARD = 3,                    /* FORWARD  */
  YYSYMBOL_SEND = 4,                       /* SEND  */
  YYSYMBOL_DROP = 5,                       /* DROP  */
  YYSYMBOL_ASSERT = 6,                     /* ASSERT  */
  YYSYMBOL_EXIT = 7,                       /* EXIT  */
  YYSYMBOL_RETURN = 8,                     /* RETURN  */
  YYSYMBOL_LOG_TOK = 9,                    /* LOG_TOK  */
  YYSYMBOL_ERROR = 10,                     /* ERROR  */
  YYSYMBOL_ROUTE = 11,                     /* ROUTE  */
  YYSYMBOL_ROUTE_FAILURE = 12,             /* ROUTE_FAILURE  */
  YYSYMBOL_ROUTE_ONREPLY = 13,             /* ROUTE_ONREPLY  */
  YYSYMBOL_ROUTE_BRANCH = 14,              /* ROUTE_BRANCH  */
  YYSYMBOL_ROUTE_ERROR = 15,               /* ROUTE_ERROR  */
  YYSYMBOL_ROUTE_LOCAL = 16,               /* ROUTE_LOCAL  */
  YYSYMBOL_ROUTE_STARTUP = 17,             /* ROUTE_STARTUP  */
  YYSYMBOL_ROUTE_TIMER = 18,               /* ROUTE_TIMER  */
  YYSYMBOL_ROUTE_EVENT = 19,               /* ROUTE_EVENT  */
  YYSYMBOL_SET_HOST = 20,                  /* SET_HOST  */
  YYSYMBOL_SET_HOSTPORT = 21,              /* SET_HOSTPORT  */
  YYSYMBOL_PREFIX = 22,                    /* PREFIX  */
  YYSYMBOL_STRIP = 23,                     /* STRIP  */
  YYSYMBOL_STRIP_TAIL = 24,                /* STRIP_TAIL  */
  YYSYMBOL_APPEND_BRANCH = 25,             /* APPEND_BRANCH  */
  YYSYMBOL_REMOVE_BRANCH = 26,             /* REMOVE_BRANCH  */
  YYSYMBOL_PV_PRINTF = 27,                 /* PV_PRINTF  */
  YYSYMBOL_SET_USER = 28,                  /* SET_USER  */
  YYSYMBOL_SET_USERPASS = 29,              /* SET_USERPASS  */
  YYSYMBOL_SET_PORT = 30,                  /* SET_PORT  */
  YYSYMBOL_SET_URI = 31,                   /* SET_URI  */
  YYSYMBOL_REVERT_URI = 32,                /* REVERT_URI  */
  YYSYMBOL_SET_DSTURI = 33,                /* SET_DSTURI  */
  YYSYMBOL_RESET_DSTURI = 34,              /* RESET_DSTURI  */
  YYSYMBOL_ISDSTURISET = 35,               /* ISDSTURISET  */
  YYSYMBOL_FORCE_RPORT = 36,               /* FORCE_RPORT  */
  YYSYMBOL_FORCE_LOCAL_RPORT = 37,         /* FORCE_LOCAL_RPORT  */
  YYSYMBOL_FORCE_TCP_ALIAS = 38,           /* FORCE_TCP_ALIAS  */
  YYSYMBOL_IF = 39,                        /* IF  */
  YYSYMBOL_ELSE = 40,                      /* ELSE  */
  YYSYMBOL_SWITCH = 41,                    /* SWITCH  */
  YYSYMBOL_CASE = 42,                      /* CASE  */
  YYSYMBOL_DEFAULT = 43,                   /* DEFAULT  */
  YYSYMBOL_SBREAK = 44,                    /* SBREAK  */
  YYSYMBOL_WHILE = 45,                     /* WHILE  */
  YYSYMBOL_FOR = 46,                       /* FOR  */
  YYSYMBOL_IN = 47,                        /* IN  */
  YYSYMBOL_SET_ADV_ADDRESS = 48,           /* SET_ADV_ADDRESS  */
  YYSYMBOL_SET_ADV_PORT = 49,              /* SET_ADV_PORT  */
  YYSYMBOL_FORCE_SEND_SOCKET = 50,         /* FORCE_SEND_SOCKET  */
  YYSYMBOL_SERIALIZE_BRANCHES = 51,        /* SERIALIZE_BRANCHES  */
  YYSYMBOL_NEXT_BRANCHES = 52,             /* NEXT_BRANCHES  */
  YYSYMBOL_USE_BLACKLIST = 53,             /* USE_BLACKLIST  */
  YYSYMBOL_UNUSE_BLACKLIST = 54,           /* UNUSE_BLACKLIST  */
  YYSYMBOL_SETFLAG = 55,                   /* SETFLAG  */
  YYSYMBOL_RESETFLAG = 56,                 /* RESETFLAG  */
  YYSYMBOL_ISFLAGSET = 57,                 /* ISFLAGSET  */
  YYSYMBOL_SETBFLAG = 58,                  /* SETBFLAG  */
  YYSYMBOL_RESETBFLAG = 59,                /* RESETBFLAG  */
  YYSYMBOL_ISBFLAGSET = 60,                /* ISBFLAGSET  */
  YYSYMBOL_METHOD = 61,                    /* METHOD  */
  YYSYMBOL_PROTO = 62,                     /* PROTO  */
  YYSYMBOL_AF = 63,                        /* AF  */
  YYSYMBOL_IS_MYSELF = 64,                 /* IS_MYSELF  */
  YYSYMBOL_MSGLEN = 65,                    /* MSGLEN  */
  YYSYMBOL_NULLV = 66,                     /* NULLV  */
  YYSYMBOL_CACHE_STORE = 67,               /* CACHE_STORE  */
  YYSYMBOL_CACHE_FETCH = 68,               /* CACHE_FETCH  */
  YYSYMBOL_CACHE_COUNTER_FETCH = 69,       /* CACHE_COUNTER_FETCH  */
  YYSYMBOL_CACHE_REMOVE = 70,              /* CACHE_REMOVE  */
  YYSYMBOL_CACHE_ADD = 71,                 /* CACHE_ADD  */
  YYSYMBOL_CACHE_SUB = 72,                 /* CACHE_SUB  */
  YYSYMBOL_CACHE_RAW_QUERY = 73,           /* CACHE_RAW_QUERY  */
  YYSYMBOL_XDBG = 74,                      /* XDBG  */
  YYSYMBOL_XLOG = 75,                      /* XLOG  */
  YYSYMBOL_XLOG_BUF_SIZE = 76,             /* XLOG_BUF_SIZE  */
  YYSYMBOL_XLOG_FORCE_COLOR = 77,          /* XLOG_FORCE_COLOR  */
  YYSYMBOL_XLOG_DEFAULT_LEVEL = 78,        /* XLOG_DEFAULT_LEVEL  */
  YYSYMBOL_RAISE_EVENT = 79,               /* RAISE_EVENT  */
  YYSYMBOL_SUBSCRIBE_EVENT = 80,           /* SUBSCRIBE_EVENT  */
  YYSYMBOL_CONSTRUCT_URI = 81,             /* CONSTRUCT_URI  */
  YYSYMBOL_GET_TIMESTAMP = 82,             /* GET_TIMESTAMP  */
  YYSYMBOL_SCRIPT_TRACE = 83,              /* SCRIPT_TRACE  */
  YYSYMBOL_FORK = 84,                      /* FORK  */
  YYSYMBOL_DEBUG_MODE = 85,                /* DEBUG_MODE  */
  YYSYMBOL_DEBUG = 86,                     /* DEBUG  */
  YYSYMBOL_ENABLE_ASSERTS = 87,            /* ENABLE_ASSERTS  */
  YYSYMBOL_ABORT_ON_ASSERT = 88,           /* ABORT_ON_ASSERT  */
  YYSYMBOL_LOGLEVEL = 89,                  /* LOGLEVEL  */
  YYSYMBOL_LOGSTDERROR = 90,               /* LOGSTDERROR  */
  YYSYMBOL_LOGFACILITY = 91,               /* LOGFACILITY  */
  YYSYMBOL_LOGNAME = 92,                   /* LOGNAME  */
  YYSYMBOL_AVP_ALIASES = 93,               /* AVP_ALIASES  */
  YYSYMBOL_LISTEN = 94,                    /* LISTEN  */
  YYSYMBOL_MEMGROUP = 95,                  /* MEMGROUP  */
  YYSYMBOL_ALIAS = 96,                     /* ALIAS  */
  YYSYMBOL_AUTO_ALIASES = 97,              /* AUTO_ALIASES  */
  YYSYMBOL_DNS = 98,                       /* DNS  */
  YYSYMBOL_REV_DNS = 99,                   /* REV_DNS  */
  YYSYMBOL_DNS_TRY_IPV6 = 100,             /* DNS_TRY_IPV6  */
  YYSYMBOL_DNS_TRY_NAPTR = 101,            /* DNS_TRY_NAPTR  */
  YYSYMBOL_DNS_RETR_TIME = 102,            /* DNS_RETR_TIME  */
  YYSYMBOL_DNS_RETR_NO = 103,              /* DNS_RETR_NO  */
  YYSYMBOL_DNS_SERVERS_NO = 104,           /* DNS_SERVERS_NO  */
  YYSYMBOL_DNS_USE_SEARCH = 105,           /* DNS_USE_SEARCH  */
  YYSYMBOL_MAX_WHILE_LOOPS = 106,          /* MAX_WHILE_LOOPS  */
  YYSYMBOL_CHILDREN = 107,                 /* CHILDREN  */
  YYSYMBOL_CHECK_VIA = 108,                /* CHECK_VIA  */
  YYSYMBOL_SHM_HASH_SPLIT_PERCENTAGE = 109, /* SHM_HASH_SPLIT_PERCENTAGE  */
  YYSYMBOL_SHM_SECONDARY_HASH_SIZE = 110,  /* SHM_SECONDARY_HASH_SIZE  */
  YYSYMBOL_MEM_WARMING_ENABLED = 111,      /* MEM_WARMING_ENABLED  */
  YYSYMBOL_MEM_WARMING_PATTERN_FILE = 112, /* MEM_WARMING_PATTERN_FILE  */
  YYSYMBOL_MEM_WARMING_PERCENTAGE = 113,   /* MEM_WARMING_PERCENTAGE  */
  YYSYMBOL_MEMLOG = 114,                   /* MEMLOG  */
  YYSYMBOL_MEMDUMP = 115,                  /* MEMDUMP  */
  YYSYMBOL_EXECMSGTHRESHOLD = 116,         /* EXECMSGTHRESHOLD  */
  YYSYMBOL_EXECDNSTHRESHOLD = 117,         /* EXECDNSTHRESHOLD  */
  YYSYMBOL_TCPTHRESHOLD = 118,             /* TCPTHRESHOLD  */
  YYSYMBOL_EVENT_SHM_THRESHOLD = 119,      /* EVENT_SHM_THRESHOLD  */
  YYSYMBOL_EVENT_PKG_THRESHOLD = 120,      /* EVENT_PKG_THRESHOLD  */
  YYSYMBOL_QUERYBUFFERSIZE = 121,          /* QUERYBUFFERSIZE  */
  YYSYMBOL_QUERYFLUSHTIME = 122,           /* QUERYFLUSHTIME  */
  YYSYMBOL_SIP_WARNING = 123,              /* SIP_WARNING  */
  YYSYMBOL_SOCK_MODE = 124,                /* SOCK_MODE  */
  YYSYMBOL_SOCK_USER = 125,                /* SOCK_USER  */
  YYSYMBOL_SOCK_GROUP = 126,               /* SOCK_GROUP  */
  YYSYMBOL_UNIX_SOCK = 127,                /* UNIX_SOCK  */
  YYSYMBOL_UNIX_SOCK_CHILDREN = 128,       /* UNIX_SOCK_CHILDREN  */
  YYSYMBOL_UNIX_TX_TIMEOUT = 129,          /* UNIX_TX_TIMEOUT  */
  YYSYMBOL_SERVER_SIGNATURE = 130,         /* SERVER_SIGNATURE  */
  YYSYMBOL_SERVER_HEADER = 131,            /* SERVER_HEADER  */
  YYSYMBOL_USER_AGENT_HEADER = 132,        /* USER_AGENT_HEADER  */
  YYSYMBOL_LOADMODULE = 133,               /* LOADMODULE  */
  YYSYMBOL_MPATH = 134,                    /* MPATH  */
  YYSYMBOL_MODPARAM = 135,                 /* MODPARAM  */
  YYSYMBOL_MAXBUFFER = 136,                /* MAXBUFFER  */
  YYSYMBOL_CHROOT = 137,                   /* CHROOT  */
  YYSYMBOL_WDIR = 138,                     /* WDIR  */
  YYSYMBOL_MHOMED = 139,                   /* MHOMED  */
  YYSYMBOL_POLL_METHOD = 140,              /* POLL_METHOD  */
  YYSYMBOL_TCP_ACCEPT_ALIASES = 141,       /* TCP_ACCEPT_ALIASES  */
  YYSYMBOL_TCP_CHILDREN = 142,             /* TCP_CHILDREN  */
  YYSYMBOL_TCP_CONNECT_TIMEOUT = 143,      /* TCP_CONNECT_TIMEOUT  */
  YYSYMBOL_TCP_CON_LIFETIME = 144,         /* TCP_CON_LIFETIME  */
  YYSYMBOL_TCP_LISTEN_BACKLOG = 145,       /* TCP_LISTEN_BACKLOG  */
  YYSYMBOL_TCP_MAX_CONNECTIONS = 146,      /* TCP_MAX_CONNECTIONS  */
  YYSYMBOL_TCP_NO_NEW_CONN_BFLAG = 147,    /* TCP_NO_NEW_CONN_BFLAG  */
  YYSYMBOL_TCP_KEEPALIVE = 148,            /* TCP_KEEPALIVE  */
  YYSYMBOL_TCP_KEEPCOUNT = 149,            /* TCP_KEEPCOUNT  */
  YYSYMBOL_TCP_KEEPIDLE = 150,             /* TCP_KEEPIDLE  */
  YYSYMBOL_TCP_KEEPINTERVAL = 151,         /* TCP_KEEPINTERVAL  */
  YYSYMBOL_TCP_MAX_MSG_TIME = 152,         /* TCP_MAX_MSG_TIME  */
  YYSYMBOL_ADVERTISED_ADDRESS = 153,       /* ADVERTISED_ADDRESS  */
  YYSYMBOL_ADVERTISED_PORT = 154,          /* ADVERTISED_PORT  */
  YYSYMBOL_DISABLE_CORE = 155,             /* DISABLE_CORE  */
  YYSYMBOL_OPEN_FD_LIMIT = 156,            /* OPEN_FD_LIMIT  */
  YYSYMBOL_MCAST_LOOPBACK = 157,           /* MCAST_LOOPBACK  */
  YYSYMBOL_MCAST_TTL = 158,                /* MCAST_TTL  */
  YYSYMBOL_TOS = 159,                      /* TOS  */
  YYSYMBOL_DISABLE_DNS_FAILOVER = 160,     /* DISABLE_DNS_FAILOVER  */
  YYSYMBOL_DISABLE_DNS_BLACKLIST = 161,    /* DISABLE_DNS_BLACKLIST  */
  YYSYMBOL_DST_BLACKLIST = 162,            /* DST_BLACKLIST  */
  YYSYMBOL_DISABLE_STATELESS_FWD = 163,    /* DISABLE_STATELESS_FWD  */
  YYSYMBOL_DB_VERSION_TABLE = 164,         /* DB_VERSION_TABLE  */
  YYSYMBOL_DB_DEFAULT_URL = 165,           /* DB_DEFAULT_URL  */
  YYSYMBOL_DB_MAX_ASYNC_CONNECTIONS = 166, /* DB_MAX_ASYNC_CONNECTIONS  */
  YYSYMBOL_DISABLE_503_TRANSLATION = 167,  /* DISABLE_503_TRANSLATION  */
  YYSYMBOL_SYNC_TOKEN = 168,               /* SYNC_TOKEN  */
  YYSYMBOL_ASYNC_TOKEN = 169,              /* ASYNC_TOKEN  */
  YYSYMBOL_LAUNCH_TOKEN = 170,             /* LAUNCH_TOKEN  */
  YYSYMBOL_EQUAL = 171,                    /* EQUAL  */
  YYSYMBOL_EQUAL_T = 172,                  /* EQUAL_T  */
  YYSYMBOL_GT = 173,                       /* GT  */
  YYSYMBOL_LT = 174,                       /* LT  */
  YYSYMBOL_GTE = 175,                      /* GTE  */
  YYSYMBOL_LTE = 176,                      /* LTE  */
  YYSYMBOL_DIFF = 177,                     /* DIFF  */
  YYSYMBOL_MATCH = 178,                    /* MATCH  */
  YYSYMBOL_NOTMATCH = 179,                 /* NOTMATCH  */
  YYSYMBOL_COLONEQ = 180,                  /* COLONEQ  */
  YYSYMBOL_PLUSEQ = 181,                   /* PLUSEQ  */
  YYSYMBOL_MINUSEQ = 182,                  /* MINUSEQ  */
  YYSYMBOL_SLASHEQ = 183,                  /* SLASHEQ  */
  YYSYMBOL_MULTEQ = 184,                   /* MULTEQ  */
  YYSYMBOL_MODULOEQ = 185,                 /* MODULOEQ  */
  YYSYMBOL_BANDEQ = 186,                   /* BANDEQ  */
  YYSYMBOL_BOREQ = 187,                    /* BOREQ  */
  YYSYMBOL_BXOREQ = 188,                   /* BXOREQ  */
  YYSYMBOL_OR = 189,                       /* OR  */
  YYSYMBOL_AND = 190,                      /* AND  */
  YYSYMBOL_BOR = 191,                      /* BOR  */
  YYSYMBOL_BAND = 192,                     /* BAND  */
  YYSYMBOL_BXOR = 193,                     /* BXOR  */
  YYSYMBOL_BLSHIFT = 194,                  /* BLSHIFT  */
  YYSYMBOL_BRSHIFT = 195,                  /* BRSHIFT  */
  YYSYMBOL_PLUS = 196,                     /* PLUS  */
  YYSYMBOL_MINUS = 197,                    /* MINUS  */
  YYSYMBOL_MULT = 198,                     /* MULT  */
  YYSYMBOL_MODULO = 199,                   /* MODULO  */
  YYSYMBOL_NOT = 200,                      /* NOT  */
  YYSYMBOL_BNOT = 201,                     /* BNOT  */
  YYSYMBOL_NUMBER = 202,                   /* NUMBER  */
  YYSYMBOL_ZERO = 203,                     /* ZERO  */
  YYSYMBOL_ID = 204,                       /* ID  */
  YYSYMBOL_STRING = 205,                   /* STRING  */
  YYSYMBOL_SCRIPTVAR = 206,                /* SCRIPTVAR  */
  YYSYMBOL_IPV6ADDR = 207,                 /* IPV6ADDR  */
  YYSYMBOL_IPV4ADDR = 208,                 /* IPV4ADDR  */
  YYSYMBOL_IPNET = 209,                    /* IPNET  */
  YYSYMBOL_COMMA = 210,                    /* COMMA  */
  YYSYMBOL_SEMICOLON = 211,                /* SEMICOLON  */
  YYSYMBOL_RPAREN = 212,                   /* RPAREN  */
  YYSYMBOL_LPAREN = 213,                   /* LPAREN  */
  YYSYMBOL_LBRACE = 214,                   /* LBRACE  */
  YYSYMBOL_RBRACE = 215,                   /* RBRACE  */
  YYSYMBOL_LBRACK = 216,                   /* LBRACK  */
  YYSYMBOL_RBRACK = 217,                   /* RBRACK  */
  YYSYMBOL_SLASH = 218,                    /* SLASH  */
  YYSYMBOL_AS = 219,                       /* AS  */
  YYSYMBOL_USE_CHILDREN = 220,             /* USE_CHILDREN  */
  YYSYMBOL_DOT = 221,                      /* DOT  */
  YYSYMBOL_CR = 222,                       /* CR  */
  YYSYMBOL_COLON = 223,                    /* COLON  */
  YYSYMBOL_ANY = 224,                      /* ANY  */
  YYSYMBOL_ANYCAST = 225,                  /* ANYCAST  */
  YYSYMBOL_SCRIPTVARERR = 226,             /* SCRIPTVARERR  */
  YYSYMBOL_YYACCEPT = 227,                 /* $accept  */
  YYSYMBOL_cfg = 228,                      /* cfg  */
  YYSYMBOL_statements = 229,               /* statements  */
  YYSYMBOL_statement = 230,                /* statement  */
  YYSYMBOL_231_1 = 231,                    /* $@1  */
  YYSYMBOL_232_2 = 232,                    /* $@2  */
  YYSYMBOL_233_3 = 233,                    /* $@3  */
  YYSYMBOL_234_4 = 234,                    /* $@4  */
  YYSYMBOL_235_5 = 235,                    /* $@5  */
  YYSYMBOL_236_6 = 236,                    /* $@6  */
  YYSYMBOL_237_7 = 237,                    /* $@7  */
  YYSYMBOL_238_8 = 238,                    /* $@8  */
  YYSYMBOL_239_9 = 239,                    /* $@9  */
  YYSYMBOL_listen_id = 240,                /* listen_id  */
  YYSYMBOL_proto = 241,                    /* proto  */
  YYSYMBOL_port = 242,                     /* port  */
  YYSYMBOL_snumber = 243,                  /* snumber  */
  YYSYMBOL_phostport = 244,                /* phostport  */
  YYSYMBOL_panyhostport = 245,             /* panyhostport  */
  YYSYMBOL_alias_def = 246,                /* alias_def  */
  YYSYMBOL_id_lst = 247,                   /* id_lst  */
  YYSYMBOL_listen_def = 248,               /* listen_def  */
  YYSYMBOL_any_proto = 249,                /* any_proto  */
  YYSYMBOL_multi_string = 250,             /* multi_string  */
  YYSYMBOL_blst_elem = 251,                /* blst_elem  */
  YYSYMBOL_blst_elem_list = 252,           /* blst_elem_list  */
  YYSYMBOL_assign_stm = 253,               /* assign_stm  */
  YYSYMBOL_module_stm = 254,               /* module_stm  */
  YYSYMBOL_ip = 255,                       /* ip  */
  YYSYMBOL_ipv4 = 256,                     /* ipv4  */
  YYSYMBOL_ipv6addr = 257,                 /* ipv6addr  */
  YYSYMBOL_ipv6 = 258,                     /* ipv6  */
  YYSYMBOL_folded_string = 259,            /* folded_string  */
  YYSYMBOL_route_name = 260,               /* route_name  */
  YYSYMBOL_route_stm = 261,                /* route_stm  */
  YYSYMBOL_failure_route_stm = 262,        /* failure_route_stm  */
  YYSYMBOL_onreply_route_stm = 263,        /* onreply_route_stm  */
  YYSYMBOL_branch_route_stm = 264,         /* branch_route_stm  */
  YYSYMBOL_error_route_stm = 265,          /* error_route_stm  */
  YYSYMBOL_local_route_stm = 266,          /* local_route_stm  */
  YYSYMBOL_startup_route_stm = 267,        /* startup_route_stm  */
  YYSYMBOL_timer_route_stm = 268,          /* timer_route_stm  */
  YYSYMBOL_event_route_stm = 269,          /* event_route_stm  */
  YYSYMBOL_exp = 270,                      /* exp  */
  YYSYMBOL_equalop = 271,                  /* equalop  */
  YYSYMBOL_compop = 272,                   /* compop  */
  YYSYMBOL_matchop = 273,                  /* matchop  */
  YYSYMBOL_intop = 274,                    /* intop  */
  YYSYMBOL_strop = 275,                    /* strop  */
  YYSYMBOL_script_var = 276,               /* script_var  */
  YYSYMBOL_exp_elem = 277,                 /* exp_elem  */
  YYSYMBOL_exp_cond = 278,                 /* exp_cond  */
  YYSYMBOL_ipnet = 279,                    /* ipnet  */
  YYSYMBOL_host_sep = 280,                 /* host_sep  */
  YYSYMBOL_host = 281,                     /* host  */
  YYSYMBOL_assignop = 282,                 /* assignop  */
  YYSYMBOL_assignexp = 283,                /* assignexp  */
  YYSYMBOL_assign_cmd = 284,               /* assign_cmd  */
  YYSYMBOL_exp_stm = 285,                  /* exp_stm  */
  YYSYMBOL_stm = 286,                      /* stm  */
  YYSYMBOL_actions = 287,                  /* actions  */
  YYSYMBOL_action = 288,                   /* action  */
  YYSYMBOL_if_cmd = 289,                   /* if_cmd  */
  YYSYMBOL_while_cmd = 290,                /* while_cmd  */
  YYSYMBOL_foreach_cmd = 291,              /* foreach_cmd  */
  YYSYMBOL_switch_cmd = 292,               /* switch_cmd  */
  YYSYMBOL_switch_stm = 293,               /* switch_stm  */
  YYSYMBOL_case_stms = 294,                /* case_stms  */
  YYSYMBOL_case_stm = 295,                 /* case_stm  */
  YYSYMBOL_default_stm = 296,              /* default_stm  */
  YYSYMBOL_module_func_param = 297,        /* module_func_param  */
  YYSYMBOL_route_param = 298,              /* route_param  */
  YYSYMBOL_async_func = 299,               /* async_func  */
  YYSYMBOL_cmd = 300                       /* cmd  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  188
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   5120

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  227
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  74
/* YYNRULES -- Number of rules.  */
#define YYNRULES  559
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1197

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   481


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   486,   486,   489,   490,   491,   494,   495,   496,   496,
     497,   497,   498,   498,   499,   499,   500,   500,   501,   501,
     502,   502,   503,   503,   504,   504,   506,   509,   523,   531,
     545,   554,   555,   558,   559,   560,   564,   565,   566,   571,
     577,   578,   581,   582,   583,   584,   588,   591,   592,   596,
     597,   598,   599,   600,   601,   604,   607,   611,   615,   619,
     622,   626,   630,   636,   637,   639,   640,   643,   650,   660,
     661,   662,   666,   668,   670,   674,   675,   676,   677,   678,
     681,   683,   687,   688,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   729,   737,   745,   753,   761,   769,   777,   785,
     793,   801,   802,   803,   804,   805,   806,   807,   808,   809,
     810,   811,   821,   822,   842,   843,   844,   845,   846,   847,
     848,   849,   850,   851,   852,   853,   854,   855,   856,   857,
     867,   877,   878,   881,   882,   885,   886,   889,   890,   893,
     894,   897,   898,   901,   902,   911,   918,   919,   922,   923,
     926,   927,   934,   935,   942,   943,   950,   951,   952,   953,
     956,   957,   960,   961,   962,   963,   964,   965,   966,   967,
     974,   977,  1021,  1022,  1027,  1029,  1030,  1031,  1037,  1039,
    1053,  1055,  1058,  1059,  1062,  1063,  1070,  1071,  1078,  1079,
    1083,  1110,  1111,  1112,  1113,  1116,  1117,  1120,  1121,  1131,
    1134,  1135,  1136,  1137,  1138,  1139,  1142,  1143,  1146,  1149,
    1153,  1154,  1160,  1166,  1170,  1171,  1174,  1190,  1206,  1207,
    1210,  1220,  1231,  1234,  1243,  1248,  1256,  1271,  1274,  1280,
    1283,  1291,  1297,  1300,  1306,  1309,  1317,  1320,  1328,  1331,
    1339,  1342,  1354,  1358,  1378,  1399,  1420,  1424,  1425,  1426,
    1427,  1428,  1429,  1432,  1433,  1436,  1437,  1438,  1439,  1441,
    1442,  1445,  1446,  1449,  1450,  1451,  1455,  1471,  1476,  1477,
    1478,  1480,  1485,  1488,  1491,  1494,  1497,  1504,  1510,  1514,
    1515,  1518,  1519,  1532,  1536,  1537,  1538,  1539,  1540,  1541,
    1542,  1543,  1544,  1545,  1549,  1550,  1551,  1552,  1553,  1554,
    1557,  1560,  1563,  1566,  1569,  1572,  1575,  1578,  1581,  1584,
    1587,  1590,  1603,  1616,  1638,  1639,  1640,  1641,  1642,  1645,
    1646,  1647,  1650,  1651,  1652,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1665,  1673,  1683,  1691,  1709,  1718,  1719,
    1721,  1722,  1725,  1734,  1743,  1751,  1759,  1768,  1777,  1785,
    1796,  1802,  1810,  1815,  1825,  1832,  1839,  1849,  1854,  1859,
    1866,  1871,  1876,  1881,  1886,  1896,  1906,  1916,  1928,  1940,
    1952,  1956,  1962,  1968,  1975,  1976,  1979,  1985,  1991,  1992,
    1994,  1997,  1998,  1999,  2000,  2001,  2007,  2013,  2019,  2025,
    2028,  2034,  2035,  2037,  2040,  2042,  2043,  2045,  2047,  2048,
    2050,  2052,  2053,  2057,  2061,  2064,  2067,  2068,  2072,  2076,
    2080,  2084,  2085,  2089,  2093,  2097,  2101,  2102,  2108,  2109,
    2111,  2118,  2139,  2140,  2142,  2144,  2145,  2148,  2150,  2151,
    2153,  2155,  2156,  2159,  2161,  2162,  2164,  2177,  2179,  2181,
    2183,  2185,  2187,  2210,  2225,  2227,  2228,  2230,  2232,  2233,
    2235,  2237,  2238,  2240,  2242,  2243,  2245,  2247,  2248,  2250,
    2251,  2252,  2254,  2255,  2257,  2259,  2260,  2261,  2262,  2264,
    2265,  2267,  2269,  2273,  2276,  2279,  2282,  2286,  2288,  2289,
    2302,  2307,  2309,  2310,  2314,  2317,  2318,  2322,  2327,  2330,
    2331,  2334,  2337,  2338,  2342,  2345,  2346,  2350,  2353,  2354,
    2363,  2375,  2388,  2395,  2404,  2413,  2424,  2435,  2448,  2461,
    2472,  2483,  2496,  2509,  2518,  2525,  2542,  2559,  2561,  2564,
    2566,  2568,  2570,  2572,  2574,  2576,  2578,  2580,  2583,  2585,
    2588,  2602,  2608,  2610,  2618,  2626,  2632,  2638,  2642,  2645
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "FORWARD", "SEND",
  "DROP", "ASSERT", "EXIT", "RETURN", "LOG_TOK", "ERROR", "ROUTE",
  "ROUTE_FAILURE", "ROUTE_ONREPLY", "ROUTE_BRANCH", "ROUTE_ERROR",
  "ROUTE_LOCAL", "ROUTE_STARTUP", "ROUTE_TIMER", "ROUTE_EVENT", "SET_HOST",
  "SET_HOSTPORT", "PREFIX", "STRIP", "STRIP_TAIL", "APPEND_BRANCH",
  "REMOVE_BRANCH", "PV_PRINTF", "SET_USER", "SET_USERPASS", "SET_PORT",
  "SET_URI", "REVERT_URI", "SET_DSTURI", "RESET_DSTURI", "ISDSTURISET",
  "FORCE_RPORT", "FORCE_LOCAL_RPORT", "FORCE_TCP_ALIAS", "IF", "ELSE",
  "SWITCH", "CASE", "DEFAULT", "SBREAK", "WHILE", "FOR", "IN",
  "SET_ADV_ADDRESS", "SET_ADV_PORT", "FORCE_SEND_SOCKET",
  "SERIALIZE_BRANCHES", "NEXT_BRANCHES", "USE_BLACKLIST",
  "UNUSE_BLACKLIST", "SETFLAG", "RESETFLAG", "ISFLAGSET", "SETBFLAG",
  "RESETBFLAG", "ISBFLAGSET", "METHOD", "PROTO", "AF", "IS_MYSELF",
  "MSGLEN", "NULLV", "CACHE_STORE", "CACHE_FETCH", "CACHE_COUNTER_FETCH",
  "CACHE_REMOVE", "CACHE_ADD", "CACHE_SUB", "CACHE_RAW_QUERY", "XDBG",
  "XLOG", "XLOG_BUF_SIZE", "XLOG_FORCE_COLOR", "XLOG_DEFAULT_LEVEL",
  "RAISE_EVENT", "SUBSCRIBE_EVENT", "CONSTRUCT_URI", "GET_TIMESTAMP",
  "SCRIPT_TRACE", "FORK", "DEBUG_MODE", "DEBUG", "ENABLE_ASSERTS",
  "ABORT_ON_ASSERT", "LOGLEVEL", "LOGSTDERROR", "LOGFACILITY", "LOGNAME",
  "AVP_ALIASES", "LISTEN", "MEMGROUP", "ALIAS", "AUTO_ALIASES", "DNS",
  "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR", "DNS_RETR_TIME",
  "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH", "MAX_WHILE_LOOPS",
  "CHILDREN", "CHECK_VIA", "SHM_HASH_SPLIT_PERCENTAGE",
  "SHM_SECONDARY_HASH_SIZE", "MEM_WARMING_ENABLED",
  "MEM_WARMING_PATTERN_FILE", "MEM_WARMING_PERCENTAGE", "MEMLOG",
  "MEMDUMP", "EXECMSGTHRESHOLD", "EXECDNSTHRESHOLD", "TCPTHRESHOLD",
  "EVENT_SHM_THRESHOLD", "EVENT_PKG_THRESHOLD", "QUERYBUFFERSIZE",
  "QUERYFLUSHTIME", "SIP_WARNING", "SOCK_MODE", "SOCK_USER", "SOCK_GROUP",
  "UNIX_SOCK", "UNIX_SOCK_CHILDREN", "UNIX_TX_TIMEOUT", "SERVER_SIGNATURE",
  "SERVER_HEADER", "USER_AGENT_HEADER", "LOADMODULE", "MPATH", "MODPARAM",
  "MAXBUFFER", "CHROOT", "WDIR", "MHOMED", "POLL_METHOD",
  "TCP_ACCEPT_ALIASES", "TCP_CHILDREN", "TCP_CONNECT_TIMEOUT",
  "TCP_CON_LIFETIME", "TCP_LISTEN_BACKLOG", "TCP_MAX_CONNECTIONS",
  "TCP_NO_NEW_CONN_BFLAG", "TCP_KEEPALIVE", "TCP_KEEPCOUNT",
  "TCP_KEEPIDLE", "TCP_KEEPINTERVAL", "TCP_MAX_MSG_TIME",
  "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE", "OPEN_FD_LIMIT",
  "MCAST_LOOPBACK", "MCAST_TTL", "TOS", "DISABLE_DNS_FAILOVER",
  "DISABLE_DNS_BLACKLIST", "DST_BLACKLIST", "DISABLE_STATELESS_FWD",
  "DB_VERSION_TABLE", "DB_DEFAULT_URL", "DB_MAX_ASYNC_CONNECTIONS",
  "DISABLE_503_TRANSLATION", "SYNC_TOKEN", "ASYNC_TOKEN", "LAUNCH_TOKEN",
  "EQUAL", "EQUAL_T", "GT", "LT", "GTE", "LTE", "DIFF", "MATCH",
  "NOTMATCH", "COLONEQ", "PLUSEQ", "MINUSEQ", "SLASHEQ", "MULTEQ",
  "MODULOEQ", "BANDEQ", "BOREQ", "BXOREQ", "OR", "AND", "BOR", "BAND",
  "BXOR", "BLSHIFT", "BRSHIFT", "PLUS", "MINUS", "MULT", "MODULO", "NOT",
  "BNOT", "NUMBER", "ZERO", "ID", "STRING", "SCRIPTVAR", "IPV6ADDR",
  "IPV4ADDR", "IPNET", "COMMA", "SEMICOLON", "RPAREN", "LPAREN", "LBRACE",
  "RBRACE", "LBRACK", "RBRACK", "SLASH", "AS", "USE_CHILDREN", "DOT", "CR",
  "COLON", "ANY", "ANYCAST", "SCRIPTVARERR", "$accept", "cfg",
  "statements", "statement", "$@1", "$@2", "$@3", "$@4", "$@5", "$@6",
  "$@7", "$@8", "$@9", "listen_id", "proto", "port", "snumber",
  "phostport", "panyhostport", "alias_def", "id_lst", "listen_def",
  "any_proto", "multi_string", "blst_elem", "blst_elem_list", "assign_stm",
  "module_stm", "ip", "ipv4", "ipv6addr", "ipv6", "folded_string",
  "route_name", "route_stm", "failure_route_stm", "onreply_route_stm",
  "branch_route_stm", "error_route_stm", "local_route_stm",
  "startup_route_stm", "timer_route_stm", "event_route_stm", "exp",
  "equalop", "compop", "matchop", "intop", "strop", "script_var",
  "exp_elem", "exp_cond", "ipnet", "host_sep", "host", "assignop",
  "assignexp", "assign_cmd", "exp_stm", "stm", "actions", "action",
  "if_cmd", "while_cmd", "foreach_cmd", "switch_cmd", "switch_stm",
  "case_stms", "case_stm", "default_stm", "module_func_param",
  "route_param", "async_func", "cmd", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481
};
#endif

#define YYPACT_NINF (-916)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-371)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    4898,   -57,   -40,    -7,    27,   247,   271,   328,   334,   380,
     407,   416,   427,   433,   435,   441,   449,   466,   492,   504,
      47,    49,    50,    56,    57,    58,   508,   527,   531,   547,
     585,   625,   632,   647,   650,   651,   662,   670,   708,   715,
     730,   733,   734,   752,   753,   787,   788,    46,   794,    63,
     798,   814,   816,   817,   818,   819,   820,   821,   822,   823,
     824,   825,   826,   827,   828,   829,   830,   831,   832,   833,
     834,   835,   836,   840,    64,   151,   841,   842,   843,   844,
     845,   846,  -916,   215,  4731,  -916,   220,   505,   114,   534,
     616,   618,   637,   667,   897,  -916,  -916,  -916,    83,   106,
     107,   808,   205,   298,   207,   208,   298,   209,    52,   136,
     156,   813,     9,   211,   218,   221,  -916,   837,  -916,   838,
    -916,   847,  -916,   849,  -916,   850,  -916,   862,   223,   235,
     244,   282,   304,   322,   171,   326,   225,   237,   332,   387,
     390,   392,   393,   395,   411,   414,   434,   174,   175,  -916,
    -916,   176,  -916,   815,   437,   160,   170,   439,   173,   446,
     456,   458,   459,   460,   463,   200,   464,   469,   472,   474,
     475,    39,   476,   478,   479,   480,   481,   201,  -916,   864,
    -916,   865,   866,   867,   177,   178,   482,   484,  -916,   -57,
    -916,    18,  -916,    38,  -916,    23,  -916,    41,  -916,    44,
    -916,    48,  -916,    60,  -916,    43,  -916,    45,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,   869,   890,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -916,  1018,  -916,   799,   496,   801,  -916,
     800,  -916,   802,  -916,  -916,  -916,   861,   803,  -916,   804,
    -916,   364,  -916,  -916,  -916,  -916,  -916,  -143,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -916,   884,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,   805,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  4588,   445,  -916,   445,  -916,  4588,   445,  -916,
     445,  -916,  4588,  -916,  4588,  -916,  4588,  -916,   445,  -916,
     445,  -916,  -916,  -916,   417,   448,   893,   809,   894,   179,
     807,   448,   448,  -916,  -916,    99,   895,   908,   900,    67,
      71,   902,   904,   905,   915,    73,    75,    78,    79,    80,
      81,    84,    85,   916,   917,   924,    86,    89,    91,    93,
     934,    94,   935,   936,   937,   938,   939,  3420,   940,  3420,
     941,    97,    98,   100,   104,   108,   115,   116,   117,   118,
     119,   121,   122,   123,   962,   964,   965,   966,   969,   983,
     984,   985,   987,   988,   998,   999,  1000,  1006,  1007,  1010,
    1011,   124,  -916,  -916,  -916,   792,  1014,  1052,  -916,  -916,
    -916,  -916,  -916,   105,  -916,  -916,  -916,  1009,  1012,  1135,
    1013,  1015,  1348,  1431,  1644,  1017,   -74,   810,   811,   246,
    -916,  1026,  -916,  -916,  1028,  -916,  -916,   812,  -916,  -916,
    1021,  -144,  -916,   140,  -916,   180,  1022,  3420,  1023,   324,
    -916,   166,  -916,   181,  -916,   168,  -916,   182,  -916,   184,
    -916,   185,  -916,   485,  -916,   486,   -65,    -3,   -60,  -916,
     187,  -916,   190,  -916,   192,  -916,   193,  1024,  -916,   194,
    1025,  1027,  1029,  1030,   155,  3420,  3420,  3713,  3794,  -916,
    3501,   765,  -916,  -916,  -916,  -916,  -916,  -916,   -93,  3501,
     -93,  -916,    74,  -916,   164,  -916,   204,  -916,   487,  -916,
     127,  -916,   195,  -916,   196,  -916,  -142,  -916,   331,  -916,
     436,  -916,   455,  -916,   499,  -916,   515,  1033,  1035,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
     -93,   -44,  1050,  1050,  -916,   138,   970,   971,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  3794,  -916,  -916,  -916,
    -916,  -916,  -916,  1051,  1054,  -916,  1055,  1056,  -916,  -916,
    -916,  1053,   299,  1057,  -147,    28,  1058,  -147,  1037,  -916,
    -916,    51,   394,  1049,  -121,  -916,    62,  1060,  1061,  -916,
    1062,   512,  -916,   342,  -916,  -916,  1063,  1064,  1065,  1067,
    1070,  1069,  1072,  1071,   513,  1073,  1074,  1075,  1076,  1077,
    1078,  1079,  1080,  1081,  1082,   517,  -916,  1083,  1084,  1087,
    1088,  1089,  1090,  1091,  1094,  1095,  1096,  1097,  1098,  -916,
    1099,  1100,  -916,  -916,  -916,  -916,  1101,  1102,  -916,  -916,
    -123,  -916,  1727,  3794,  -916,  3794,  -916,   596,  -916,   346,
    -916,  3420,  3420,  4005,   990,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -916,   488,   341,  -916,   298,   351,  1103,
    -916,   991,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,
     518,  1112,  -916,  1113,  1114,  1115,  1116,  1117,  1118,  1119,
    1120,  1121,  1122,   521,  1123,   524,  1124,   528,  1125,   532,
    1128,  1130,  1132,  1133,  1134,  1137,  1138,   -50,   -42,   348,
     292,   533,  1150,  1152,  1153,  1154,  -916,   125,  1155,   536,
    1176,  -916,  -916,     2,  -916,   539,  -916,  -916,   736,  4588,
    4588,  4588,  4588,  1149,  1173,  1174,  4588,  -916,  -916,  -916,
    -916,  -916,  -916,   345,  1059,  -916,  -916,  1180,  1183,  -121,
    -916,  -916,  1157,  -916,  -144,  -916,  -916,  -916,  -916,  1140,
    -916,  1204,  -916,  -916,  -916,  -916,  1205,  -916,  1206,  -916,
     377,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  1208,  -916,  -916,  -916,  1209,  1219,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,   514,  3794,  3794,  3794,  3794,  3794,  3794,
    3794,  3794,  3794,  -916,  3794,  -916,  -916,  -916,  1940,  4086,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  1085,   -93,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  1223,  -916,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,  -916,
     548,  -916,  -916,   615,  -916,  -916,   630,  -916,  -916,  1221,
    -916,  1228,  1238,  1239,  1240,  1241,  1242,  1243,  -916,  -916,
    -916,  -916,  1244,  -916,  -916,   -93,  -916,  1245,  1266,   -93,
    1268,  -916,   149,   445,   445,  -916,  -916,  -916,  -916,   239,
    -916,  2023,  2236,  2319,  2532,  1086,  1260,  1261,  2615,  1276,
    1272,  -916,  -916,  -916,  1283,   483,  -916,  1282,  1284,  1285,
    1295,  -916,  -916,  -916,  -916,   641,  1296,  1297,  1303,  -916,
     412,   412,   412,   412,   412,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,   989,  1304,  1307,  1308,  1309,  1310,  1311,  1312,
    1313,  1314,  1317,  1318,  1319,  1320,  1321,  1323,   642,   388,
     402,   645,   646,  1324,  1325,   690,  1326,  -916,   705,  1327,
    1328,  -916,  -916,  -916,  -916,  -916,  -916,  4588,  4588,  4588,
    -916,  -916,  1333,   483,  1331,  -916,  -916,  -916,  -916,   379,
    -916,  -916,  -916,  -916,   430,  1315,   519,  -916,  4086,  -916,
    -916,  -916,  -916,  -916,  -916,  -916,  -916,  1337,   -93,   -93,
    -916,   296,   301,  1338,  -916,  -916,  -916,   -93,  -916,  1334,
    -916,  1339,  -916,  1340,  -916,  -916,  -916,  -916,  -916,  2828,
    2911,  3124,  -916,  1336,  -147,  -916,  -916,  -916,  -916,  1036,
    1330,  -916,  1332,  -916,  -916,  -916,   745,  1335,  1344,  1341,
    1347,  1350,  1351,  1346,  1352,  1353,  1356,  1355,  -916,  -916,
    -916,  -147,  1358,  4298,  4379,  4588,   323,  -916,  -916,  -916,
    1360,  1367,  1368,  1369,  -916,  -916,  -916,  1343,  -916,  1362,
    1345,  1364,   756,  1365,   839,  3207,  1361,  1366,   754,   758,
     771,   774,  1370,  1372,  1371,  -916,  1373,  -916,  1374,  -916,
    -916,   -93,  -916,   -93,  -916,   -93,  -916,   -93,  -916,  1376,
    1375,  -916,  -916,  -916,  1377,  1378,  1379,  1380,  1383,  -916,
    -916,  -916,  -916,  -916,   -93,  1382,  -916
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    26,     0,     0,     4,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     6,     7,   228,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    92,     0,    94,     0,
      96,     0,    98,     0,   100,     0,   102,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     229,     0,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   215,     0,
     217,     0,     0,     0,     0,     0,     0,     0,     1,     5,
       3,     0,     9,     0,    11,     0,    13,     0,    15,     0,
      17,     0,    19,     0,    21,     0,    23,     0,    25,   186,
     183,   187,   184,   188,   185,    73,    80,    79,     0,     0,
      33,    72,    76,    75,    78,    77,    74,    82,    81,    84,
      83,    86,    85,   190,     0,    30,     0,    51,    49,   189,
       0,   194,   301,    28,   237,   236,     0,     0,    42,     0,
      46,    47,   193,    27,   234,   238,   235,    29,   196,   195,
      88,    87,    90,    89,    91,    93,    95,    97,    99,   101,
     104,   103,   108,   107,   110,   109,   112,   111,   114,   113,
     116,   115,   118,   117,   120,   119,   122,   121,   124,   123,
     126,   125,   128,   127,   130,   129,   132,   131,   134,   133,
     136,   135,   138,   137,   140,   139,   178,   177,   180,   179,
     182,   181,   213,   212,     0,   106,   105,   143,   142,   141,
     146,   145,   144,   148,   147,   151,   149,   150,   153,   152,
     155,   154,   157,   156,   159,   158,   161,   160,   163,   162,
     166,   164,   165,   168,   167,   172,   171,   174,   173,   176,
     175,   170,   169,   198,   301,   197,   200,   199,   202,   201,
     204,   203,   206,   205,   208,   207,   211,   209,   210,   214,
     216,     0,   219,   221,   220,   223,   222,   225,   224,   227,
     226,   247,     0,     0,   249,     0,   252,     0,     0,   254,
       0,   256,     0,   258,     0,   260,     0,   262,     0,   266,
       0,    34,    35,    39,     0,     0,     0,    52,     0,     0,
       0,     0,     0,    48,   300,     0,     0,     0,     0,     0,
       0,   402,     0,   404,   408,     0,     0,     0,     0,     0,
       0,     0,     0,   459,     0,     0,     0,     0,     0,     0,
     480,     0,   485,   487,   489,   491,   494,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   286,   351,   287,     0,     0,     0,   343,   346,
     347,   348,   349,     0,   243,   242,   244,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    40,    36,    55,
      53,     0,    50,   192,    65,   191,   239,    43,   303,   302,
       0,     0,   394,     0,   398,     0,     0,     0,     0,     0,
     411,     0,   438,     0,   442,     0,   445,     0,   465,     0,
     448,     0,   454,     0,   451,     0,     0,     0,     0,   471,
       0,   474,     0,   468,     0,   477,     0,     0,   482,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   290,
       0,   291,   272,   288,   336,   289,   335,   334,     0,     0,
       0,   498,     0,   502,     0,   505,     0,   509,     0,   512,
       0,   515,     0,   518,     0,   415,     0,   418,     0,   421,
       0,   426,     0,   431,     0,   436,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   538,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,     0,   350,   344,   245,
     342,   352,   345,     0,     0,   250,     0,     0,   255,   257,
     259,     0,     0,     0,     0,     0,     0,     0,    56,    54,
      66,     0,     0,     0,     0,    70,     0,     0,     0,   393,
       0,     0,   401,     0,   403,   407,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   458,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   479,
       0,     0,   484,   486,   488,   490,     0,     0,   493,   269,
       0,   338,     0,     0,   315,     0,   314,   316,   317,     0,
     318,     0,     0,     0,   353,   339,   273,   275,   276,   277,
     278,   274,   279,   280,   281,   282,   285,     0,     0,     0,
     355,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   510,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   552,     0,     0,     0,
       0,   377,   372,   374,   535,     0,   332,   333,   331,     0,
       0,     0,     0,     0,     0,     0,     0,    31,    32,    41,
      38,    37,    57,    59,     0,    45,    44,     0,     0,     0,
      63,    64,     0,    71,     0,   218,   395,   392,   399,     0,
     396,     0,   405,   406,   412,   409,     0,   439,     0,   443,
       0,   440,   446,   444,   466,   464,   449,   447,   455,   453,
     452,   450,     0,   457,   460,   461,     0,     0,   472,   470,
     475,   473,   469,   467,   478,   476,   483,   481,   495,   492,
     270,   337,   329,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   271,     0,   268,   267,   341,     0,     0,
     295,   297,   298,   296,   294,   293,   292,     0,     0,   497,
     496,   501,   499,   500,   504,   503,   508,     0,   506,   511,
     514,   513,   517,   516,   413,   414,   416,   417,   419,   420,
       0,   424,   425,     0,   429,   430,     0,   434,   435,     0,
     558,     0,     0,     0,     0,     0,     0,     0,   240,   539,
     241,   540,     0,   541,   542,     0,   545,     0,     0,     0,
       0,   391,     0,     0,     0,   557,   537,   378,   375,   376,
     536,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      60,    58,   231,   232,     0,     0,    69,     0,     0,     0,
       0,   382,   380,   381,   383,     0,     0,     0,     0,   330,
     325,   324,   326,   327,   328,   319,   320,   321,   323,   322,
     340,   354,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   388,     0,     0,
       0,   379,   373,   246,   248,   251,   253,     0,     0,     0,
     263,    61,     0,     0,     0,   397,   400,   410,   437,     0,
     441,   456,   462,   463,     0,     0,   359,   361,     0,   507,
     422,   423,   427,   428,   432,   433,   559,     0,     0,     0,
     522,     0,     0,     0,   534,   543,   544,     0,   546,     0,
     548,     0,   551,     0,   553,   390,   389,   555,   556,     0,
       0,     0,    62,     0,     0,   387,   384,   385,   386,     0,
       0,   357,     0,   360,   358,   356,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   261,   264,
     265,     0,     0,   369,   365,   371,     0,   519,   523,   524,
       0,     0,     0,     0,   533,   547,   549,     0,   554,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   367,     0,   363,     0,   520,
     521,     0,   525,     0,   526,     0,   529,     0,   530,     0,
       0,    67,   366,   362,     0,     0,     0,     0,     0,    68,
     527,   528,   531,   532,     0,     0,   550
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -916,  -916,  -916,   948,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -163,  -109,  -630,  -103,  -108,  -916,  -916,
     790,  -916,   213,   530,   212,  -916,  -916,  -916,  -735,  -916,
    1020,  -916,  -610,  -362,  -916,  -916,  -916,  -916,  -916,  -916,
    -916,  -916,  -916,  -431,  -916,  -916,  -916,  -916,  -916,  -436,
    -916,  -417,  -915,  -916,  -916,  -916,  -621,  -412,  -916,  -575,
    -380,  -482,  -406,  -916,  -916,  -916,  -916,  -916,   -19,  -916,
     302,  -916,   425,  -376
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,   248,   249,   819,   726,   250,   238,   251,
     252,   239,   832,   515,   665,   666,    95,    96,   253,   254,
     255,   256,   788,   497,   192,   194,   196,   198,   200,   202,
     204,   206,   208,   570,   744,   745,   746,   747,   748,   485,
     572,   728,   903,   416,   257,   636,   729,   486,   575,   734,
     487,   488,   489,   490,   491,   492,  1065,  1066,  1067,  1114,
     805,   995,   798,   493
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     221,   236,   237,   226,   750,   640,   790,   499,   355,   902,
     241,   571,   502,   571,   503,   808,   504,   640,   579,   381,
     640,   640,   640,   498,   386,   821,   500,   823,   501,   820,
     573,   826,   573,   287,   289,   574,   505,   574,   506,   384,
     353,   576,   389,   576,   397,   391,   399,   149,   116,   393,
     118,   120,   825,   229,   414,   817,   663,   122,   124,   126,
     767,   395,   768,   833,   152,   178,   731,   732,   522,   664,
    1054,   577,   524,   577,   530,   752,   532,   818,   415,   534,
     536,   538,   540,   235,   209,   542,   544,   549,   735,   880,
     551,   571,   553,   677,   555,   558,   673,   735,   581,   583,
     518,   585,   882,   830,   883,   587,   641,   211,   213,   589,
     573,   698,   700,   482,    97,   574,   591,   593,   595,   597,
     599,   576,   601,   603,   605,   624,   961,   195,   761,   571,
     571,    98,   727,   484,   719,   720,   652,   231,  1103,   800,
     695,   667,   749,   653,   751,   699,   482,   696,   573,   573,
    1036,   577,   180,   574,   574,   948,   716,   233,   795,   576,
     576,   317,   949,   950,    99,   754,   484,   678,   796,   683,
     951,   320,   282,   684,   325,   308,   310,   312,   373,   375,
     513,   670,   681,   685,   794,   687,   689,   722,   701,   577,
     577,   703,   730,   705,   707,   710,   763,   765,   100,   697,
     727,   340,   366,   482,   967,   757,   216,   968,   222,   224,
     227,   234,   258,   242,   243,   188,   244,   245,   117,   260,
     119,   121,   262,   484,   270,   246,   286,   123,   125,   127,
     817,   191,   382,   247,   383,   179,   272,   387,   288,   388,
     640,   508,   509,   354,   243,   274,   244,   245,   517,   508,
     902,   150,   818,   817,   385,   246,   230,   390,   392,   398,
     730,   400,   394,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,   834,  1009,   396,   818,   153,   835,   354,   243,
     523,   244,   245,   276,   525,   210,   531,   727,   533,   727,
     246,   535,   537,   539,   541,   571,   571,   543,   545,   550,
     895,   896,   552,  -299,   554,   278,   556,   559,   212,   214,
     582,   584,   906,   586,   573,   573,   642,   588,   902,   574,
     574,   590,   181,   280,  1011,   576,   576,   284,   592,   594,
     596,   598,   600,   290,   602,   604,   606,   625,   962,   762,
     801,   232,  1030,   802,   569,   668,   569,   730,   803,   730,
     804,   801,   669,   898,   802,   577,   577,   717,   234,   803,
     235,  1037,   218,   219,   318,   319,   755,   718,   220,   756,
     494,   679,   495,   496,   321,   322,   283,   326,   327,   309,
     311,   313,   374,   376,   514,   671,   682,   686,   292,   688,
     690,   294,   702,   296,   298,   704,   300,   706,   708,   711,
     764,   766,   341,   367,   342,   368,   234,   217,   235,   223,
     225,   228,   302,   259,   994,   304,   640,   735,   101,   753,
     261,   218,   219,   263,   569,   271,   676,   220,   680,   971,
     972,   973,   974,   218,   219,   306,   978,   273,   315,   220,
     323,  1041,   102,   991,  1042,  1105,   275,   328,   727,   727,
     727,   727,   727,   727,   727,   727,   727,   330,   727,   332,
     334,   336,   569,   569,   338,   343,   656,   814,   815,   657,
     345,   658,  1013,   347,  1132,   349,   351,   356,   758,   358,
     360,   362,   364,   377,   277,   379,   691,   693,   759,   640,
     640,   640,   640,  1115,   218,   219,   640,   950,  1119,   103,
     220,  1149,   482,  1121,   954,   104,   279,   482,   730,   730,
     730,   730,   730,   730,   730,   730,   730,   193,   730,  1031,
     218,   219,   484,  1034,   281,  1156,   220,   484,   285,   482,
     482,   731,   732,   769,   291,   770,   675,   884,   885,   886,
     887,   888,   889,   890,   891,   892,  -284,  -284,   197,   484,
     484,   105,   841,   948,   900,   831,   905,   482,   952,   828,
     953,  1064,  1112,   893,   894,   979,   234,  -284,   242,   243,
     980,   244,   245,   218,   219,   218,   219,   484,   106,   220,
     246,   220,   992,   482,  1106,   482,   735,   107,   247,   293,
     218,   219,   295,   948,   297,   299,   220,   301,   108,   827,
    1085,  1039,  1040,   484,   109,   484,   110,   950,   889,   890,
     891,   892,   111,   303,  1086,   507,   305,   640,   640,   640,
     112,   354,   243,  1108,   244,   245,   218,   219,   569,   569,
     894,   199,   220,   246,   201,  1109,   307,   113,   771,   316,
     772,   324,  1117,  1118,   904,  1120,  1122,   494,   329,   495,
     496,  1124,   354,   243,   203,   244,   245,   773,   331,   774,
     333,   335,   337,   114,   246,   339,   344,  1099,  1100,  1101,
     640,   346,   640,   640,   348,   115,   350,   352,   357,   128,
     359,   361,   363,   365,   378,   205,   380,   692,   694,   760,
     244,   245,   901,  -283,  -283,   244,   245,   901,   129,   246,
    1157,   775,   130,   776,   246,   884,   885,   886,   887,   888,
     889,   890,   891,   892,  -283,   405,   406,   777,   131,   778,
     831,   407,   839,   850,   840,   851,   999,   862,   917,   863,
     918,   930,   894,   931,   933,  1184,   934,  1185,   936,  1186,
     937,  1187,   939,   955,   940,   956,   964,   993,   965,   969,
    1015,   970,  1016,  1152,  1154,  1155,   132,   638,  1195,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   736,   737,
     738,   739,   740,   741,   742,   743,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   133,   448,  -368,  -368,
    1166,   449,   450,   134,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,  1017,   135,  1018,
     464,   136,   137,   465,   466,   467,   468,   469,   470,   471,
     472,   473,  1019,   138,  1020,   474,   475,   476,   477,   478,
     638,   139,   419,   420,   421,   422,   423,   424,   425,   426,
     427,  1059,  1083,  1060,  1084,  1087,  1089,  1088,  1090,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   140,
     448,  -364,  -364,  1168,   449,   450,   141,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
    1093,   142,  1094,   464,   143,   144,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   969,   207,  1096,   474,   475,
     476,   477,   478,   145,   146,   479,   480,   884,   885,   886,
     887,   888,   889,   890,   891,   892,   626,   736,   737,   738,
     739,   740,   741,   742,   743,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   894,  1136,  1107,  1137,   147,   148,
     481,  1110,   482,   626,  1171,   151,  1172,   483,  1173,   154,
    1174,  -368,   627,   628,   629,   630,   631,   632,   633,   634,
     635,  1175,   484,  1176,  1177,   155,  1178,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   479,   480,
     215,   177,   182,   183,   184,   185,   186,   187,   240,   403,
     314,   408,   404,   409,   516,   -30,   411,   412,   418,   511,
     899,  1064,   190,   654,   655,   661,   806,   807,   908,   264,
     265,   413,   984,   481,   660,   482,   986,  1113,   799,   266,
     483,   267,   268,   638,  -364,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   269,   484,   369,   370,   244,   372,
     371,   401,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   402,   448,   417,   510,   512,   449,   450,   519,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   520,   521,   526,   464,   527,   528,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   529,   546,
     547,   474,   475,   476,   477,   478,   638,   548,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   557,   560,   561,
     562,   563,   564,   578,   580,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   607,   448,   608,   609,   610,
     449,   450,   611,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   612,   613,   614,   464,
     615,   616,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   617,   618,   619,   474,   475,   476,   477,   478,   620,
     621,   479,   480,   622,   623,   637,   643,   651,   659,   644,
     646,   662,   647,   514,   672,   674,   709,   712,   779,   713,
     780,   714,   715,   781,   782,   783,   784,   785,   786,   787,
     789,   791,   792,   793,   797,   813,   481,   824,   482,  1133,
     822,   981,   829,   483,  1038,   809,   410,   639,   810,   811,
     812,   816,   836,   837,   838,   842,   843,   844,   484,   845,
     846,   847,   848,   849,     0,   852,   853,   854,   855,   856,
     857,   858,   859,   860,   861,   864,   865,   866,   867,  1012,
    1047,   868,   869,   870,   479,   480,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   907,   909,   910,   911,   912,
     913,   914,   915,   916,   919,   920,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   932,   935,   938,   941,   481,
     942,   482,   943,   944,   945,   987,   483,   946,   947,   638,
     645,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     957,   484,   958,   959,   960,   963,   975,   985,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   966,   448,
     976,   977,   982,   449,   450,   983,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   988,
     989,   990,   464,   996,   997,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   998,  1014,  1021,   474,   475,   476,
     477,   478,   638,  1022,   419,   420,   421,   422,   423,   424,
     425,   426,   427,  1023,  1024,  1025,  1026,  1027,  1028,  1029,
    1032,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,  1033,   448,  1035,  1048,  1049,   449,   450,  1051,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,  1052,  1053,  1055,   464,  1056,  1057,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1058,  1061,  1062,
     474,   475,   476,   477,   478,  1063,  1068,   479,   480,  1069,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,
    1111,  1081,  1080,  1082,  1091,  1102,  1125,  1092,  1095,  1097,
    1098,  1104,  1116,  1123,  1126,  1127,  1131,  1138,  1162,     0,
    1164,  1140,   481,  1134,   482,  1135,  1139,  1141,  1144,   483,
    1142,  1143,  1158,   648,  1145,  1146,  1147,  1148,  1150,  1159,
    1160,  1161,  1163,  1169,   484,  1165,  1167,  1180,  1170,     0,
    1179,  1188,     0,  1181,  1182,  1183,     0,  1189,     0,  1190,
    1191,  1192,  1193,  1194,  1196,     0,     0,     0,     0,     0,
     479,   480,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   481,     0,   482,     0,     0,
       0,     0,   483,     0,     0,   638,   649,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   484,     0,     0,
       0,     0,     0,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,     0,     0,     0,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,     0,     0,     0,   464,     0,
       0,   465,   466,   467,   468,   469,   470,   471,   472,   473,
       0,     0,     0,   474,   475,   476,   477,   478,   638,     0,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,     0,
       0,     0,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,     0,     0,
       0,   464,     0,     0,   465,   466,   467,   468,   469,   470,
     471,   472,   473,     0,     0,     0,   474,   475,   476,   477,
     478,     0,     0,   479,   480,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   481,     0,
     482,     0,     0,     0,     0,   483,     0,     0,     0,   650,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     484,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   479,   480,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   481,     0,   482,     0,     0,     0,     0,   483,     0,
       0,   638,   881,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   484,     0,     0,     0,     0,     0,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
       0,   448,     0,     0,     0,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,     0,     0,     0,   464,     0,     0,   465,   466,   467,
     468,   469,   470,   471,   472,   473,     0,     0,     0,   474,
     475,   476,   477,   478,   638,     0,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,     0,     0,     0,     0,
       0,     0,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   448,     0,     0,     0,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,     0,     0,     0,   464,     0,     0,
     465,   466,   467,   468,   469,   470,   471,   472,   473,     0,
       0,     0,   474,   475,   476,   477,   478,     0,     0,   479,
     480,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   481,     0,   482,     0,     0,     0,
       0,   483,     0,     0,     0,  1010,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   484,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   479,   480,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   481,     0,   482,
       0,     0,     0,     0,   483,     0,     0,   638,  1043,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   484,
       0,     0,     0,     0,     0,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,     0,     0,
       0,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,     0,     0,     0,
     464,     0,     0,   465,   466,   467,   468,   469,   470,   471,
     472,   473,     0,     0,     0,   474,   475,   476,   477,   478,
     638,     0,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,     0,     0,     0,     0,     0,     0,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,     0,     0,     0,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
       0,     0,     0,   464,     0,     0,   465,   466,   467,   468,
     469,   470,   471,   472,   473,     0,     0,     0,   474,   475,
     476,   477,   478,     0,     0,   479,   480,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     481,     0,   482,     0,     0,     0,     0,   483,     0,     0,
       0,  1044,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   484,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   479,   480,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   481,     0,   482,     0,     0,     0,     0,
     483,     0,     0,   638,  1045,   419,   420,   421,   422,   423,
     424,   425,   426,   427,     0,   484,     0,     0,     0,     0,
       0,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,     0,   448,     0,     0,     0,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,     0,     0,     0,   464,     0,     0,   465,
     466,   467,   468,   469,   470,   471,   472,   473,     0,     0,
       0,   474,   475,   476,   477,   478,   638,     0,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,     0,     0,
       0,     0,     0,     0,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,     0,   448,     0,     0,     0,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,     0,     0,     0,   464,
       0,     0,   465,   466,   467,   468,   469,   470,   471,   472,
     473,     0,     0,     0,   474,   475,   476,   477,   478,     0,
       0,   479,   480,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   481,     0,   482,     0,
       0,     0,     0,   483,     0,     0,     0,  1046,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   484,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   479,   480,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   481,
       0,   482,     0,     0,     0,     0,   483,     0,     0,   638,
    1050,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   484,     0,     0,     0,     0,     0,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
       0,     0,     0,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,     0,
       0,     0,   464,     0,     0,   465,   466,   467,   468,   469,
     470,   471,   472,   473,     0,     0,     0,   474,   475,   476,
     477,   478,   638,     0,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,     0,     0,     0,     0,     0,     0,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,     0,   448,     0,     0,     0,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,     0,     0,     0,   464,     0,     0,   465,   466,
     467,   468,   469,   470,   471,   472,   473,     0,     0,     0,
     474,   475,   476,   477,   478,     0,     0,   479,   480,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   481,     0,   482,     0,     0,     0,     0,   483,
       0,     0,     0,  1128,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   484,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     479,   480,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   481,     0,   482,     0,     0,
       0,     0,   483,     0,     0,   638,  1129,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   484,     0,     0,
       0,     0,     0,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,     0,     0,     0,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,     0,     0,     0,   464,     0,
       0,   465,   466,   467,   468,   469,   470,   471,   472,   473,
       0,     0,     0,   474,   475,   476,   477,   478,   638,     0,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,     0,
       0,     0,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,     0,     0,
       0,   464,     0,     0,   465,   466,   467,   468,   469,   470,
     471,   472,   473,     0,     0,     0,   474,   475,   476,   477,
     478,     0,     0,   479,   480,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   481,     0,
     482,     0,     0,     0,     0,   483,     0,     0,     0,  1130,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     484,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   479,   480,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   481,     0,   482,     0,     0,     0,     0,   483,     0,
       0,     0,  -370,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   484,     0,     0,     0,     0,     0,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
       0,     0,     0,     0,     0,     0,     0,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,     0,     0,     0,   464,     0,     0,   465,   466,   467,
     468,   469,   470,   471,   472,   473,     0,     0,     0,   474,
     475,   476,   477,   478,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,     0,     0,     0,     0,     0,     0,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,     0,   448,     0,     0,     0,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,     0,     0,     0,   464,     0,     0,   465,   466,
     467,   468,   469,   470,   471,   472,   473,     0,     0,     0,
     474,   475,   476,   477,   478,     0,     0,     0,     0,   479,
     480,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   218,   219,     0,     0,
     565,     0,   220,     0,   481,     0,   482,     0,     0,     0,
       0,     0,     0,   566,   567,     0,   568,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   484,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     479,   480,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     731,   732,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   481,     0,   482,     0,     0,
       0,     0,   483,     0,     0,   733,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,     0,   484,     0,     0,
       0,     0,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   448,     0,     0,     0,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,     0,     0,     0,   464,     0,     0,
     465,   466,   467,   468,   469,   470,   471,   472,   473,     0,
       0,     0,   474,   475,   476,   477,   478,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,     0,     0,     0,   464,     0,
       0,   465,   466,   467,   468,   469,   470,   471,   472,   473,
       0,     0,     0,   474,   475,   476,   477,   478,     0,     0,
       0,     0,   479,   480,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   481,     0,   482,
       0,     0,     0,     0,   483,     0,     0,     0,   721,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   484,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   479,   480,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     218,   219,     0,     0,     0,   723,   220,     0,   481,   724,
     482,     0,     0,     0,     0,     0,     0,   725,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,     0,     0,
     484,     0,     0,     0,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,     0,   448,     0,     0,     0,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,     0,     0,     0,   464,
       0,     0,   465,   466,   467,   468,   469,   470,   471,   472,
     473,     0,     0,     0,   474,   475,   476,   477,   478,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,     0,
       0,     0,     0,     0,     0,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,     0,     0,
       0,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,     0,     0,     0,
     464,     0,     0,   465,   466,   467,   468,   469,   470,   471,
     472,   473,     0,     0,     0,   474,   475,   476,   477,   478,
       0,     0,     0,     0,   479,   480,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   481,
       0,   482,     0,     0,     0,     0,   483,     0,     0,     0,
     897,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   484,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   479,   480,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     481,     0,   482,     0,     0,     0,     0,   483,     0,     0,
     733,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,     0,   484,     0,     0,     0,     0,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
       0,     0,  1151,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,     0,
       0,     0,   464,     0,     0,   465,   466,   467,   468,   469,
     470,   471,   472,   473,     0,     0,     0,   474,   475,   476,
     477,   478,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,     0,     0,     0,     0,     0,     0,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,     0,     0,  1153,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
       0,     0,     0,   464,     0,     0,   465,   466,   467,   468,
     469,   470,   471,   472,   473,     0,     0,     0,   474,   475,
     476,   477,   478,     0,     0,     0,     0,   479,   480,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   481,     0,   482,     0,     0,     0,     0,   483,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   484,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   479,   480,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   481,     0,   482,     0,     0,     0,     0,
     483,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,     0,     0,     0,     0,   484,     0,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
       0,     0,     0,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,     0,
       0,     0,   464,     0,     0,   465,   466,   467,   468,   469,
     470,   471,   472,   473,     0,     0,     0,   474,   475,   476,
     477,   478,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    -2,   189,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    -8,   -10,   -12,   -14,   -16,   -18,   -20,   -22,
     -24,     0,     0,     0,     0,     0,     0,   479,   480,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   481,     0,   482,     0,     0,     0,     0,   483,
       0,     0,     0,     0,     0,     0,     0,     2,     3,     4,
       0,     0,     0,     0,   484,     5,     6,     7,     8,     9,
      10,    11,    12,    13,     0,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,     0,     0,     0,     0,     0,
       0,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,     1,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    -8,
     -10,   -12,   -14,   -16,   -18,   -20,   -22,   -24,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     2,     3,     4,     0,     0,     0,
       0,     0,     5,     6,     7,     8,     9,    10,    11,    12,
      13,     0,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,     0,     0,     0,     0,     0,     0,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82
};

static const yytype_int16 yycheck[] =
{
     103,   110,   110,   106,   579,   487,   616,   387,   171,   744,
       1,   447,   392,   449,   394,   636,   396,   499,   449,     1,
     502,   503,   504,   385,     1,   655,   388,   657,   390,     1,
     447,   661,   449,   136,   137,   447,   398,   449,   400,     1,
       1,   447,     1,   449,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,   197,   202,   200,     1,     1,     1,
     202,     1,   204,     1,     1,     1,   189,   190,     1,   213,
     985,   447,     1,   449,     1,     1,     1,   224,   221,     1,
       1,     1,     1,   204,     1,     1,     1,     1,   570,   212,
       1,   527,     1,   529,     1,     1,   527,   579,     1,     1,
       1,     1,   723,   224,   725,     1,     1,     1,     1,     1,
     527,   547,   548,   206,   171,   527,     1,     1,     1,     1,
       1,   527,     1,     1,     1,     1,     1,    13,     1,   565,
     566,   171,   568,   226,   565,   566,   210,     1,  1053,     1,
     205,     1,   578,   217,   580,   205,   206,   212,   565,   566,
       1,   527,     1,   565,   566,   205,     1,     1,   202,   565,
     566,     1,   212,   205,   171,     1,   226,     1,   212,     1,
     212,     1,     1,   535,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,   620,     1,     1,   567,     1,   565,
     566,     1,   568,     1,     1,     1,     1,     1,   171,   202,
     636,     1,     1,   206,   202,     1,     1,   205,     1,     1,
       1,   202,     1,   204,   205,     0,   207,   208,   171,     1,
     171,   171,     1,   226,     1,   216,     1,   171,   171,   171,
     202,    11,   214,   224,   216,   171,     1,   214,     1,   216,
     722,   404,   405,   204,   205,     1,   207,   208,   411,   412,
     985,   205,   224,   202,   216,   216,   204,   216,   214,   216,
     636,   216,   214,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   210,   894,   214,   224,   213,   215,   204,   205,
     213,   207,   208,     1,   213,   202,   213,   723,   213,   725,
     216,   213,   213,   213,   213,   731,   732,   213,   213,   213,
     731,   732,   213,   204,   213,     1,   213,   213,   202,   202,
     213,   213,   748,   213,   731,   732,   211,   213,  1053,   731,
     732,   213,   171,     1,   899,   731,   732,     1,   213,   213,
     213,   213,   213,     1,   213,   213,   213,   213,   213,   212,
     202,   205,   952,   205,   447,   205,   449,   723,   210,   725,
     212,   202,   212,   733,   205,   731,   732,   202,   202,   210,
     204,   212,   196,   197,   204,   205,   202,   212,   202,   205,
     202,   205,   204,   205,   204,   205,   205,   204,   205,   205,
     205,   205,   205,   205,   205,   205,   205,   205,     1,   205,
     205,     1,   205,     1,     1,   205,     1,   205,   205,   205,
     205,   205,   202,   202,   204,   204,   202,   202,   204,   202,
     202,   202,     1,   202,   850,     1,   898,   899,   171,   582,
     202,   196,   197,   202,   527,   202,   529,   202,   531,   809,
     810,   811,   812,   196,   197,     1,   816,   202,     1,   202,
       1,   202,   171,    66,   205,    66,   202,     1,   884,   885,
     886,   887,   888,   889,   890,   891,   892,     1,   894,     1,
       1,     1,   565,   566,     1,     1,   220,   168,   169,   223,
       1,   225,   908,     1,  1104,     1,     1,     1,   586,     1,
       1,     1,     1,     1,   202,     1,     1,     1,     1,   971,
     972,   973,   974,  1068,   196,   197,   978,   205,   202,   171,
     202,  1131,   206,   202,   212,   171,   202,   206,   884,   885,
     886,   887,   888,   889,   890,   891,   892,    12,   894,   955,
     196,   197,   226,   959,   202,   202,   202,   226,   202,   206,
     206,   189,   190,   202,   202,   204,   212,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   205,   206,    14,   226,
     226,   171,   210,   205,    66,   664,   205,   206,   210,   662,
     212,    42,    43,   217,   218,   220,   202,   226,   204,   205,
     225,   207,   208,   196,   197,   196,   197,   226,   171,   202,
     216,   202,   205,   206,   205,   206,  1068,   171,   224,   202,
     196,   197,   202,   205,   202,   202,   202,   202,   171,   205,
     212,   963,   964,   226,   171,   226,   171,   205,   196,   197,
     198,   199,   171,   202,   212,   198,   202,  1099,  1100,  1101,
     171,   204,   205,  1059,   207,   208,   196,   197,   731,   732,
     218,    15,   202,   216,    16,   205,   202,   171,   202,   202,
     204,   202,  1078,  1079,   747,  1081,  1082,   202,   202,   204,
     205,  1087,   204,   205,    17,   207,   208,   202,   202,   204,
     202,   202,   202,   171,   216,   202,   202,  1047,  1048,  1049,
    1152,   202,  1154,  1155,   202,   171,   202,   202,   202,   171,
     202,   202,   202,   202,   202,    18,   202,   202,   202,   202,
     207,   208,   209,   205,   206,   207,   208,   209,   171,   216,
    1136,   202,   171,   204,   216,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   226,   219,   220,   202,   171,   204,
     829,   225,   210,   210,   212,   212,   212,   210,   210,   212,
     212,   210,   218,   212,   210,  1171,   212,  1173,   210,  1175,
     212,  1177,   210,   210,   212,   212,   210,   850,   212,   210,
     202,   212,   204,  1133,  1134,  1135,   171,     1,  1194,     3,
       4,     5,     6,     7,     8,     9,    10,    11,   172,   173,
     174,   175,   176,   177,   178,   179,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,   171,    41,    42,    43,
      44,    45,    46,   171,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,   202,   171,   204,
      64,   171,   171,    67,    68,    69,    70,    71,    72,    73,
      74,    75,   202,   171,   204,    79,    80,    81,    82,    83,
       1,   171,     3,     4,     5,     6,     7,     8,     9,    10,
      11,   210,   210,   212,   212,   210,   210,   212,   212,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,   171,
      41,    42,    43,    44,    45,    46,   171,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
     210,   171,   212,    64,   171,   171,    67,    68,    69,    70,
      71,    72,    73,    74,    75,   210,    19,   212,    79,    80,
      81,    82,    83,   171,   171,   169,   170,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   218,   210,  1059,   212,   171,   171,
     204,  1064,   206,   171,   210,   171,   212,   211,   210,   171,
     212,   215,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   210,   226,   212,   210,   171,   212,   171,   171,   171,
     171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   171,   171,   171,   171,   171,   171,   171,   169,   170,
     202,   171,   171,   171,   171,   171,   171,   171,   205,     1,
     205,   220,   223,   223,   217,   223,   223,   223,   223,   220,
      40,    42,    84,   223,   223,   223,    66,    66,    47,   202,
     202,   251,   829,   204,   514,   206,   834,  1066,   623,   202,
     211,   202,   202,     1,   215,     3,     4,     5,     6,     7,
       8,     9,    10,    11,   202,   226,   202,   202,   207,   202,
     204,   202,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,   202,    41,   210,   202,   202,    45,    46,   204,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,   205,   214,   213,    64,   213,   213,    67,
      68,    69,    70,    71,    72,    73,    74,    75,   213,   213,
     213,    79,    80,    81,    82,    83,     1,   213,     3,     4,
       5,     6,     7,     8,     9,    10,    11,   213,   213,   213,
     213,   213,   213,   213,   213,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,   213,    41,   213,   213,   213,
      45,    46,   213,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,   213,   213,   213,    64,
     213,   213,    67,    68,    69,    70,    71,    72,    73,    74,
      75,   213,   213,   213,    79,    80,    81,    82,    83,   213,
     213,   169,   170,   213,   213,   211,   217,   210,   202,   217,
     217,   210,   217,   205,   212,   212,   212,   212,   205,   212,
     205,   212,   212,   205,   205,   205,   205,   205,   205,   205,
     205,   205,   205,   205,   204,   202,   204,   220,   206,   223,
     202,   202,   213,   211,   962,   214,   246,   215,   214,   214,
     214,   214,   212,   212,   212,   212,   212,   212,   226,   212,
     210,   212,   210,   212,    -1,   212,   212,   212,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   210,   210,   214,
     214,   212,   212,   212,   169,   170,   212,   212,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   212,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   212,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   212,   210,   204,
     210,   206,   210,   210,   210,   205,   211,   210,   210,     1,
     215,     3,     4,     5,     6,     7,     8,     9,    10,    11,
     210,   226,   210,   210,   210,   210,   217,   210,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,   212,    41,
     217,   217,   212,    45,    46,   212,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,   205,
     205,   205,    64,   205,   205,    67,    68,    69,    70,    71,
      72,    73,    74,    75,   205,   202,   205,    79,    80,    81,
      82,    83,     1,   205,     3,     4,     5,     6,     7,     8,
       9,    10,    11,   205,   205,   205,   205,   205,   205,   205,
     205,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,   205,    41,   205,   214,   214,    45,    46,   202,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,   220,   210,   212,    64,   212,   212,    67,    68,
      69,    70,    71,    72,    73,    74,    75,   212,   212,   212,
      79,    80,    81,    82,    83,   212,   212,   169,   170,   212,
     212,   212,   212,   212,   212,   212,   212,   210,   210,   210,
     215,   210,   212,   210,   210,   202,   202,   212,   212,   212,
     212,   210,   205,   205,   205,   205,   210,   212,   205,    -1,
     205,   210,   204,   223,   206,   223,   212,   210,   212,   211,
     210,   210,   202,   215,   212,   212,   210,   212,   210,   202,
     202,   202,   210,   212,   226,   211,   211,   205,   212,    -1,
     210,   205,    -1,   212,   211,   211,    -1,   212,    -1,   212,
     212,   212,   212,   210,   212,    -1,    -1,    -1,    -1,    -1,
     169,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   204,    -1,   206,    -1,    -1,
      -1,    -1,   211,    -1,    -1,     1,   215,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    -1,   226,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    -1,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    -1,    -1,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    79,    80,    81,    82,    83,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      -1,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      -1,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    -1,    -1,   169,   170,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   204,    -1,
     206,    -1,    -1,    -1,    -1,   211,    -1,    -1,    -1,   215,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,   170,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   204,    -1,   206,    -1,    -1,    -1,    -1,   211,    -1,
      -1,     1,   215,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    -1,   226,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    -1,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    -1,    -1,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79,
      80,    81,    82,    83,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    -1,    -1,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,    -1,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    80,    81,    82,    83,    -1,    -1,   169,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   204,    -1,   206,    -1,    -1,    -1,
      -1,   211,    -1,    -1,    -1,   215,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   226,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,   170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   204,    -1,   206,
      -1,    -1,    -1,    -1,   211,    -1,    -1,     1,   215,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    -1,   226,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    -1,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    -1,    -1,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    79,    80,    81,    82,    83,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    -1,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    -1,    -1,    64,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    -1,    -1,   169,   170,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     204,    -1,   206,    -1,    -1,    -1,    -1,   211,    -1,    -1,
      -1,   215,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,   170,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   204,    -1,   206,    -1,    -1,    -1,    -1,
     211,    -1,    -1,     1,   215,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    -1,   226,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    -1,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    79,    80,    81,    82,    83,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    -1,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    -1,    -1,    79,    80,    81,    82,    83,    -1,
      -1,   169,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   204,    -1,   206,    -1,
      -1,    -1,    -1,   211,    -1,    -1,    -1,   215,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,   170,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   204,
      -1,   206,    -1,    -1,    -1,    -1,   211,    -1,    -1,     1,
     215,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      -1,   226,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      -1,    -1,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    -1,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    80,    81,
      82,    83,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    -1,    -1,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    -1,    -1,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    -1,    -1,   169,   170,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   204,    -1,   206,    -1,    -1,    -1,    -1,   211,
      -1,    -1,    -1,   215,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   204,    -1,   206,    -1,    -1,
      -1,    -1,   211,    -1,    -1,     1,   215,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    -1,   226,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    -1,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    -1,    -1,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    79,    80,    81,    82,    83,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      -1,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      -1,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    -1,    -1,   169,   170,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   204,    -1,
     206,    -1,    -1,    -1,    -1,   211,    -1,    -1,    -1,   215,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,   170,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   204,    -1,   206,    -1,    -1,    -1,    -1,   211,    -1,
      -1,    -1,   215,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    -1,   226,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    -1,    -1,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79,
      80,    81,    82,    83,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    -1,    -1,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    -1,    -1,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    -1,    -1,    -1,    -1,   169,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   196,   197,    -1,    -1,
     200,    -1,   202,    -1,   204,    -1,   206,    -1,    -1,    -1,
      -1,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   226,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     189,   190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   204,    -1,   206,    -1,    -1,
      -1,    -1,   211,    -1,    -1,   214,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    -1,    -1,   226,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    -1,    -1,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,    -1,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    80,    81,    82,    83,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    -1,    -1,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    79,    80,    81,    82,    83,    -1,    -1,
      -1,    -1,   169,   170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   204,    -1,   206,
      -1,    -1,    -1,    -1,   211,    -1,    -1,    -1,   215,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   226,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   169,   170,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     196,   197,    -1,    -1,    -1,   201,   202,    -1,   204,   205,
     206,    -1,    -1,    -1,    -1,    -1,    -1,   213,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    -1,    -1,    -1,
     226,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    -1,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    -1,    -1,    79,    80,    81,    82,    83,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    -1,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    -1,    -1,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    79,    80,    81,    82,    83,
      -1,    -1,    -1,    -1,   169,   170,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   204,
      -1,   206,    -1,    -1,    -1,    -1,   211,    -1,    -1,    -1,
     215,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   169,   170,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     204,    -1,   206,    -1,    -1,    -1,    -1,   211,    -1,    -1,
     214,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      -1,    -1,   226,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    -1,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    80,    81,
      82,    83,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    -1,    -1,    64,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    -1,    -1,    -1,    -1,   169,   170,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   204,    -1,   206,    -1,    -1,    -1,    -1,   211,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,   170,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   204,    -1,   206,    -1,    -1,    -1,    -1,
     211,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      -1,    -1,    -1,    -1,    -1,   226,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      -1,    -1,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    -1,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    80,    81,
      82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     0,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,   169,   170,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   204,    -1,   206,    -1,    -1,    -1,    -1,   211,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      -1,    -1,    -1,    -1,   226,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,    -1,    -1,    -1,    -1,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,     1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,    -1,    -1,    -1,    -1,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     222
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    76,    77,    78,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   222,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   253,   254,   171,   171,   171,
     171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   171,   171,   171,   171,   171,     1,   171,     1,   171,
       1,   171,     1,   171,     1,   171,     1,   171,   171,   171,
     171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   171,   171,   171,   171,   171,   171,   171,   171,     1,
     205,   171,     1,   213,   171,   171,   171,   171,   171,   171,
     171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   171,   171,   171,   171,   171,   171,   171,     1,   171,
       1,   171,   171,   171,   171,   171,   171,   171,     0,     1,
     230,    11,   261,    12,   262,    13,   263,    14,   264,    15,
     265,    16,   266,    17,   267,    18,   268,    19,   269,     1,
     202,     1,   202,     1,   202,   202,     1,   202,   196,   197,
     202,   243,     1,   202,     1,   202,   243,     1,   202,     1,
     204,     1,   205,     1,   202,   204,   241,   244,   245,   248,
     205,     1,   204,   205,   207,   208,   216,   224,   240,   241,
     244,   246,   247,   255,   256,   257,   258,   281,     1,   202,
       1,   202,     1,   202,   202,   202,   202,   202,   202,   202,
       1,   202,     1,   202,     1,   202,     1,   202,     1,   202,
       1,   202,     1,   205,     1,   202,     1,   243,     1,   243,
       1,   202,     1,   202,     1,   202,     1,   202,     1,   202,
       1,   202,     1,   202,     1,   202,     1,   202,     1,   205,
       1,   205,     1,   205,   205,     1,   202,     1,   204,   205,
       1,   204,   205,     1,   202,     1,   204,   205,     1,   202,
       1,   202,     1,   202,     1,   202,     1,   202,     1,   202,
       1,   202,   204,     1,   202,     1,   202,     1,   202,     1,
     202,     1,   202,     1,   204,   240,     1,   202,     1,   202,
       1,   202,     1,   202,     1,   202,     1,   202,   204,   202,
     202,   204,   202,     1,   205,     1,   205,     1,   202,     1,
     202,     1,   214,   216,     1,   216,     1,   214,   216,     1,
     216,     1,   214,     1,   214,     1,   214,     1,   216,     1,
     216,   202,   202,     1,   223,   219,   220,   225,   220,   223,
     257,   223,   223,   247,   197,   221,   280,   210,   223,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    41,    45,
      46,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    64,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    79,    80,    81,    82,    83,   169,
     170,   204,   206,   211,   226,   276,   284,   287,   288,   289,
     290,   291,   292,   300,   202,   204,   205,   260,   260,   287,
     260,   260,   287,   287,   287,   260,   260,   198,   240,   240,
     202,   220,   202,     1,   205,   250,   217,   240,     1,   204,
     205,   214,     1,   213,     1,   213,   213,   213,   213,   213,
       1,   213,     1,   213,     1,   213,     1,   213,     1,   213,
       1,   213,     1,   213,     1,   213,   213,   213,   213,     1,
     213,     1,   213,     1,   213,     1,   213,   213,     1,   213,
     213,   213,   213,   213,   213,   200,   213,   214,   216,   243,
     270,   276,   277,   278,   284,   285,   289,   300,   213,   270,
     213,     1,   213,     1,   213,     1,   213,     1,   213,     1,
     213,     1,   213,     1,   213,     1,   213,     1,   213,     1,
     213,     1,   213,     1,   213,     1,   213,   213,   213,   213,
     213,   213,   213,   213,   213,   213,   213,   213,   213,   213,
     213,   213,   213,   213,     1,   213,   171,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   282,   211,     1,   215,
     288,     1,   211,   217,   217,   215,   217,   217,   215,   215,
     215,   210,   210,   217,   223,   223,   220,   223,   225,   202,
     250,   223,   210,   200,   213,   251,   252,     1,   205,   212,
       1,   205,   212,   270,   212,   212,   243,   276,     1,   205,
     243,     1,   205,     1,   260,     1,   205,     1,   205,     1,
     205,     1,   202,     1,   202,   205,   212,   202,   276,   205,
     276,     1,   205,     1,   205,     1,   205,     1,   205,   212,
       1,   205,   212,   212,   212,   212,     1,   202,   212,   270,
     270,   215,   287,   201,   205,   213,   243,   276,   278,   283,
     300,   189,   190,   214,   286,   288,   172,   173,   174,   175,
     176,   177,   178,   179,   271,   272,   273,   274,   275,   276,
     286,   276,     1,   240,     1,   202,   205,     1,   244,     1,
     202,     1,   212,     1,   205,     1,   205,   202,   204,   202,
     204,   202,   204,   202,   204,   202,   204,   202,   204,   205,
     205,   205,   205,   205,   205,   205,   205,   205,   259,   205,
     259,   205,   205,   205,   276,   202,   212,   204,   299,   299,
       1,   202,   205,   210,   212,   297,    66,    66,   283,   214,
     214,   214,   214,   202,   168,   169,   214,   202,   224,   242,
       1,   242,   202,   242,   220,     1,   242,   205,   243,   213,
     224,   241,   249,     1,   210,   215,   212,   212,   212,   210,
     212,   210,   212,   212,   212,   212,   210,   212,   210,   212,
     210,   212,   212,   212,   212,   212,   212,   212,   212,   212,
     212,   212,   210,   212,   212,   212,   210,   210,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   212,   212,   212,
     212,   215,   283,   283,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   217,   218,   270,   270,   215,   287,    40,
      66,   209,   255,   279,   243,   205,   276,   212,    47,   212,
     212,   212,   212,   212,   212,   212,   212,   210,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   212,   212,   212,
     210,   212,   212,   210,   212,   212,   210,   212,   212,   210,
     212,   210,   210,   210,   210,   210,   210,   210,   205,   212,
     205,   212,   210,   212,   212,   210,   212,   210,   210,   210,
     210,     1,   213,   210,   210,   212,   212,   202,   205,   210,
     212,   287,   287,   287,   287,   217,   217,   217,   287,   220,
     225,   202,   212,   212,   249,   210,   251,   205,   205,   205,
     205,    66,   205,   243,   276,   298,   205,   205,   205,   212,
     283,   283,   283,   283,   283,   283,   283,   283,   283,   283,
     215,   286,   214,   276,   202,   202,   204,   202,   204,   202,
     204,   205,   205,   205,   205,   205,   205,   205,   205,   205,
     259,   276,   205,   205,   276,   205,     1,   212,   297,   260,
     260,   202,   205,   215,   215,   215,   215,   214,   214,   214,
     215,   202,   220,   210,   279,   212,   212,   212,   212,   210,
     212,   212,   212,   212,    42,   293,   294,   295,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   210,   210,   210,
     212,   210,   210,   210,   212,   212,   212,   210,   212,   210,
     212,   210,   212,   210,   212,   212,   212,   212,   212,   287,
     287,   287,   202,   279,   210,    66,   205,   243,   276,   205,
     243,   215,    43,   295,   296,   286,   205,   276,   276,   202,
     276,   202,   276,   205,   276,   202,   205,   205,   215,   215,
     215,   210,   242,   223,   223,   223,   210,   212,   212,   212,
     210,   210,   210,   210,   212,   212,   212,   210,   212,   242,
     210,    44,   287,    44,   287,   287,   202,   276,   202,   202,
     202,   202,   205,   210,   205,   211,    44,   211,    44,   212,
     212,   210,   212,   210,   212,   210,   212,   210,   212,   210,
     205,   212,   211,   211,   276,   276,   276,   276,   205,   212,
     212,   212,   212,   212,   210,   276,   212
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   227,   228,   229,   229,   229,   230,   230,   231,   230,
     232,   230,   233,   230,   234,   230,   235,   230,   236,   230,
     237,   230,   238,   230,   239,   230,   230,   240,   240,   240,
     241,   242,   242,   243,   243,   243,   244,   244,   244,   244,
     245,   245,   246,   246,   246,   246,   246,   247,   247,   248,
     248,   248,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   249,   249,   250,   250,   251,   251,   252,
     252,   252,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   254,
     254,   254,   254,   254,   255,   255,   256,   257,   258,   258,
     259,   259,   260,   260,   260,   261,   261,   261,   262,   262,
     263,   263,   263,   264,   264,   265,   265,   266,   266,   267,
     267,   268,   268,   269,   269,   269,   269,   270,   270,   270,
     270,   270,   270,   271,   271,   272,   272,   272,   272,   273,
     273,   274,   274,   275,   275,   275,   276,   276,   277,   277,
     277,   277,   278,   278,   278,   278,   278,   279,   279,   280,
     280,   281,   281,   281,   282,   282,   282,   282,   282,   282,
     282,   282,   282,   282,   283,   283,   283,   283,   283,   283,
     283,   283,   283,   283,   283,   283,   283,   283,   283,   283,
     283,   284,   284,   284,   285,   285,   285,   285,   285,   286,
     286,   286,   287,   287,   287,   288,   288,   288,   288,   288,
     288,   288,   288,   289,   289,   290,   291,   292,   293,   293,
     294,   294,   295,   295,   295,   295,   295,   295,   295,   295,
     296,   296,   297,   297,   297,   297,   297,   297,   297,   297,
     298,   298,   298,   298,   298,   298,   298,   298,   299,   299,
     299,   299,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     3,     5,     5,     2,
       3,     5,     1,     3,     5,     5,     1,     1,     2,     1,
       3,     1,     2,     3,     4,     3,     4,     5,     6,     5,
       6,     7,     8,     1,     1,     1,     2,     9,    10,     3,
       1,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     5,     5,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     2,     7,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       2,     8,     8,     2,     1,     1,     1,     1,     1,     3,
       2,     2,     1,     1,     1,     4,     7,     2,     7,     2,
       4,     7,     2,     7,     2,     4,     2,     4,     2,     4,
       2,     9,     2,     7,     9,     9,     2,     3,     3,     2,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     1,     1,     1,
       1,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     3,     3,     3,     1,     1,     1,     3,     2,     1,
       3,     2,     2,     1,     2,     2,     1,     1,     1,     1,
       2,     1,     2,     3,     5,     3,     7,     7,     2,     1,
       2,     1,     6,     5,     4,     3,     6,     5,     4,     3,
       3,     2,     1,     3,     1,     2,     2,     1,     2,     3,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     4,
       4,     2,     4,     3,     2,     4,     4,     6,     2,     4,
       6,     3,     1,     3,     1,     4,     4,     3,     1,     4,
       6,     2,     4,     4,     4,     2,     4,     4,     2,     4,
       4,     2,     6,     6,     4,     4,     2,     6,     6,     4,
       4,     2,     6,     6,     4,     4,     2,     6,     2,     4,
       4,     6,     2,     4,     4,     2,     4,     4,     2,     4,
       4,     2,     4,     4,     2,     4,     6,     4,     3,     1,
       4,     4,     6,     6,     4,     2,     4,     4,     2,     4,
       4,     2,     4,     4,     2,     4,     4,     2,     4,     3,
       1,     4,     2,     4,     3,     1,     3,     1,     3,     1,
       3,     1,     4,     3,     1,     4,     4,     4,     2,     4,
       4,     4,     2,     4,     4,     2,     4,     6,     4,     2,
       3,     4,     2,     4,     4,     2,     4,     4,     2,     8,
      10,    10,     6,     8,     8,    10,    10,    12,    12,    10,
      10,    12,    12,     8,     6,     3,     4,     4,     2,     4,
       4,     4,     4,     6,     6,     4,     6,     8,     6,     8,
      14,     6,     3,     6,     8,     6,     6,     4,     4,     6
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* statements: statements statement  */
#line 489 "cfg.y"
                                     {}
#line 3129 "cfg.tab.c"
    break;

  case 4: /* statements: statement  */
#line 490 "cfg.y"
                            {}
#line 3135 "cfg.tab.c"
    break;

  case 5: /* statements: statements error  */
#line 491 "cfg.y"
                                   { yyerror(""); YYABORT;}
#line 3141 "cfg.tab.c"
    break;

  case 8: /* $@1: %empty  */
#line 496 "cfg.y"
                  {rt=REQUEST_ROUTE;}
#line 3147 "cfg.tab.c"
    break;

  case 10: /* $@2: %empty  */
#line 497 "cfg.y"
                  {rt=FAILURE_ROUTE;}
#line 3153 "cfg.tab.c"
    break;

  case 12: /* $@3: %empty  */
#line 498 "cfg.y"
                  {rt=ONREPLY_ROUTE;}
#line 3159 "cfg.tab.c"
    break;

  case 14: /* $@4: %empty  */
#line 499 "cfg.y"
                  {rt=BRANCH_ROUTE;}
#line 3165 "cfg.tab.c"
    break;

  case 16: /* $@5: %empty  */
#line 500 "cfg.y"
                  {rt=ERROR_ROUTE;}
#line 3171 "cfg.tab.c"
    break;

  case 18: /* $@6: %empty  */
#line 501 "cfg.y"
                  {rt=LOCAL_ROUTE;}
#line 3177 "cfg.tab.c"
    break;

  case 20: /* $@7: %empty  */
#line 502 "cfg.y"
                  {rt=STARTUP_ROUTE;}
#line 3183 "cfg.tab.c"
    break;

  case 22: /* $@8: %empty  */
#line 503 "cfg.y"
                  {rt=TIMER_ROUTE;}
#line 3189 "cfg.tab.c"
    break;

  case 24: /* $@9: %empty  */
#line 504 "cfg.y"
                  {rt=EVENT_ROUTE;}
#line 3195 "cfg.tab.c"
    break;

  case 27: /* listen_id: ip  */
#line 509 "cfg.y"
                                        {	tmp=ip_addr2a((yyvsp[0].ipaddr));
							if(tmp==0){
								LM_CRIT("cfg. parser: bad ip address.\n");
								(yyval.strval)=0;
							}else{
								(yyval.strval)=pkg_malloc(strlen(tmp)+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									strncpy((yyval.strval), tmp, strlen(tmp)+1);
								}
							}
						}
#line 3214 "cfg.tab.c"
    break;

  case 28: /* listen_id: STRING  */
#line 523 "cfg.y"
                                                {	(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
							if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
							}else{
									strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
							}
						}
#line 3227 "cfg.tab.c"
    break;

  case 29: /* listen_id: host  */
#line 531 "cfg.y"
                                        {	if ((yyvsp[0].strval)==0) {
								(yyval.strval) = 0;
							} else {
								(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
								}
							}
						}
#line 3244 "cfg.tab.c"
    break;

  case 30: /* proto: ID  */
#line 545 "cfg.y"
           {
		if (parse_proto((unsigned char *)(yyvsp[0].strval), strlen((yyvsp[0].strval)), &i_tmp) < 0) {
			yyerrorf("cannot handle protocol <%s>\n", (yyvsp[0].strval));
			YYABORT;
		}
		(yyval.intval) = i_tmp;
	 }
#line 3256 "cfg.tab.c"
    break;

  case 31: /* port: NUMBER  */
#line 554 "cfg.y"
                        { (yyval.intval)=(yyvsp[0].intval); }
#line 3262 "cfg.tab.c"
    break;

  case 32: /* port: ANY  */
#line 555 "cfg.y"
                                { (yyval.intval)=0; }
#line 3268 "cfg.tab.c"
    break;

  case 33: /* snumber: NUMBER  */
#line 558 "cfg.y"
                        { (yyval.intval)=(yyvsp[0].intval); }
#line 3274 "cfg.tab.c"
    break;

  case 34: /* snumber: PLUS NUMBER  */
#line 559 "cfg.y"
                                { (yyval.intval)=(yyvsp[0].intval); }
#line 3280 "cfg.tab.c"
    break;

  case 35: /* snumber: MINUS NUMBER  */
#line 560 "cfg.y"
                                { (yyval.intval)=-(yyvsp[0].intval); }
#line 3286 "cfg.tab.c"
    break;

  case 36: /* phostport: proto COLON listen_id  */
#line 564 "cfg.y"
                                        { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 3292 "cfg.tab.c"
    break;

  case 37: /* phostport: proto COLON listen_id COLON port  */
#line 565 "cfg.y"
                                                                { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 3298 "cfg.tab.c"
    break;

  case 38: /* phostport: proto COLON listen_id COLON error  */
#line 566 "cfg.y"
                                                            {
				(yyval.sockid)=0;
				yyerror("port number expected");
				YYABORT;
				}
#line 3308 "cfg.tab.c"
    break;

  case 39: /* phostport: NUMBER error  */
#line 571 "cfg.y"
                                       { (yyval.sockid)=0;
				yyerror("protocol expected");
				YYABORT;
			}
#line 3317 "cfg.tab.c"
    break;

  case 40: /* panyhostport: proto COLON MULT  */
#line 577 "cfg.y"
                                                        { (yyval.sockid)=mk_listen_id(0, (yyvsp[-2].intval), 0); }
#line 3323 "cfg.tab.c"
    break;

  case 41: /* panyhostport: proto COLON MULT COLON port  */
#line 578 "cfg.y"
                                                        { (yyval.sockid)=mk_listen_id(0, (yyvsp[-4].intval), (yyvsp[0].intval)); }
#line 3329 "cfg.tab.c"
    break;

  case 42: /* alias_def: listen_id  */
#line 581 "cfg.y"
                                                                        { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 3335 "cfg.tab.c"
    break;

  case 43: /* alias_def: ANY COLON listen_id  */
#line 582 "cfg.y"
                                                                        { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 3341 "cfg.tab.c"
    break;

  case 44: /* alias_def: ANY COLON listen_id COLON port  */
#line 583 "cfg.y"
                                                        { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 3347 "cfg.tab.c"
    break;

  case 45: /* alias_def: ANY COLON listen_id COLON error  */
#line 584 "cfg.y"
                                                        {
				(yyval.sockid)=0;
				yyerror(" port number expected");
				}
#line 3356 "cfg.tab.c"
    break;

  case 47: /* id_lst: alias_def  */
#line 591 "cfg.y"
                                        {  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 3362 "cfg.tab.c"
    break;

  case 48: /* id_lst: alias_def id_lst  */
#line 592 "cfg.y"
                                        { (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 3368 "cfg.tab.c"
    break;

  case 49: /* listen_def: panyhostport  */
#line 596 "cfg.y"
                                                { (yyval.sockid)=(yyvsp[0].sockid); }
#line 3374 "cfg.tab.c"
    break;

  case 50: /* listen_def: panyhostport USE_CHILDREN NUMBER  */
#line 597 "cfg.y"
                                                           { (yyval.sockid)=(yyvsp[-2].sockid); (yyval.sockid)->children=(yyvsp[0].intval); }
#line 3380 "cfg.tab.c"
    break;

  case 51: /* listen_def: phostport  */
#line 598 "cfg.y"
                                                                { (yyval.sockid)=(yyvsp[0].sockid); }
#line 3386 "cfg.tab.c"
    break;

  case 52: /* listen_def: phostport ANYCAST  */
#line 599 "cfg.y"
                                                        { (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->flags=SI_IS_ANYCAST; }
#line 3392 "cfg.tab.c"
    break;

  case 53: /* listen_def: phostport USE_CHILDREN NUMBER  */
#line 600 "cfg.y"
                                                        { (yyval.sockid)=(yyvsp[-2].sockid); (yyval.sockid)->children=(yyvsp[0].intval); }
#line 3398 "cfg.tab.c"
    break;

  case 54: /* listen_def: phostport ANYCAST USE_CHILDREN NUMBER  */
#line 601 "cfg.y"
                                                                {
				(yyval.sockid)=(yyvsp[-3].sockid); (yyval.sockid)->children=(yyvsp[0].intval); (yyval.sockid)->flags=SI_IS_ANYCAST;
				}
#line 3406 "cfg.tab.c"
    break;

  case 55: /* listen_def: phostport AS listen_id  */
#line 604 "cfg.y"
                                                 {
				(yyval.sockid)=(yyvsp[-2].sockid); set_listen_id_adv((struct socket_id *)(yyvsp[-2].sockid), (yyvsp[0].strval), 5060);
				}
#line 3414 "cfg.tab.c"
    break;

  case 56: /* listen_def: phostport AS listen_id ANYCAST  */
#line 607 "cfg.y"
                                                         {
				(yyval.sockid)=(yyvsp[-3].sockid); set_listen_id_adv((struct socket_id *)(yyvsp[-3].sockid), (yyvsp[-1].strval), 5060);
				(yyval.sockid)->flags=SI_IS_ANYCAST;
				}
#line 3423 "cfg.tab.c"
    break;

  case 57: /* listen_def: phostport AS listen_id USE_CHILDREN NUMBER  */
#line 611 "cfg.y"
                                                                     {
				(yyval.sockid)=(yyvsp[-4].sockid); set_listen_id_adv((struct socket_id *)(yyvsp[-4].sockid), (yyvsp[-2].strval), 5060);
				(yyvsp[-4].sockid)->children=(yyvsp[0].intval);
				}
#line 3432 "cfg.tab.c"
    break;

  case 58: /* listen_def: phostport AS listen_id ANYCAST USE_CHILDREN NUMBER  */
#line 615 "cfg.y"
                                                                             {
				(yyval.sockid)=(yyvsp[-5].sockid); set_listen_id_adv((struct socket_id *)(yyvsp[-5].sockid), (yyvsp[-3].strval), 5060);
				(yyvsp[-5].sockid)->children=(yyvsp[0].intval); (yyval.sockid)->flags=SI_IS_ANYCAST;
				}
#line 3441 "cfg.tab.c"
    break;

  case 59: /* listen_def: phostport AS listen_id COLON port  */
#line 619 "cfg.y"
                                                            {
				(yyval.sockid)=(yyvsp[-4].sockid); set_listen_id_adv((struct socket_id *)(yyvsp[-4].sockid), (yyvsp[-2].strval), (yyvsp[0].intval));
				}
#line 3449 "cfg.tab.c"
    break;

  case 60: /* listen_def: phostport AS listen_id COLON port ANYCAST  */
#line 622 "cfg.y"
                                                                    {
				(yyval.sockid)=(yyvsp[-5].sockid); set_listen_id_adv((struct socket_id *)(yyvsp[-5].sockid), (yyvsp[-3].strval), (yyvsp[-1].intval));
				(yyval.sockid)->flags=SI_IS_ANYCAST;
				}
#line 3458 "cfg.tab.c"
    break;

  case 61: /* listen_def: phostport AS listen_id COLON port USE_CHILDREN NUMBER  */
#line 626 "cfg.y"
                                                                                {
				(yyval.sockid)=(yyvsp[-6].sockid); set_listen_id_adv((struct socket_id *)(yyvsp[-6].sockid), (yyvsp[-4].strval), (yyvsp[-2].intval));
				(yyvsp[-6].sockid)->children=(yyvsp[0].intval);
				}
#line 3467 "cfg.tab.c"
    break;

  case 62: /* listen_def: phostport AS listen_id COLON port ANYCAST USE_CHILDREN NUMBER  */
#line 630 "cfg.y"
                                                                                        {
				(yyval.sockid)=(yyvsp[-7].sockid); set_listen_id_adv((struct socket_id *)(yyvsp[-7].sockid), (yyvsp[-5].strval), (yyvsp[-3].intval));
				(yyvsp[-7].sockid)->children=(yyvsp[0].intval); (yyval.sockid)->flags=SI_IS_ANYCAST;
				}
#line 3476 "cfg.tab.c"
    break;

  case 63: /* any_proto: ANY  */
#line 636 "cfg.y"
                        { (yyval.intval)=PROTO_NONE; }
#line 3482 "cfg.tab.c"
    break;

  case 64: /* any_proto: proto  */
#line 637 "cfg.y"
                                { (yyval.intval)=(yyvsp[0].intval); }
#line 3488 "cfg.tab.c"
    break;

  case 65: /* multi_string: STRING  */
#line 639 "cfg.y"
                       { (yyval.multistr)=new_string((yyvsp[0].strval)); }
#line 3494 "cfg.tab.c"
    break;

  case 66: /* multi_string: STRING multi_string  */
#line 640 "cfg.y"
                                      { (yyval.multistr)=new_string((yyvsp[-1].strval)); (yyval.multistr)->next=(yyvsp[0].multistr); }
#line 3500 "cfg.tab.c"
    break;

  case 67: /* blst_elem: LPAREN any_proto COMMA ipnet COMMA port COMMA STRING RPAREN  */
#line 643 "cfg.y"
                                                                        {
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,(yyvsp[-3].intval),(yyvsp[-7].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3512 "cfg.tab.c"
    break;

  case 68: /* blst_elem: NOT LPAREN any_proto COMMA ipnet COMMA port COMMA STRING RPAREN  */
#line 650 "cfg.y"
                                                                                    {
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,
				(yyvsp[-3].intval),(yyvsp[-7].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3525 "cfg.tab.c"
    break;

  case 69: /* blst_elem_list: blst_elem_list COMMA blst_elem  */
#line 660 "cfg.y"
                                               {}
#line 3531 "cfg.tab.c"
    break;

  case 70: /* blst_elem_list: blst_elem  */
#line 661 "cfg.y"
                            {}
#line 3537 "cfg.tab.c"
    break;

  case 71: /* blst_elem_list: blst_elem_list error  */
#line 662 "cfg.y"
                                       { yyerror("bad black list element");}
#line 3543 "cfg.tab.c"
    break;

  case 72: /* assign_stm: DEBUG EQUAL snumber  */
#line 667 "cfg.y"
                        { yyerror("\'debug\' is deprecated, use \'log_level\' instead\n");}
#line 3549 "cfg.tab.c"
    break;

  case 73: /* assign_stm: FORK EQUAL NUMBER  */
#line 669 "cfg.y"
                        {yyerror("fork is deprecated, use debug_mode\n");}
#line 3555 "cfg.tab.c"
    break;

  case 74: /* assign_stm: LOGLEVEL EQUAL snumber  */
#line 670 "cfg.y"
                                         {
			/* in debug mode, force logging to DEBUG level*/
			*log_level = debug_mode?L_DBG:(yyvsp[0].intval);
			}
#line 3564 "cfg.tab.c"
    break;

  case 75: /* assign_stm: ENABLE_ASSERTS EQUAL NUMBER  */
#line 674 "cfg.y"
                                               { enable_asserts=(yyvsp[0].intval); }
#line 3570 "cfg.tab.c"
    break;

  case 76: /* assign_stm: ENABLE_ASSERTS EQUAL error  */
#line 675 "cfg.y"
                                              { yyerror("boolean value expected"); }
#line 3576 "cfg.tab.c"
    break;

  case 77: /* assign_stm: ABORT_ON_ASSERT EQUAL NUMBER  */
#line 676 "cfg.y"
                                                { abort_on_assert=(yyvsp[0].intval); }
#line 3582 "cfg.tab.c"
    break;

  case 78: /* assign_stm: ABORT_ON_ASSERT EQUAL error  */
#line 677 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3588 "cfg.tab.c"
    break;

  case 79: /* assign_stm: DEBUG_MODE EQUAL NUMBER  */
#line 678 "cfg.y"
                                           { debug_mode=(yyvsp[0].intval);
			if (debug_mode) { *log_level = L_DBG;log_stderr=1;}
			}
#line 3596 "cfg.tab.c"
    break;

  case 80: /* assign_stm: DEBUG_MODE EQUAL error  */
#line 682 "cfg.y"
                        { yyerror("boolean value expected for debug_mode"); }
#line 3602 "cfg.tab.c"
    break;

  case 81: /* assign_stm: LOGSTDERROR EQUAL NUMBER  */
#line 686 "cfg.y"
                        { if (!config_check && !debug_mode) log_stderr=(yyvsp[0].intval); }
#line 3608 "cfg.tab.c"
    break;

  case 82: /* assign_stm: LOGSTDERROR EQUAL error  */
#line 687 "cfg.y"
                                          { yyerror("boolean value expected"); }
#line 3614 "cfg.tab.c"
    break;

  case 83: /* assign_stm: LOGFACILITY EQUAL ID  */
#line 688 "cfg.y"
                                       {
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3625 "cfg.tab.c"
    break;

  case 84: /* assign_stm: LOGFACILITY EQUAL error  */
#line 694 "cfg.y"
                                          { yyerror("ID expected"); }
#line 3631 "cfg.tab.c"
    break;

  case 85: /* assign_stm: LOGNAME EQUAL STRING  */
#line 695 "cfg.y"
                                       { log_name=(yyvsp[0].strval); }
#line 3637 "cfg.tab.c"
    break;

  case 86: /* assign_stm: LOGNAME EQUAL error  */
#line 696 "cfg.y"
                                      { yyerror("string value expected"); }
#line 3643 "cfg.tab.c"
    break;

  case 87: /* assign_stm: DNS EQUAL NUMBER  */
#line 697 "cfg.y"
                                     { received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 3649 "cfg.tab.c"
    break;

  case 88: /* assign_stm: DNS EQUAL error  */
#line 698 "cfg.y"
                                  { yyerror("boolean value expected"); }
#line 3655 "cfg.tab.c"
    break;

  case 89: /* assign_stm: REV_DNS EQUAL NUMBER  */
#line 699 "cfg.y"
                                       { received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 3661 "cfg.tab.c"
    break;

  case 90: /* assign_stm: REV_DNS EQUAL error  */
#line 700 "cfg.y"
                                      { yyerror("boolean value expected"); }
#line 3667 "cfg.tab.c"
    break;

  case 91: /* assign_stm: DNS_TRY_IPV6 EQUAL NUMBER  */
#line 701 "cfg.y"
                                              { dns_try_ipv6=(yyvsp[0].intval); }
#line 3673 "cfg.tab.c"
    break;

  case 92: /* assign_stm: DNS_TRY_IPV6 error  */
#line 702 "cfg.y"
                                     { yyerror("boolean value expected"); }
#line 3679 "cfg.tab.c"
    break;

  case 93: /* assign_stm: DNS_TRY_NAPTR EQUAL NUMBER  */
#line 703 "cfg.y"
                                               { dns_try_naptr=(yyvsp[0].intval); }
#line 3685 "cfg.tab.c"
    break;

  case 94: /* assign_stm: DNS_TRY_NAPTR error  */
#line 704 "cfg.y"
                                      { yyerror("boolean value expected"); }
#line 3691 "cfg.tab.c"
    break;

  case 95: /* assign_stm: DNS_RETR_TIME EQUAL NUMBER  */
#line 705 "cfg.y"
                                               { dns_retr_time=(yyvsp[0].intval); }
#line 3697 "cfg.tab.c"
    break;

  case 96: /* assign_stm: DNS_RETR_TIME error  */
#line 706 "cfg.y"
                                      { yyerror("number expected"); }
#line 3703 "cfg.tab.c"
    break;

  case 97: /* assign_stm: DNS_RETR_NO EQUAL NUMBER  */
#line 707 "cfg.y"
                                             { dns_retr_no=(yyvsp[0].intval); }
#line 3709 "cfg.tab.c"
    break;

  case 98: /* assign_stm: DNS_RETR_NO error  */
#line 708 "cfg.y"
                                    { yyerror("number expected"); }
#line 3715 "cfg.tab.c"
    break;

  case 99: /* assign_stm: DNS_SERVERS_NO EQUAL NUMBER  */
#line 709 "cfg.y"
                                                { dns_servers_no=(yyvsp[0].intval); }
#line 3721 "cfg.tab.c"
    break;

  case 100: /* assign_stm: DNS_SERVERS_NO error  */
#line 710 "cfg.y"
                                       { yyerror("number expected"); }
#line 3727 "cfg.tab.c"
    break;

  case 101: /* assign_stm: DNS_USE_SEARCH EQUAL NUMBER  */
#line 711 "cfg.y"
                                                { dns_search_list=(yyvsp[0].intval); }
#line 3733 "cfg.tab.c"
    break;

  case 102: /* assign_stm: DNS_USE_SEARCH error  */
#line 712 "cfg.y"
                                       { yyerror("boolean value expected"); }
#line 3739 "cfg.tab.c"
    break;

  case 103: /* assign_stm: MAX_WHILE_LOOPS EQUAL NUMBER  */
#line 713 "cfg.y"
                                               { max_while_loops=(yyvsp[0].intval); }
#line 3745 "cfg.tab.c"
    break;

  case 104: /* assign_stm: MAX_WHILE_LOOPS EQUAL error  */
#line 714 "cfg.y"
                                              { yyerror("number expected"); }
#line 3751 "cfg.tab.c"
    break;

  case 105: /* assign_stm: MAXBUFFER EQUAL NUMBER  */
#line 715 "cfg.y"
                                         { maxbuffer=(yyvsp[0].intval); }
#line 3757 "cfg.tab.c"
    break;

  case 106: /* assign_stm: MAXBUFFER EQUAL error  */
#line 716 "cfg.y"
                                        { yyerror("number expected"); }
#line 3763 "cfg.tab.c"
    break;

  case 107: /* assign_stm: CHILDREN EQUAL NUMBER  */
#line 717 "cfg.y"
                                        { children_no=(yyvsp[0].intval); }
#line 3769 "cfg.tab.c"
    break;

  case 108: /* assign_stm: CHILDREN EQUAL error  */
#line 718 "cfg.y"
                                       { yyerror("number expected"); }
#line 3775 "cfg.tab.c"
    break;

  case 109: /* assign_stm: CHECK_VIA EQUAL NUMBER  */
#line 719 "cfg.y"
                                         { check_via=(yyvsp[0].intval); }
#line 3781 "cfg.tab.c"
    break;

  case 110: /* assign_stm: CHECK_VIA EQUAL error  */
#line 720 "cfg.y"
                                        { yyerror("boolean value expected"); }
#line 3787 "cfg.tab.c"
    break;

  case 111: /* assign_stm: SHM_HASH_SPLIT_PERCENTAGE EQUAL NUMBER  */
#line 721 "cfg.y"
                                                         {
			#ifdef HP_MALLOC
			shm_hash_split_percentage=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3800 "cfg.tab.c"
    break;

  case 112: /* assign_stm: SHM_HASH_SPLIT_PERCENTAGE EQUAL error  */
#line 729 "cfg.y"
                                                        {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
				}
#line 3813 "cfg.tab.c"
    break;

  case 113: /* assign_stm: SHM_SECONDARY_HASH_SIZE EQUAL NUMBER  */
#line 737 "cfg.y"
                                                       {
			#ifdef HP_MALLOC
			shm_secondary_hash_size=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3826 "cfg.tab.c"
    break;

  case 114: /* assign_stm: SHM_SECONDARY_HASH_SIZE EQUAL error  */
#line 745 "cfg.y"
                                                      {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3839 "cfg.tab.c"
    break;

  case 115: /* assign_stm: MEM_WARMING_ENABLED EQUAL NUMBER  */
#line 753 "cfg.y"
                                                   {
			#ifdef HP_MALLOC
			mem_warming_enabled = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3852 "cfg.tab.c"
    break;

  case 116: /* assign_stm: MEM_WARMING_ENABLED EQUAL error  */
#line 761 "cfg.y"
                                                  {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3865 "cfg.tab.c"
    break;

  case 117: /* assign_stm: MEM_WARMING_PATTERN_FILE EQUAL STRING  */
#line 769 "cfg.y"
                                                        {
			#ifdef HP_MALLOC
			mem_warming_pattern_file = (yyvsp[0].strval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3878 "cfg.tab.c"
    break;

  case 118: /* assign_stm: MEM_WARMING_PATTERN_FILE EQUAL error  */
#line 777 "cfg.y"
                                                       {
			#ifdef HP_MALLOC
			yyerror("string expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3891 "cfg.tab.c"
    break;

  case 119: /* assign_stm: MEM_WARMING_PERCENTAGE EQUAL NUMBER  */
#line 785 "cfg.y"
                                                      {
			#ifdef HP_MALLOC
			mem_warming_percentage = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3904 "cfg.tab.c"
    break;

  case 120: /* assign_stm: MEM_WARMING_PERCENTAGE EQUAL error  */
#line 793 "cfg.y"
                                                     {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3917 "cfg.tab.c"
    break;

  case 121: /* assign_stm: MEMLOG EQUAL snumber  */
#line 801 "cfg.y"
                                       { memlog=(yyvsp[0].intval); memdump=(yyvsp[0].intval); }
#line 3923 "cfg.tab.c"
    break;

  case 122: /* assign_stm: MEMLOG EQUAL error  */
#line 802 "cfg.y"
                                     { yyerror("int value expected"); }
#line 3929 "cfg.tab.c"
    break;

  case 123: /* assign_stm: MEMDUMP EQUAL snumber  */
#line 803 "cfg.y"
                                        { memdump=(yyvsp[0].intval); }
#line 3935 "cfg.tab.c"
    break;

  case 124: /* assign_stm: MEMDUMP EQUAL error  */
#line 804 "cfg.y"
                                      { yyerror("int value expected"); }
#line 3941 "cfg.tab.c"
    break;

  case 125: /* assign_stm: EXECMSGTHRESHOLD EQUAL NUMBER  */
#line 805 "cfg.y"
                                                { execmsgthreshold=(yyvsp[0].intval); }
#line 3947 "cfg.tab.c"
    break;

  case 126: /* assign_stm: EXECMSGTHRESHOLD EQUAL error  */
#line 806 "cfg.y"
                                               { yyerror("int value expected"); }
#line 3953 "cfg.tab.c"
    break;

  case 127: /* assign_stm: EXECDNSTHRESHOLD EQUAL NUMBER  */
#line 807 "cfg.y"
                                                { execdnsthreshold=(yyvsp[0].intval); }
#line 3959 "cfg.tab.c"
    break;

  case 128: /* assign_stm: EXECDNSTHRESHOLD EQUAL error  */
#line 808 "cfg.y"
                                               { yyerror("int value expected"); }
#line 3965 "cfg.tab.c"
    break;

  case 129: /* assign_stm: TCPTHRESHOLD EQUAL NUMBER  */
#line 809 "cfg.y"
                                            { tcpthreshold=(yyvsp[0].intval); }
#line 3971 "cfg.tab.c"
    break;

  case 130: /* assign_stm: TCPTHRESHOLD EQUAL error  */
#line 810 "cfg.y"
                                           { yyerror("int value expected"); }
#line 3977 "cfg.tab.c"
    break;

  case 131: /* assign_stm: EVENT_SHM_THRESHOLD EQUAL NUMBER  */
#line 811 "cfg.y"
                                                   {
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("SHM threshold has to be a percentage between"
					" 0 and 100");
			event_shm_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif /* STATISTICS */
			}
#line 3992 "cfg.tab.c"
    break;

  case 132: /* assign_stm: EVENT_SHM_THRESHOLD EQUAL error  */
#line 821 "cfg.y"
                                                  { yyerror("int value expected"); }
#line 3998 "cfg.tab.c"
    break;

  case 133: /* assign_stm: EVENT_PKG_THRESHOLD EQUAL NUMBER  */
#line 822 "cfg.y"
                                                   {
			#ifdef PKG_MALLOC
			#ifdef STATISTICS
			#ifdef USE_SHM_MEM
				warn("No PKG memory, all allocations are mapped to SHM; "
					"Use event_shm_threshold instead or recompile with PKG_MALLOC "
					"instead of USE_SHM_MEM in order to have separate PKG memory");
			#else
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("PKG threshold has to be a percentage between "
					"0 and 100");
			event_pkg_threshold=(yyvsp[0].intval);
			#endif
			#else
			yyerror("statistics support not compiled in");
			#endif
			#else
			yyerror("pkg_malloc support not compiled in");
			#endif
			}
#line 4023 "cfg.tab.c"
    break;

  case 134: /* assign_stm: EVENT_PKG_THRESHOLD EQUAL error  */
#line 842 "cfg.y"
                                                  { yyerror("int value expected"); }
#line 4029 "cfg.tab.c"
    break;

  case 135: /* assign_stm: QUERYBUFFERSIZE EQUAL NUMBER  */
#line 843 "cfg.y"
                                               { query_buffer_size=(yyvsp[0].intval); }
#line 4035 "cfg.tab.c"
    break;

  case 136: /* assign_stm: QUERYBUFFERSIZE EQUAL error  */
#line 844 "cfg.y"
                                              { yyerror("int value expected"); }
#line 4041 "cfg.tab.c"
    break;

  case 137: /* assign_stm: QUERYFLUSHTIME EQUAL NUMBER  */
#line 845 "cfg.y"
                                              { query_flush_time=(yyvsp[0].intval); }
#line 4047 "cfg.tab.c"
    break;

  case 138: /* assign_stm: QUERYFLUSHTIME EQUAL error  */
#line 846 "cfg.y"
                                             { yyerror("int value expected"); }
#line 4053 "cfg.tab.c"
    break;

  case 139: /* assign_stm: SIP_WARNING EQUAL NUMBER  */
#line 847 "cfg.y"
                                           { sip_warning=(yyvsp[0].intval); }
#line 4059 "cfg.tab.c"
    break;

  case 140: /* assign_stm: SIP_WARNING EQUAL error  */
#line 848 "cfg.y"
                                          { yyerror("boolean value expected"); }
#line 4065 "cfg.tab.c"
    break;

  case 141: /* assign_stm: CHROOT EQUAL STRING  */
#line 849 "cfg.y"
                                          { chroot_dir=(yyvsp[0].strval); }
#line 4071 "cfg.tab.c"
    break;

  case 142: /* assign_stm: CHROOT EQUAL ID  */
#line 850 "cfg.y"
                                          { chroot_dir=(yyvsp[0].strval); }
#line 4077 "cfg.tab.c"
    break;

  case 143: /* assign_stm: CHROOT EQUAL error  */
#line 851 "cfg.y"
                                          { yyerror("string value expected"); }
#line 4083 "cfg.tab.c"
    break;

  case 144: /* assign_stm: WDIR EQUAL STRING  */
#line 852 "cfg.y"
                                        { working_dir=(yyvsp[0].strval); }
#line 4089 "cfg.tab.c"
    break;

  case 145: /* assign_stm: WDIR EQUAL ID  */
#line 853 "cfg.y"
                                        { working_dir=(yyvsp[0].strval); }
#line 4095 "cfg.tab.c"
    break;

  case 146: /* assign_stm: WDIR EQUAL error  */
#line 854 "cfg.y"
                                        { yyerror("string value expected"); }
#line 4101 "cfg.tab.c"
    break;

  case 147: /* assign_stm: MHOMED EQUAL NUMBER  */
#line 855 "cfg.y"
                                      { mhomed=(yyvsp[0].intval); }
#line 4107 "cfg.tab.c"
    break;

  case 148: /* assign_stm: MHOMED EQUAL error  */
#line 856 "cfg.y"
                                     { yyerror("boolean value expected"); }
#line 4113 "cfg.tab.c"
    break;

  case 149: /* assign_stm: POLL_METHOD EQUAL ID  */
#line 857 "cfg.y"
                                       {
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
								}
#line 4128 "cfg.tab.c"
    break;

  case 150: /* assign_stm: POLL_METHOD EQUAL STRING  */
#line 867 "cfg.y"
                                           {
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
									}
#line 4143 "cfg.tab.c"
    break;

  case 151: /* assign_stm: POLL_METHOD EQUAL error  */
#line 877 "cfg.y"
                                          { yyerror("poll method name expected"); }
#line 4149 "cfg.tab.c"
    break;

  case 152: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL NUMBER  */
#line 878 "cfg.y"
                                                  {
				tcp_accept_aliases=(yyvsp[0].intval);
		}
#line 4157 "cfg.tab.c"
    break;

  case 153: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL error  */
#line 881 "cfg.y"
                                                 { yyerror("boolean value expected"); }
#line 4163 "cfg.tab.c"
    break;

  case 154: /* assign_stm: TCP_CHILDREN EQUAL NUMBER  */
#line 882 "cfg.y"
                                            {
				tcp_children_no=(yyvsp[0].intval);
		}
#line 4171 "cfg.tab.c"
    break;

  case 155: /* assign_stm: TCP_CHILDREN EQUAL error  */
#line 885 "cfg.y"
                                           { yyerror("number expected"); }
#line 4177 "cfg.tab.c"
    break;

  case 156: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL NUMBER  */
#line 886 "cfg.y"
                                                   {
				tcp_connect_timeout=(yyvsp[0].intval);
		}
#line 4185 "cfg.tab.c"
    break;

  case 157: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL error  */
#line 889 "cfg.y"
                                                  { yyerror("number expected"); }
#line 4191 "cfg.tab.c"
    break;

  case 158: /* assign_stm: TCP_CON_LIFETIME EQUAL NUMBER  */
#line 890 "cfg.y"
                                                {
				tcp_con_lifetime=(yyvsp[0].intval);
		}
#line 4199 "cfg.tab.c"
    break;

  case 159: /* assign_stm: TCP_CON_LIFETIME EQUAL error  */
#line 893 "cfg.y"
                                               { yyerror("number expected"); }
#line 4205 "cfg.tab.c"
    break;

  case 160: /* assign_stm: TCP_LISTEN_BACKLOG EQUAL NUMBER  */
#line 894 "cfg.y"
                                                  {
				tcp_listen_backlog=(yyvsp[0].intval);
		}
#line 4213 "cfg.tab.c"
    break;

  case 161: /* assign_stm: TCP_LISTEN_BACKLOG EQUAL error  */
#line 897 "cfg.y"
                                                 { yyerror("number expected"); }
#line 4219 "cfg.tab.c"
    break;

  case 162: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL NUMBER  */
#line 898 "cfg.y"
                                                   {
				tcp_max_connections=(yyvsp[0].intval);
		}
#line 4227 "cfg.tab.c"
    break;

  case 163: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL error  */
#line 901 "cfg.y"
                                                  { yyerror("number expected"); }
#line 4233 "cfg.tab.c"
    break;

  case 164: /* assign_stm: TCP_NO_NEW_CONN_BFLAG EQUAL NUMBER  */
#line 902 "cfg.y"
                                                     {
				tmp = NULL;
				fix_flag_name(tmp, (yyvsp[0].intval));
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, tmp);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 4247 "cfg.tab.c"
    break;

  case 165: /* assign_stm: TCP_NO_NEW_CONN_BFLAG EQUAL ID  */
#line 911 "cfg.y"
                                                 {
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, (yyvsp[0].strval));
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 4259 "cfg.tab.c"
    break;

  case 166: /* assign_stm: TCP_NO_NEW_CONN_BFLAG EQUAL error  */
#line 918 "cfg.y"
                                                    { yyerror("number value expected"); }
#line 4265 "cfg.tab.c"
    break;

  case 167: /* assign_stm: TCP_KEEPALIVE EQUAL NUMBER  */
#line 919 "cfg.y"
                                             {
				tcp_keepalive=(yyvsp[0].intval);
		}
#line 4273 "cfg.tab.c"
    break;

  case 168: /* assign_stm: TCP_KEEPALIVE EQUAL error  */
#line 922 "cfg.y"
                                            { yyerror("boolean value expected"); }
#line 4279 "cfg.tab.c"
    break;

  case 169: /* assign_stm: TCP_MAX_MSG_TIME EQUAL NUMBER  */
#line 923 "cfg.y"
                                                {
				tcp_max_msg_time=(yyvsp[0].intval);
		}
#line 4287 "cfg.tab.c"
    break;

  case 170: /* assign_stm: TCP_MAX_MSG_TIME EQUAL error  */
#line 926 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 4293 "cfg.tab.c"
    break;

  case 171: /* assign_stm: TCP_KEEPCOUNT EQUAL NUMBER  */
#line 927 "cfg.y"
                                                        {
			#ifndef HAVE_TCP_KEEPCNT
				warn("cannot be enabled TCP_KEEPCOUNT (no OS support)");
			#else
				tcp_keepcount=(yyvsp[0].intval);
			#endif
		}
#line 4305 "cfg.tab.c"
    break;

  case 172: /* assign_stm: TCP_KEEPCOUNT EQUAL error  */
#line 934 "cfg.y"
                                            { yyerror("int value expected"); }
#line 4311 "cfg.tab.c"
    break;

  case 173: /* assign_stm: TCP_KEEPIDLE EQUAL NUMBER  */
#line 935 "cfg.y"
                                                        {
			#ifndef HAVE_TCP_KEEPIDLE
				warn("cannot be enabled TCP_KEEPIDLE (no OS support)");
			#else
				tcp_keepidle=(yyvsp[0].intval);
			#endif
		}
#line 4323 "cfg.tab.c"
    break;

  case 174: /* assign_stm: TCP_KEEPIDLE EQUAL error  */
#line 942 "cfg.y"
                                           { yyerror("int value expected"); }
#line 4329 "cfg.tab.c"
    break;

  case 175: /* assign_stm: TCP_KEEPINTERVAL EQUAL NUMBER  */
#line 943 "cfg.y"
                                                {
			#ifndef HAVE_TCP_KEEPINTVL
				warn("cannot be enabled TCP_KEEPINTERVAL (no OS support)");
			#else
				tcp_keepinterval=(yyvsp[0].intval);
			 #endif
		}
#line 4341 "cfg.tab.c"
    break;

  case 176: /* assign_stm: TCP_KEEPINTERVAL EQUAL error  */
#line 950 "cfg.y"
                                               { yyerror("int value expected"); }
#line 4347 "cfg.tab.c"
    break;

  case 177: /* assign_stm: SERVER_SIGNATURE EQUAL NUMBER  */
#line 951 "cfg.y"
                                                { server_signature=(yyvsp[0].intval); }
#line 4353 "cfg.tab.c"
    break;

  case 178: /* assign_stm: SERVER_SIGNATURE EQUAL error  */
#line 952 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 4359 "cfg.tab.c"
    break;

  case 179: /* assign_stm: SERVER_HEADER EQUAL STRING  */
#line 953 "cfg.y"
                                             { server_header.s=(yyvsp[0].strval);
									server_header.len=strlen((yyvsp[0].strval));
									}
#line 4367 "cfg.tab.c"
    break;

  case 180: /* assign_stm: SERVER_HEADER EQUAL error  */
#line 956 "cfg.y"
                                            { yyerror("string value expected"); }
#line 4373 "cfg.tab.c"
    break;

  case 181: /* assign_stm: USER_AGENT_HEADER EQUAL STRING  */
#line 957 "cfg.y"
                                                 { user_agent_header.s=(yyvsp[0].strval);
									user_agent_header.len=strlen((yyvsp[0].strval));
									}
#line 4381 "cfg.tab.c"
    break;

  case 182: /* assign_stm: USER_AGENT_HEADER EQUAL error  */
#line 960 "cfg.y"
                                                { yyerror("string value expected"); }
#line 4387 "cfg.tab.c"
    break;

  case 183: /* assign_stm: XLOG_BUF_SIZE EQUAL NUMBER  */
#line 961 "cfg.y"
                                             { xlog_buf_size = (yyvsp[0].intval); }
#line 4393 "cfg.tab.c"
    break;

  case 184: /* assign_stm: XLOG_FORCE_COLOR EQUAL NUMBER  */
#line 962 "cfg.y"
                                                { xlog_force_color = (yyvsp[0].intval); }
#line 4399 "cfg.tab.c"
    break;

  case 185: /* assign_stm: XLOG_DEFAULT_LEVEL EQUAL NUMBER  */
#line 963 "cfg.y"
                                                  { xlog_default_level = (yyvsp[0].intval); }
#line 4405 "cfg.tab.c"
    break;

  case 186: /* assign_stm: XLOG_BUF_SIZE EQUAL error  */
#line 964 "cfg.y"
                                            { yyerror("number expected"); }
#line 4411 "cfg.tab.c"
    break;

  case 187: /* assign_stm: XLOG_FORCE_COLOR EQUAL error  */
#line 965 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 4417 "cfg.tab.c"
    break;

  case 188: /* assign_stm: XLOG_DEFAULT_LEVEL EQUAL error  */
#line 966 "cfg.y"
                                                 { yyerror("number expected"); }
#line 4423 "cfg.tab.c"
    break;

  case 189: /* assign_stm: LISTEN EQUAL listen_def  */
#line 967 "cfg.y"
                                          {
							if (add_listener((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listen address\n");
								break;
							}
						}
#line 4435 "cfg.tab.c"
    break;

  case 190: /* assign_stm: LISTEN EQUAL error  */
#line 974 "cfg.y"
                                      { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4443 "cfg.tab.c"
    break;

  case 191: /* assign_stm: MEMGROUP EQUAL STRING COLON multi_string  */
#line 977 "cfg.y"
                                                           {
							/* convert STIRNG ($3) to an ID */
							/* update the memstats type for each module */
							#ifndef SHM_EXTRA_STATS
								LM_CRIT("SHM_EXTRA_STATS not defined");
								YYABORT;
							#else

							#ifdef SHM_SHOW_DEFAULT_GROUP
							if(strcmp((yyvsp[-2].strval), "default") == 0){
								LM_CRIT("default group  name is not allowed");
								YYABORT;
							}
							#endif

							for(tmp_mod = mod_names; tmp_mod; tmp_mod=tmp_mod->next){
								if(strcmp((yyvsp[-2].strval), tmp_mod->s) == 0){
									LM_CRIT("The same mem-group name is used twice: [%s] [%s]\n", (yyvsp[-2].strval), tmp_mod->s);
									YYABORT;
								}
							}

							tmp_mod = pkg_malloc(sizeof(struct multi_str));
							if(!tmp_mod){
								LM_CRIT("out of pkg memory");
								YYABORT;
							}

							tmp_mod->s = (yyvsp[-2].strval);
							tmp_mod->next = mod_names;
							mod_names = tmp_mod;
							for (tmp_mod = (yyvsp[0].multistr); tmp_mod; tmp_mod = tmp_mod->next){
								if(set_mem_idx(tmp_mod->s, mem_free_idx)){
									YYABORT;
								}
							}

							mem_free_idx++;	

							if(alloc_group_stat()){
								YYABORT;
							}
							#endif
						}
#line 4492 "cfg.tab.c"
    break;

  case 192: /* assign_stm: MEMGROUP EQUAL STRING COLON error  */
#line 1021 "cfg.y"
                                                    { yyerror("invalid or no module specified"); }
#line 4498 "cfg.tab.c"
    break;

  case 193: /* assign_stm: ALIAS EQUAL id_lst  */
#line 1022 "cfg.y"
                                      {
							for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next)
								add_alias(lst_tmp->name, strlen(lst_tmp->name),
											lst_tmp->port, lst_tmp->proto);
							  }
#line 4508 "cfg.tab.c"
    break;

  case 194: /* assign_stm: ALIAS EQUAL error  */
#line 1027 "cfg.y"
                                      { yyerror("hostname expected (use quotes"
							" if the hostname includes config keywords)"); }
#line 4515 "cfg.tab.c"
    break;

  case 195: /* assign_stm: AUTO_ALIASES EQUAL NUMBER  */
#line 1029 "cfg.y"
                                            { auto_aliases=(yyvsp[0].intval); }
#line 4521 "cfg.tab.c"
    break;

  case 196: /* assign_stm: AUTO_ALIASES EQUAL error  */
#line 1030 "cfg.y"
                                            { yyerror("number  expected"); }
#line 4527 "cfg.tab.c"
    break;

  case 197: /* assign_stm: ADVERTISED_ADDRESS EQUAL listen_id  */
#line 1031 "cfg.y"
                                                     {
								if ((yyvsp[0].strval)) {
									default_global_address.s=(yyvsp[0].strval);
									default_global_address.len=strlen((yyvsp[0].strval));
								}
								}
#line 4538 "cfg.tab.c"
    break;

  case 198: /* assign_stm: ADVERTISED_ADDRESS EQUAL error  */
#line 1037 "cfg.y"
                                                 {yyerror("ip address or hostname "
												"expected"); }
#line 4545 "cfg.tab.c"
    break;

  case 199: /* assign_stm: ADVERTISED_PORT EQUAL NUMBER  */
#line 1039 "cfg.y"
                                               {
								tmp = int2str((yyvsp[0].intval), &i_tmp);
								if (i_tmp > default_global_port.len)
									default_global_port.s =
									pkg_realloc(default_global_port.s, i_tmp);
								if (!default_global_port.s) {
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								} else {
									default_global_port.len = i_tmp;
									memcpy(default_global_port.s, tmp,
											default_global_port.len);
								}
								}
#line 4564 "cfg.tab.c"
    break;

  case 200: /* assign_stm: ADVERTISED_PORT EQUAL error  */
#line 1053 "cfg.y"
                                             {yyerror("ip address or hostname "
												"expected"); }
#line 4571 "cfg.tab.c"
    break;

  case 201: /* assign_stm: DISABLE_CORE EQUAL NUMBER  */
#line 1055 "cfg.y"
                                            {
										disable_core_dump=(yyvsp[0].intval);
									}
#line 4579 "cfg.tab.c"
    break;

  case 202: /* assign_stm: DISABLE_CORE EQUAL error  */
#line 1058 "cfg.y"
                                           { yyerror("boolean value expected"); }
#line 4585 "cfg.tab.c"
    break;

  case 203: /* assign_stm: OPEN_FD_LIMIT EQUAL NUMBER  */
#line 1059 "cfg.y"
                                             {
										open_files_limit=(yyvsp[0].intval);
									}
#line 4593 "cfg.tab.c"
    break;

  case 204: /* assign_stm: OPEN_FD_LIMIT EQUAL error  */
#line 1062 "cfg.y"
                                            { yyerror("number expected"); }
#line 4599 "cfg.tab.c"
    break;

  case 205: /* assign_stm: MCAST_LOOPBACK EQUAL NUMBER  */
#line 1063 "cfg.y"
                                              {
								#ifdef USE_MCAST
										mcast_loopback=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4611 "cfg.tab.c"
    break;

  case 206: /* assign_stm: MCAST_LOOPBACK EQUAL error  */
#line 1070 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 4617 "cfg.tab.c"
    break;

  case 207: /* assign_stm: MCAST_TTL EQUAL NUMBER  */
#line 1071 "cfg.y"
                                         {
								#ifdef USE_MCAST
										mcast_ttl=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4629 "cfg.tab.c"
    break;

  case 208: /* assign_stm: MCAST_TTL EQUAL error  */
#line 1078 "cfg.y"
                                        { yyerror("number expected as tos"); }
#line 4635 "cfg.tab.c"
    break;

  case 209: /* assign_stm: TOS EQUAL NUMBER  */
#line 1079 "cfg.y"
                                   { tos = (yyvsp[0].intval);
							if (tos<=0)
								yyerror("invalid tos value");
		 }
#line 4644 "cfg.tab.c"
    break;

  case 210: /* assign_stm: TOS EQUAL ID  */
#line 1083 "cfg.y"
                               { if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
								tos=IPTOS_LOWDELAY;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
								tos=IPTOS_THROUGHPUT;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
								tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
								tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
								tos=IPTOS_LOWCOST;
#endif
							} else {
								yyerror("invalid tos value - allowed: "
									"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
									"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
									",IPTOS_LOWCOST"
#endif
#if defined(IPTOS_MINCOST)
									",IPTOS_MINCOST"
#endif
									"\n");
							}
		 }
#line 4676 "cfg.tab.c"
    break;

  case 211: /* assign_stm: TOS EQUAL error  */
#line 1110 "cfg.y"
                                  { yyerror("number expected"); }
#line 4682 "cfg.tab.c"
    break;

  case 212: /* assign_stm: MPATH EQUAL STRING  */
#line 1111 "cfg.y"
                                     { set_mpath((yyvsp[0].strval)); }
#line 4688 "cfg.tab.c"
    break;

  case 213: /* assign_stm: MPATH EQUAL error  */
#line 1112 "cfg.y"
                                     { yyerror("string value expected"); }
#line 4694 "cfg.tab.c"
    break;

  case 214: /* assign_stm: DISABLE_DNS_FAILOVER EQUAL NUMBER  */
#line 1113 "cfg.y"
                                                    {
										disable_dns_failover=(yyvsp[0].intval);
									}
#line 4702 "cfg.tab.c"
    break;

  case 215: /* assign_stm: DISABLE_DNS_FAILOVER error  */
#line 1116 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 4708 "cfg.tab.c"
    break;

  case 216: /* assign_stm: DISABLE_DNS_BLACKLIST EQUAL NUMBER  */
#line 1117 "cfg.y"
                                                     {
										disable_dns_blacklist=(yyvsp[0].intval);
									}
#line 4716 "cfg.tab.c"
    break;

  case 217: /* assign_stm: DISABLE_DNS_BLACKLIST error  */
#line 1120 "cfg.y"
                                              { yyerror("boolean value expected"); }
#line 4722 "cfg.tab.c"
    break;

  case 218: /* assign_stm: DST_BLACKLIST EQUAL ID COLON LBRACE blst_elem_list RBRACE  */
#line 1121 "cfg.y"
                                                                            {
				s_tmp.s = (yyvsp[-4].strval);
				s_tmp.len = strlen((yyvsp[-4].strval));
				if (create_bl_head( BL_CORE_ID, BL_READONLY_LIST,
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4737 "cfg.tab.c"
    break;

  case 219: /* assign_stm: DISABLE_STATELESS_FWD EQUAL NUMBER  */
#line 1131 "cfg.y"
                                                     {
				sl_fwd_disabled=(yyvsp[0].intval);
				}
#line 4745 "cfg.tab.c"
    break;

  case 220: /* assign_stm: DB_VERSION_TABLE EQUAL STRING  */
#line 1134 "cfg.y"
                                                { db_version_table=(yyvsp[0].strval); }
#line 4751 "cfg.tab.c"
    break;

  case 221: /* assign_stm: DB_VERSION_TABLE EQUAL error  */
#line 1135 "cfg.y"
                                               { yyerror("string value expected"); }
#line 4757 "cfg.tab.c"
    break;

  case 222: /* assign_stm: DB_DEFAULT_URL EQUAL STRING  */
#line 1136 "cfg.y"
                                              { db_default_url=(yyvsp[0].strval); }
#line 4763 "cfg.tab.c"
    break;

  case 223: /* assign_stm: DB_DEFAULT_URL EQUAL error  */
#line 1137 "cfg.y"
                                             { yyerror("string value expected"); }
#line 4769 "cfg.tab.c"
    break;

  case 224: /* assign_stm: DB_MAX_ASYNC_CONNECTIONS EQUAL NUMBER  */
#line 1138 "cfg.y"
                                                        { db_max_async_connections=(yyvsp[0].intval); }
#line 4775 "cfg.tab.c"
    break;

  case 225: /* assign_stm: DB_MAX_ASYNC_CONNECTIONS EQUAL error  */
#line 1139 "cfg.y"
                                                       {
				yyerror("integer value expected");
				}
#line 4783 "cfg.tab.c"
    break;

  case 226: /* assign_stm: DISABLE_503_TRANSLATION EQUAL NUMBER  */
#line 1142 "cfg.y"
                                                       { disable_503_translation=(yyvsp[0].intval); }
#line 4789 "cfg.tab.c"
    break;

  case 227: /* assign_stm: DISABLE_503_TRANSLATION EQUAL error  */
#line 1143 "cfg.y"
                                                      {
				yyerror("integer value expected");
				}
#line 4797 "cfg.tab.c"
    break;

  case 228: /* assign_stm: error EQUAL  */
#line 1146 "cfg.y"
                              { yyerror("unknown config variable"); }
#line 4803 "cfg.tab.c"
    break;

  case 229: /* module_stm: LOADMODULE STRING  */
#line 1149 "cfg.y"
                                        {
			if (load_module((yyvsp[0].strval)) < 0)
				yyerrorf("failed to load module %s\n", (yyvsp[0].strval));
		}
#line 4812 "cfg.tab.c"
    break;

  case 230: /* module_stm: LOADMODULE error  */
#line 1153 "cfg.y"
                                        { yyerror("string expected");  }
#line 4818 "cfg.tab.c"
    break;

  case 231: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 1154 "cfg.y"
                                                                          {
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4829 "cfg.tab.c"
    break;

  case 232: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA snumber RPAREN  */
#line 1160 "cfg.y"
                                                                           {
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), INT_PARAM, (void*)(yyvsp[-1].intval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4840 "cfg.tab.c"
    break;

  case 233: /* module_stm: MODPARAM error  */
#line 1166 "cfg.y"
                                 { yyerror("Invalid arguments"); }
#line 4846 "cfg.tab.c"
    break;

  case 234: /* ip: ipv4  */
#line 1170 "cfg.y"
                       { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4852 "cfg.tab.c"
    break;

  case 235: /* ip: ipv6  */
#line 1171 "cfg.y"
                       { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4858 "cfg.tab.c"
    break;

  case 236: /* ipv4: IPV4ADDR  */
#line 1174 "cfg.y"
                 {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv4 address");
						}
					}
				}
#line 4877 "cfg.tab.c"
    break;

  case 237: /* ipv6addr: IPV6ADDR  */
#line 1190 "cfg.y"
                         {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET6;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv6 address");
						}
					}
				}
#line 4896 "cfg.tab.c"
    break;

  case 238: /* ipv6: ipv6addr  */
#line 1206 "cfg.y"
                 { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4902 "cfg.tab.c"
    break;

  case 239: /* ipv6: LBRACK ipv6addr RBRACK  */
#line 1207 "cfg.y"
                                 {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 4908 "cfg.tab.c"
    break;

  case 240: /* folded_string: STRING STRING  */
#line 1210 "cfg.y"
                              {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					yyerror("cfg. parser: out of memory");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4923 "cfg.tab.c"
    break;

  case 241: /* folded_string: folded_string STRING  */
#line 1220 "cfg.y"
                                       {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					LM_CRIT("ERROR: cfg. parser: out of memory.\n");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4938 "cfg.tab.c"
    break;

  case 242: /* route_name: ID  */
#line 1231 "cfg.y"
                {
				(yyval.strval) = (yyvsp[0].strval);
				}
#line 4946 "cfg.tab.c"
    break;

  case 243: /* route_name: NUMBER  */
#line 1234 "cfg.y"
                         {
				tmp=int2str((yyvsp[0].intval), &i_tmp);
				if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
					yyerror("cfg. parser: out of memory.\n");
					YYABORT;
				}
				memcpy( (yyval.strval), tmp, i_tmp);
				(yyval.strval)[i_tmp] = 0;
				}
#line 4960 "cfg.tab.c"
    break;

  case 244: /* route_name: STRING  */
#line 1243 "cfg.y"
                        {
				(yyval.strval) = (yyvsp[0].strval);
		}
#line 4968 "cfg.tab.c"
    break;

  case 245: /* route_stm: ROUTE LBRACE actions RBRACE  */
#line 1248 "cfg.y"
                                        {
						if (rlist[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"request routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &rlist[DEFAULT_RT].a);
					}
#line 4981 "cfg.tab.c"
    break;

  case 246: /* route_stm: ROUTE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1256 "cfg.y"
                                                                       {
						if ( strtol((yyvsp[-4].strval),&tmp,10)==0 && *tmp==0) {
							/* route[0] detected */
							if (rlist[DEFAULT_RT].a!=0) {
								yyerror("overwriting(2) default "
									"request routing table");
								YYABORT;
							}
							push((yyvsp[-1].action), &rlist[DEFAULT_RT].a);
						} else {
							i_tmp = get_script_route_idx((yyvsp[-4].strval),rlist,RT_NO,1);
							if (i_tmp==-1) YYABORT;
							push((yyvsp[-1].action), &rlist[i_tmp].a);
						}
					}
#line 5001 "cfg.tab.c"
    break;

  case 247: /* route_stm: ROUTE error  */
#line 1271 "cfg.y"
                              { yyerror("invalid  route  statement"); }
#line 5007 "cfg.tab.c"
    break;

  case 248: /* failure_route_stm: ROUTE_FAILURE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1274 "cfg.y"
                                                                                {
						i_tmp = get_script_route_idx((yyvsp[-4].strval),failure_rlist,
								FAILURE_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &failure_rlist[i_tmp].a);
					}
#line 5018 "cfg.tab.c"
    break;

  case 249: /* failure_route_stm: ROUTE_FAILURE error  */
#line 1280 "cfg.y"
                                      { yyerror("invalid failure_route statement"); }
#line 5024 "cfg.tab.c"
    break;

  case 250: /* onreply_route_stm: ROUTE_ONREPLY LBRACE actions RBRACE  */
#line 1283 "cfg.y"
                                                       {
						if (onreply_rlist[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"onreply routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &onreply_rlist[DEFAULT_RT].a);
					}
#line 5037 "cfg.tab.c"
    break;

  case 251: /* onreply_route_stm: ROUTE_ONREPLY LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1291 "cfg.y"
                                                                               {
						i_tmp = get_script_route_idx((yyvsp[-4].strval),onreply_rlist,
								ONREPLY_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &onreply_rlist[i_tmp].a);
					}
#line 5048 "cfg.tab.c"
    break;

  case 252: /* onreply_route_stm: ROUTE_ONREPLY error  */
#line 1297 "cfg.y"
                                      { yyerror("invalid onreply_route statement"); }
#line 5054 "cfg.tab.c"
    break;

  case 253: /* branch_route_stm: ROUTE_BRANCH LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1300 "cfg.y"
                                                                              {
						i_tmp = get_script_route_idx((yyvsp[-4].strval),branch_rlist,
								BRANCH_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &branch_rlist[i_tmp].a);
					}
#line 5065 "cfg.tab.c"
    break;

  case 254: /* branch_route_stm: ROUTE_BRANCH error  */
#line 1306 "cfg.y"
                                     { yyerror("invalid branch_route statement"); }
#line 5071 "cfg.tab.c"
    break;

  case 255: /* error_route_stm: ROUTE_ERROR LBRACE actions RBRACE  */
#line 1309 "cfg.y"
                                                    {
						if (error_rlist.a!=0) {
							yyerror("overwriting default "
								"error routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &error_rlist.a);
					}
#line 5084 "cfg.tab.c"
    break;

  case 256: /* error_route_stm: ROUTE_ERROR error  */
#line 1317 "cfg.y"
                                    { yyerror("invalid error_route statement"); }
#line 5090 "cfg.tab.c"
    break;

  case 257: /* local_route_stm: ROUTE_LOCAL LBRACE actions RBRACE  */
#line 1320 "cfg.y"
                                                    {
						if (local_rlist.a!=0) {
							yyerror("re-definition of local "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &local_rlist.a);
					}
#line 5103 "cfg.tab.c"
    break;

  case 258: /* local_route_stm: ROUTE_LOCAL error  */
#line 1328 "cfg.y"
                                    { yyerror("invalid local_route statement"); }
#line 5109 "cfg.tab.c"
    break;

  case 259: /* startup_route_stm: ROUTE_STARTUP LBRACE actions RBRACE  */
#line 1331 "cfg.y"
                                                        {
						if (startup_rlist.a!=0) {
							yyerror("re-definition of startup "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &startup_rlist.a);
					}
#line 5122 "cfg.tab.c"
    break;

  case 260: /* startup_route_stm: ROUTE_STARTUP error  */
#line 1339 "cfg.y"
                                      { yyerror("invalid startup_route statement"); }
#line 5128 "cfg.tab.c"
    break;

  case 261: /* timer_route_stm: ROUTE_TIMER LBRACK route_name COMMA NUMBER RBRACK LBRACE actions RBRACE  */
#line 1342 "cfg.y"
                                                                                          {
						i_tmp = 0;
						while (timer_rlist[i_tmp].a!=0 && i_tmp < TIMER_RT_NO) {
							i_tmp++;
						}
						if(i_tmp == TIMER_RT_NO) {
							yyerror("Too many timer routes defined\n");
							YYABORT;
						}
						timer_rlist[i_tmp].interval = (yyvsp[-4].intval);
						push((yyvsp[-1].action), &timer_rlist[i_tmp].a);
					}
#line 5145 "cfg.tab.c"
    break;

  case 262: /* timer_route_stm: ROUTE_TIMER error  */
#line 1354 "cfg.y"
                                    { yyerror("invalid timer_route statement"); }
#line 5151 "cfg.tab.c"
    break;

  case 263: /* event_route_stm: ROUTE_EVENT LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1358 "cfg.y"
                                                                            {
						i_tmp = 1;
						while (event_rlist[i_tmp].a !=0 && i_tmp < EVENT_RT_NO) {
							if (strcmp((yyvsp[-4].strval), event_rlist[i_tmp].name) == 0) {
								LM_ERR("Script route <%s> redefined\n", (yyvsp[-4].strval));
								YYABORT;
							}
							i_tmp++;
						}

						if (i_tmp == EVENT_RT_NO) {
							yyerror("Too many event routes defined\n");
							YYABORT;
						}

						event_rlist[i_tmp].name = (yyvsp[-4].strval);
						event_rlist[i_tmp].mode = EV_ROUTE_SYNC;

						push((yyvsp[-1].action), &event_rlist[i_tmp].a);
					}
#line 5176 "cfg.tab.c"
    break;

  case 264: /* event_route_stm: ROUTE_EVENT LBRACK route_name COMMA SYNC_TOKEN RBRACK LBRACE actions RBRACE  */
#line 1378 "cfg.y"
                                                                                              {

						i_tmp = 1;
						while (event_rlist[i_tmp].a !=0 && i_tmp < EVENT_RT_NO) {
							if (strcmp((yyvsp[-6].strval), event_rlist[i_tmp].name) == 0) {
								LM_ERR("Script route <%s> redefined\n", (yyvsp[-6].strval));
								YYABORT;
							}
							i_tmp++;
						}

						if (i_tmp == EVENT_RT_NO) {
							yyerror("Too many event routes defined\n");
							YYABORT;
						}

						event_rlist[i_tmp].name = (yyvsp[-6].strval);
						event_rlist[i_tmp].mode = EV_ROUTE_SYNC;

						push((yyvsp[-1].action), &event_rlist[i_tmp].a);
					}
#line 5202 "cfg.tab.c"
    break;

  case 265: /* event_route_stm: ROUTE_EVENT LBRACK route_name COMMA ASYNC_TOKEN RBRACK LBRACE actions RBRACE  */
#line 1399 "cfg.y"
                                                                                               {

						i_tmp = 1;
						while (event_rlist[i_tmp].a !=0 && i_tmp < EVENT_RT_NO) {
							if (strcmp((yyvsp[-6].strval), event_rlist[i_tmp].name) == 0) {
								LM_ERR("Script route <%s> redefined\n", (yyvsp[-6].strval));
								YYABORT;
							}
							i_tmp++;
						}

						if (i_tmp == EVENT_RT_NO) {
							yyerror("Too many event routes defined\n");
							YYABORT;
						}

						event_rlist[i_tmp].name = (yyvsp[-6].strval);
						event_rlist[i_tmp].mode = EV_ROUTE_ASYNC;

						push((yyvsp[-1].action), &event_rlist[i_tmp].a);
					}
#line 5228 "cfg.tab.c"
    break;

  case 266: /* event_route_stm: ROUTE_EVENT error  */
#line 1420 "cfg.y"
                                    { yyerror("invalid event_route statement"); }
#line 5234 "cfg.tab.c"
    break;

  case 267: /* exp: exp AND exp  */
#line 1424 "cfg.y"
                        { (yyval.expr)=mk_exp(AND_OP, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5240 "cfg.tab.c"
    break;

  case 268: /* exp: exp OR exp  */
#line 1425 "cfg.y"
                                { (yyval.expr)=mk_exp(OR_OP, (yyvsp[-2].expr), (yyvsp[0].expr));  }
#line 5246 "cfg.tab.c"
    break;

  case 269: /* exp: NOT exp  */
#line 1426 "cfg.y"
                                        { (yyval.expr)=mk_exp(NOT_OP, (yyvsp[0].expr), 0);  }
#line 5252 "cfg.tab.c"
    break;

  case 270: /* exp: LPAREN exp RPAREN  */
#line 1427 "cfg.y"
                                { (yyval.expr)=mk_exp(EVAL_OP, (yyvsp[-1].expr), 0); }
#line 5258 "cfg.tab.c"
    break;

  case 271: /* exp: LBRACK assignexp RBRACK  */
#line 1428 "cfg.y"
                                  { (yyval.expr)=(yyvsp[-1].expr); }
#line 5264 "cfg.tab.c"
    break;

  case 272: /* exp: exp_elem  */
#line 1429 "cfg.y"
                                        { (yyval.expr)=(yyvsp[0].expr); }
#line 5270 "cfg.tab.c"
    break;

  case 273: /* equalop: EQUAL_T  */
#line 1432 "cfg.y"
                          {(yyval.intval)=EQUAL_OP; }
#line 5276 "cfg.tab.c"
    break;

  case 274: /* equalop: DIFF  */
#line 1433 "cfg.y"
                                {(yyval.intval)=DIFF_OP; }
#line 5282 "cfg.tab.c"
    break;

  case 275: /* compop: GT  */
#line 1436 "cfg.y"
                {(yyval.intval)=GT_OP; }
#line 5288 "cfg.tab.c"
    break;

  case 276: /* compop: LT  */
#line 1437 "cfg.y"
                        {(yyval.intval)=LT_OP; }
#line 5294 "cfg.tab.c"
    break;

  case 277: /* compop: GTE  */
#line 1438 "cfg.y"
                        {(yyval.intval)=GTE_OP; }
#line 5300 "cfg.tab.c"
    break;

  case 278: /* compop: LTE  */
#line 1439 "cfg.y"
                        {(yyval.intval)=LTE_OP; }
#line 5306 "cfg.tab.c"
    break;

  case 279: /* matchop: MATCH  */
#line 1441 "cfg.y"
                {(yyval.intval)=MATCH_OP; }
#line 5312 "cfg.tab.c"
    break;

  case 280: /* matchop: NOTMATCH  */
#line 1442 "cfg.y"
                                {(yyval.intval)=NOTMATCH_OP; }
#line 5318 "cfg.tab.c"
    break;

  case 281: /* intop: equalop  */
#line 1445 "cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 5324 "cfg.tab.c"
    break;

  case 282: /* intop: compop  */
#line 1446 "cfg.y"
                        {(yyval.intval)=(yyvsp[0].intval); }
#line 5330 "cfg.tab.c"
    break;

  case 283: /* strop: equalop  */
#line 1449 "cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 5336 "cfg.tab.c"
    break;

  case 284: /* strop: compop  */
#line 1450 "cfg.y"
                     {(yyval.intval)=(yyvsp[0].intval); }
#line 5342 "cfg.tab.c"
    break;

  case 285: /* strop: matchop  */
#line 1451 "cfg.y"
                                {(yyval.intval)=(yyvsp[0].intval); }
#line 5348 "cfg.tab.c"
    break;

  case 286: /* script_var: SCRIPTVAR  */
#line 1455 "cfg.y"
                                {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				if (spec==NULL){
					yyerror("no more pkg memory\n");
					YYABORT;
				}
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[0].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable");
				}

				(yyval.specval) = spec;
			}
#line 5369 "cfg.tab.c"
    break;

  case 287: /* script_var: SCRIPTVARERR  */
#line 1471 "cfg.y"
                               {
			(yyval.specval)=0; yyerror("invalid script variable name");
		}
#line 5377 "cfg.tab.c"
    break;

  case 288: /* exp_elem: exp_cond  */
#line 1476 "cfg.y"
                                {(yyval.expr)=(yyvsp[0].expr); }
#line 5383 "cfg.tab.c"
    break;

  case 289: /* exp_elem: exp_stm  */
#line 1477 "cfg.y"
                                        {(yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5389 "cfg.tab.c"
    break;

  case 290: /* exp_elem: snumber  */
#line 1478 "cfg.y"
                                        {(yyval.expr)=mk_elem( NO_OP, NUMBER_O, 0, NUMBER_ST,
											(void*)(yyvsp[0].intval) ); }
#line 5396 "cfg.tab.c"
    break;

  case 291: /* exp_elem: script_var  */
#line 1480 "cfg.y"
                                {
				(yyval.expr)=mk_elem(NO_OP, SCRIPTVAR_O,0,SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5404 "cfg.tab.c"
    break;

  case 292: /* exp_cond: script_var strop script_var  */
#line 1485 "cfg.y"
                                      {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5412 "cfg.tab.c"
    break;

  case 293: /* exp_cond: script_var strop STRING  */
#line 1488 "cfg.y"
                                          {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),STR_ST,(yyvsp[0].strval));
			}
#line 5420 "cfg.tab.c"
    break;

  case 294: /* exp_cond: script_var intop snumber  */
#line 1491 "cfg.y"
                                           {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),NUMBER_ST,(void *)(yyvsp[0].intval));
			}
#line 5428 "cfg.tab.c"
    break;

  case 295: /* exp_cond: script_var equalop NULLV  */
#line 1494 "cfg.y"
                                                {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval), NULLV_ST, 0);
			}
#line 5436 "cfg.tab.c"
    break;

  case 296: /* exp_cond: script_var equalop ipnet  */
#line 1497 "cfg.y"
                                           {
				(yyval.expr)=mk_elem((yyvsp[-1].intval), SCRIPTVAR_O, (void*)(yyvsp[-2].specval), NET_ST, (yyvsp[0].ipnet));
			}
#line 5444 "cfg.tab.c"
    break;

  case 297: /* ipnet: IPNET  */
#line 1504 "cfg.y"
                {
				if (parse_ipnet((yyvsp[0].strval), strlen((yyvsp[0].strval)), &net_tmp) < 0)
					yyerror("unable to parse ip and/or netmask\n");

				(yyval.ipnet) = net_tmp;
			}
#line 5455 "cfg.tab.c"
    break;

  case 298: /* ipnet: ip  */
#line 1510 "cfg.y"
                        { (yyval.ipnet)=mk_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8); }
#line 5461 "cfg.tab.c"
    break;

  case 299: /* host_sep: DOT  */
#line 1514 "cfg.y"
                    {(yyval.strval)=".";}
#line 5467 "cfg.tab.c"
    break;

  case 300: /* host_sep: MINUS  */
#line 1515 "cfg.y"
                              {(yyval.strval)="-"; }
#line 5473 "cfg.tab.c"
    break;

  case 301: /* host: ID  */
#line 1518 "cfg.y"
                                        { (yyval.strval)=(yyvsp[0].strval); }
#line 5479 "cfg.tab.c"
    break;

  case 302: /* host: host host_sep ID  */
#line 1519 "cfg.y"
                                { (yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
						  if ((yyval.strval)==0){
							LM_CRIT("cfg. parser: memory allocation"
										" failure while parsing host\n");
							YYABORT;
						  }else{
							memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))]=*(yyvsp[-1].strval);
							memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
						  }
						  pkg_free((yyvsp[-2].strval)); pkg_free((yyvsp[0].strval));
						}
#line 5497 "cfg.tab.c"
    break;

  case 303: /* host: host DOT error  */
#line 1532 "cfg.y"
                         { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname (use quotes if hostname has config keywords)"); }
#line 5503 "cfg.tab.c"
    break;

  case 304: /* assignop: EQUAL  */
#line 1536 "cfg.y"
              { (yyval.intval) = EQ_T; }
#line 5509 "cfg.tab.c"
    break;

  case 305: /* assignop: COLONEQ  */
#line 1537 "cfg.y"
                  { (yyval.intval) = COLONEQ_T; }
#line 5515 "cfg.tab.c"
    break;

  case 306: /* assignop: PLUSEQ  */
#line 1538 "cfg.y"
                 { (yyval.intval) = PLUSEQ_T; }
#line 5521 "cfg.tab.c"
    break;

  case 307: /* assignop: MINUSEQ  */
#line 1539 "cfg.y"
                  { (yyval.intval) = MINUSEQ_T;}
#line 5527 "cfg.tab.c"
    break;

  case 308: /* assignop: SLASHEQ  */
#line 1540 "cfg.y"
                  { (yyval.intval) = DIVEQ_T; }
#line 5533 "cfg.tab.c"
    break;

  case 309: /* assignop: MULTEQ  */
#line 1541 "cfg.y"
                 { (yyval.intval) = MULTEQ_T; }
#line 5539 "cfg.tab.c"
    break;

  case 310: /* assignop: MODULOEQ  */
#line 1542 "cfg.y"
                   { (yyval.intval) = MODULOEQ_T; }
#line 5545 "cfg.tab.c"
    break;

  case 311: /* assignop: BANDEQ  */
#line 1543 "cfg.y"
                 { (yyval.intval) = BANDEQ_T; }
#line 5551 "cfg.tab.c"
    break;

  case 312: /* assignop: BOREQ  */
#line 1544 "cfg.y"
                { (yyval.intval) = BOREQ_T; }
#line 5557 "cfg.tab.c"
    break;

  case 313: /* assignop: BXOREQ  */
#line 1545 "cfg.y"
                 { (yyval.intval) = BXOREQ_T; }
#line 5563 "cfg.tab.c"
    break;

  case 314: /* assignexp: snumber  */
#line 1549 "cfg.y"
                { (yyval.expr) = mk_elem(VALUE_OP, NUMBERV_O, (void*)(yyvsp[0].intval), 0, 0); }
#line 5569 "cfg.tab.c"
    break;

  case 315: /* assignexp: STRING  */
#line 1550 "cfg.y"
                 { (yyval.expr) = mk_elem(VALUE_OP, STRINGV_O, (yyvsp[0].strval), 0, 0); }
#line 5575 "cfg.tab.c"
    break;

  case 316: /* assignexp: script_var  */
#line 1551 "cfg.y"
                     { (yyval.expr) = mk_elem(VALUE_OP, SCRIPTVAR_O, (yyvsp[0].specval), 0, 0); }
#line 5581 "cfg.tab.c"
    break;

  case 317: /* assignexp: exp_cond  */
#line 1552 "cfg.y"
                   { (yyval.expr)= (yyvsp[0].expr); }
#line 5587 "cfg.tab.c"
    break;

  case 318: /* assignexp: cmd  */
#line 1553 "cfg.y"
              { (yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5593 "cfg.tab.c"
    break;

  case 319: /* assignexp: assignexp PLUS assignexp  */
#line 1554 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(PLUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5601 "cfg.tab.c"
    break;

  case 320: /* assignexp: assignexp MINUS assignexp  */
#line 1557 "cfg.y"
                                    {
				(yyval.expr) = mk_elem(MINUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5609 "cfg.tab.c"
    break;

  case 321: /* assignexp: assignexp MULT assignexp  */
#line 1560 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(MULT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5617 "cfg.tab.c"
    break;

  case 322: /* assignexp: assignexp SLASH assignexp  */
#line 1563 "cfg.y"
                                    {
				(yyval.expr) = mk_elem(DIV_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5625 "cfg.tab.c"
    break;

  case 323: /* assignexp: assignexp MODULO assignexp  */
#line 1566 "cfg.y"
                                     {
				(yyval.expr) = mk_elem(MODULO_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5633 "cfg.tab.c"
    break;

  case 324: /* assignexp: assignexp BAND assignexp  */
#line 1569 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(BAND_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5641 "cfg.tab.c"
    break;

  case 325: /* assignexp: assignexp BOR assignexp  */
#line 1572 "cfg.y"
                                  {
				(yyval.expr) = mk_elem(BOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5649 "cfg.tab.c"
    break;

  case 326: /* assignexp: assignexp BXOR assignexp  */
#line 1575 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(BXOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5657 "cfg.tab.c"
    break;

  case 327: /* assignexp: assignexp BLSHIFT assignexp  */
#line 1578 "cfg.y"
                                      {
				(yyval.expr) = mk_elem(BLSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5665 "cfg.tab.c"
    break;

  case 328: /* assignexp: assignexp BRSHIFT assignexp  */
#line 1581 "cfg.y"
                                      {
				(yyval.expr) = mk_elem(BRSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5673 "cfg.tab.c"
    break;

  case 329: /* assignexp: BNOT assignexp  */
#line 1584 "cfg.y"
                         {
				(yyval.expr) = mk_elem(BNOT_OP, EXPR_O, (yyvsp[0].expr), 0, 0);
			}
#line 5681 "cfg.tab.c"
    break;

  case 330: /* assignexp: LPAREN assignexp RPAREN  */
#line 1587 "cfg.y"
                                  { (yyval.expr) = (yyvsp[-1].expr); }
#line 5687 "cfg.tab.c"
    break;

  case 331: /* assign_cmd: script_var assignop assignexp  */
#line 1590 "cfg.y"
                                          {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), (yyvsp[-1].intval),
					SCRIPTVAR_ST,
					EXPR_ST,
					(yyvsp[-2].specval),
					(yyvsp[0].expr));
		}
#line 5705 "cfg.tab.c"
    break;

  case 332: /* assign_cmd: script_var EQUAL NULLV  */
#line 1603 "cfg.y"
                                  {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), EQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5723 "cfg.tab.c"
    break;

  case 333: /* assign_cmd: script_var COLONEQ NULLV  */
#line 1616 "cfg.y"
                                    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			/* not all can get NULL with := */
			switch((yyvsp[-2].specval)->type) {
				case PVT_AVP:
				break;
				default:
					yyerror("invalid left operand in NULL assignment");
			}
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), COLONEQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5748 "cfg.tab.c"
    break;

  case 334: /* exp_stm: cmd  */
#line 1638 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5754 "cfg.tab.c"
    break;

  case 335: /* exp_stm: if_cmd  */
#line 1639 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5760 "cfg.tab.c"
    break;

  case 336: /* exp_stm: assign_cmd  */
#line 1640 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5766 "cfg.tab.c"
    break;

  case 337: /* exp_stm: LBRACE actions RBRACE  */
#line 1641 "cfg.y"
                                                { (yyval.action)=(yyvsp[-1].action); }
#line 5772 "cfg.tab.c"
    break;

  case 338: /* exp_stm: LBRACE RBRACE  */
#line 1642 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5778 "cfg.tab.c"
    break;

  case 339: /* stm: action  */
#line 1645 "cfg.y"
                                                        { (yyval.action)=(yyvsp[0].action); }
#line 5784 "cfg.tab.c"
    break;

  case 340: /* stm: LBRACE actions RBRACE  */
#line 1646 "cfg.y"
                                                { (yyval.action)=(yyvsp[-1].action); }
#line 5790 "cfg.tab.c"
    break;

  case 341: /* stm: LBRACE RBRACE  */
#line 1647 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5796 "cfg.tab.c"
    break;

  case 342: /* actions: actions action  */
#line 1650 "cfg.y"
                                {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5802 "cfg.tab.c"
    break;

  case 343: /* actions: action  */
#line 1651 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5808 "cfg.tab.c"
    break;

  case 344: /* actions: actions error  */
#line 1652 "cfg.y"
                                { (yyval.action)=0; yyerror("bad command!)"); }
#line 5814 "cfg.tab.c"
    break;

  case 345: /* action: cmd SEMICOLON  */
#line 1655 "cfg.y"
                              {(yyval.action)=(yyvsp[-1].action);}
#line 5820 "cfg.tab.c"
    break;

  case 346: /* action: if_cmd  */
#line 1656 "cfg.y"
                         {(yyval.action)=(yyvsp[0].action);}
#line 5826 "cfg.tab.c"
    break;

  case 347: /* action: while_cmd  */
#line 1657 "cfg.y"
                            { (yyval.action)=(yyvsp[0].action);}
#line 5832 "cfg.tab.c"
    break;

  case 348: /* action: foreach_cmd  */
#line 1658 "cfg.y"
                              { (yyval.action)=(yyvsp[0].action);}
#line 5838 "cfg.tab.c"
    break;

  case 349: /* action: switch_cmd  */
#line 1659 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5844 "cfg.tab.c"
    break;

  case 350: /* action: assign_cmd SEMICOLON  */
#line 1660 "cfg.y"
                                       {(yyval.action)=(yyvsp[-1].action);}
#line 5850 "cfg.tab.c"
    break;

  case 351: /* action: SEMICOLON  */
#line 1661 "cfg.y"
                                              {(yyval.action)=0;}
#line 5856 "cfg.tab.c"
    break;

  case 352: /* action: cmd error  */
#line 1662 "cfg.y"
                            { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5862 "cfg.tab.c"
    break;

  case 353: /* if_cmd: IF exp stm  */
#line 1665 "cfg.y"
                                                        { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-1].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 5875 "cfg.tab.c"
    break;

  case 354: /* if_cmd: IF exp stm ELSE stm  */
#line 1673 "cfg.y"
                                                { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-3].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 5888 "cfg.tab.c"
    break;

  case 355: /* while_cmd: WHILE exp stm  */
#line 1683 "cfg.y"
                                                                { mk_action2( (yyval.action), WHILE_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 (yyvsp[-1].expr),
													 (yyvsp[0].action));
									}
#line 5899 "cfg.tab.c"
    break;

  case 356: /* foreach_cmd: FOR LPAREN script_var IN script_var RPAREN stm  */
#line 1691 "cfg.y"
                                                               {
					if ((yyvsp[-4].specval)->type != PVT_SCRIPTVAR &&
					    (yyvsp[-4].specval)->type != PVT_AVP &&
						pv_type((yyvsp[-4].specval)->type) != PVT_JSON) {
						yyerror("\nfor-each statement: only \"var\", \"avp\" "
					            "and \"json\" iterators are supported!");
					}

					mk_action3( (yyval.action), FOR_EACH_T,
					            SCRIPTVAR_ST,
					            SCRIPTVAR_ST,
					            ACTIONS_ST,
					            (yyvsp[-4].specval),
					            (yyvsp[-2].specval),
					            (yyvsp[0].action));
					}
#line 5920 "cfg.tab.c"
    break;

  case 357: /* switch_cmd: SWITCH LPAREN script_var RPAREN LBRACE switch_stm RBRACE  */
#line 1709 "cfg.y"
                                                                                        {
											mk_action2( (yyval.action), SWITCH_T,
														SCRIPTVAR_ST,
														ACTIONS_ST,
														(yyvsp[-4].specval),
														(yyvsp[-1].action));
									}
#line 5932 "cfg.tab.c"
    break;

  case 358: /* switch_stm: case_stms default_stm  */
#line 1718 "cfg.y"
                                  { (yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5938 "cfg.tab.c"
    break;

  case 359: /* switch_stm: case_stms  */
#line 1719 "cfg.y"
                                                { (yyval.action)=(yyvsp[0].action); }
#line 5944 "cfg.tab.c"
    break;

  case 360: /* case_stms: case_stms case_stm  */
#line 1721 "cfg.y"
                                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5950 "cfg.tab.c"
    break;

  case 361: /* case_stms: case_stm  */
#line 1722 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5956 "cfg.tab.c"
    break;

  case 362: /* case_stm: CASE snumber COLON actions SBREAK SEMICOLON  */
#line 1726 "cfg.y"
                                                                                { mk_action3( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-4].intval),
													(yyvsp[-2].action),
													(void*)1);
											}
#line 5969 "cfg.tab.c"
    break;

  case 363: /* case_stm: CASE snumber COLON SBREAK SEMICOLON  */
#line 1735 "cfg.y"
                                                                                { mk_action3( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-3].intval),
													0,
													(void*)1);
											}
#line 5982 "cfg.tab.c"
    break;

  case 364: /* case_stm: CASE snumber COLON actions  */
#line 1743 "cfg.y"
                                             { mk_action3( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-2].intval),
													(yyvsp[0].action),
													(void*)0);
									}
#line 5995 "cfg.tab.c"
    break;

  case 365: /* case_stm: CASE snumber COLON  */
#line 1751 "cfg.y"
                                     { mk_action3( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-1].intval),
													0,
													(void*)0);
							}
#line 6008 "cfg.tab.c"
    break;

  case 366: /* case_stm: CASE STRING COLON actions SBREAK SEMICOLON  */
#line 1760 "cfg.y"
                                                                                { mk_action3( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-4].strval),
													(yyvsp[-2].action),
													(void*)1);
											}
#line 6021 "cfg.tab.c"
    break;

  case 367: /* case_stm: CASE STRING COLON SBREAK SEMICOLON  */
#line 1769 "cfg.y"
                                                                                { mk_action3( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-3].strval),
													0,
													(void*)1);
											}
#line 6034 "cfg.tab.c"
    break;

  case 368: /* case_stm: CASE STRING COLON actions  */
#line 1777 "cfg.y"
                                            { mk_action3( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-2].strval),
													(yyvsp[0].action),
													(void*)0);
									}
#line 6047 "cfg.tab.c"
    break;

  case 369: /* case_stm: CASE STRING COLON  */
#line 1785 "cfg.y"
                                    { mk_action3( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-1].strval),
													0,
													(void*)0);
							}
#line 6060 "cfg.tab.c"
    break;

  case 370: /* default_stm: DEFAULT COLON actions  */
#line 1796 "cfg.y"
                                   { mk_action2( (yyval.action), DEFAULT_T,
													ACTIONS_ST,
													0,
													(yyvsp[0].action),
													0);
									}
#line 6071 "cfg.tab.c"
    break;

  case 371: /* default_stm: DEFAULT COLON  */
#line 1802 "cfg.y"
                                { mk_action2( (yyval.action), DEFAULT_T,
													ACTIONS_ST,
													0,
													0,
													0);
									}
#line 6082 "cfg.tab.c"
    break;

  case 372: /* module_func_param: STRING  */
#line 1810 "cfg.y"
                          {
										elems[1].type = STRING_ST;
										elems[1].u.data = (yyvsp[0].strval);
										(yyval.intval)=1;
										}
#line 6092 "cfg.tab.c"
    break;

  case 373: /* module_func_param: module_func_param COMMA STRING  */
#line 1815 "cfg.y"
                                                 {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = STRING_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].strval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6107 "cfg.tab.c"
    break;

  case 374: /* module_func_param: COMMA  */
#line 1825 "cfg.y"
                        {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NULLV_ST;
										elems[2].u.data = NULL;
										(yyval.intval)=2;
										}
#line 6119 "cfg.tab.c"
    break;

  case 375: /* module_func_param: COMMA STRING  */
#line 1832 "cfg.y"
                               {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = STRING_ST;
										elems[2].u.data = (yyvsp[0].strval);
										(yyval.intval)=2;
										}
#line 6131 "cfg.tab.c"
    break;

  case 376: /* module_func_param: module_func_param COMMA  */
#line 1839 "cfg.y"
                                          {
										if ((yyvsp[-1].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-1].intval)+1].type = NULLV_ST;
										elems[(yyvsp[-1].intval)+1].u.data = NULL;
										(yyval.intval)=(yyvsp[-1].intval)+1;
										}
#line 6146 "cfg.tab.c"
    break;

  case 377: /* module_func_param: NUMBER  */
#line 1849 "cfg.y"
                         {
										(yyval.intval)=0;
										yyerror("numbers used as parameters -"
											" they should be quoted");
										}
#line 6156 "cfg.tab.c"
    break;

  case 378: /* module_func_param: COMMA NUMBER  */
#line 1854 "cfg.y"
                               {
										(yyval.intval)=0;
										yyerror("numbers used as parameters -"
											" they should be quoted");
										}
#line 6166 "cfg.tab.c"
    break;

  case 379: /* module_func_param: module_func_param COMMA NUMBER  */
#line 1859 "cfg.y"
                                                 {
										(yyval.intval)=0;
										yyerror("numbers used as parameters -"
											" they should be quoted");
										}
#line 6176 "cfg.tab.c"
    break;

  case 380: /* route_param: STRING  */
#line 1866 "cfg.y"
                    {
						route_elems[0].type = STRING_ST;
						route_elems[0].u.string = (yyvsp[0].strval);
						(yyval.intval)=1;
			}
#line 6186 "cfg.tab.c"
    break;

  case 381: /* route_param: snumber  */
#line 1871 "cfg.y"
                          {
						route_elems[0].type = NUMBER_ST;
						route_elems[0].u.number = (long)(yyvsp[0].intval);
						(yyval.intval)=1;
			}
#line 6196 "cfg.tab.c"
    break;

  case 382: /* route_param: NULLV  */
#line 1876 "cfg.y"
                        {
						route_elems[0].type = NULLV_ST;
						route_elems[0].u.data = 0;
						(yyval.intval)=1;
			}
#line 6206 "cfg.tab.c"
    break;

  case 383: /* route_param: script_var  */
#line 1881 "cfg.y"
                             {
						route_elems[0].type = SCRIPTVAR_ST;
						route_elems[0].u.data = (yyvsp[0].specval);
						(yyval.intval)=1;
			}
#line 6216 "cfg.tab.c"
    break;

  case 384: /* route_param: route_param COMMA STRING  */
#line 1886 "cfg.y"
                                           {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = STRING_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].strval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6231 "cfg.tab.c"
    break;

  case 385: /* route_param: route_param COMMA snumber  */
#line 1896 "cfg.y"
                                            {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NUMBER_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (void*)(long)(yyvsp[0].intval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6246 "cfg.tab.c"
    break;

  case 386: /* route_param: route_param COMMA script_var  */
#line 1906 "cfg.y"
                                               {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = SCRIPTVAR_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].specval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6261 "cfg.tab.c"
    break;

  case 387: /* route_param: route_param COMMA NULLV  */
#line 1916 "cfg.y"
                                          {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NULLV_ST;
							route_elems[(yyvsp[-2].intval)].u.data = 0;
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6276 "cfg.tab.c"
    break;

  case 388: /* async_func: ID LPAREN RPAREN  */
#line 1928 "cfg.y"
                             {
				cmd_tmp=(void*)find_acmd_export_t((yyvsp[-2].strval), 0);
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-2].strval));
					(yyval.action)=0;
				}else{
					elems[0].type = ACMD_ST;
					elems[0].u.data = cmd_tmp;
					mk_action_((yyval.action), AMODULE_T, 1, elems);
				}
			}
#line 6293 "cfg.tab.c"
    break;

  case 389: /* async_func: ID LPAREN module_func_param RPAREN  */
#line 1940 "cfg.y"
                                                             {
				cmd_tmp=(void*)find_acmd_export_t((yyvsp[-3].strval), (yyvsp[-1].intval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-3].strval));
					(yyval.action)=0;
				}else{
					elems[0].type = ACMD_ST;
					elems[0].u.data = cmd_tmp;
					mk_action_((yyval.action), AMODULE_T, (yyvsp[-1].intval)+1, elems);
				}
			}
#line 6310 "cfg.tab.c"
    break;

  case 390: /* async_func: ID LPAREN error RPAREN  */
#line 1952 "cfg.y"
                                                 {
				(yyval.action)=0;
				yyerrorf("bad arguments for command <%s>", (yyvsp[-3].strval));
			}
#line 6319 "cfg.tab.c"
    break;

  case 391: /* async_func: ID error  */
#line 1956 "cfg.y"
                                   {
				(yyval.action)=0;
				yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6328 "cfg.tab.c"
    break;

  case 392: /* cmd: FORWARD LPAREN STRING RPAREN  */
#line 1962 "cfg.y"
                                        { mk_action2( (yyval.action), FORWARD_T,
											STRING_ST,
											0,
											(yyvsp[-1].strval),
											0);
										}
#line 6339 "cfg.tab.c"
    break;

  case 393: /* cmd: FORWARD LPAREN RPAREN  */
#line 1968 "cfg.y"
                                        {
										mk_action2( (yyval.action), FORWARD_T,
											0,
											0,
											0,
											0);
										}
#line 6351 "cfg.tab.c"
    break;

  case 394: /* cmd: FORWARD error  */
#line 1975 "cfg.y"
                                { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6357 "cfg.tab.c"
    break;

  case 395: /* cmd: FORWARD LPAREN error RPAREN  */
#line 1976 "cfg.y"
                                              { (yyval.action)=0; yyerror("bad forward "
										"argument"); }
#line 6364 "cfg.tab.c"
    break;

  case 396: /* cmd: SEND LPAREN STRING RPAREN  */
#line 1979 "cfg.y"
                                            { mk_action2( (yyval.action), SEND_T,
											STRING_ST,
											0,
											(yyvsp[-1].strval),
											0);
										}
#line 6375 "cfg.tab.c"
    break;

  case 397: /* cmd: SEND LPAREN STRING COMMA STRING RPAREN  */
#line 1985 "cfg.y"
                                                         { mk_action2( (yyval.action), SEND_T,
											STRING_ST,
											STRING_ST,
											(yyvsp[-3].strval),
											(yyvsp[-1].strval));
										}
#line 6386 "cfg.tab.c"
    break;

  case 398: /* cmd: SEND error  */
#line 1991 "cfg.y"
                             { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6392 "cfg.tab.c"
    break;

  case 399: /* cmd: SEND LPAREN error RPAREN  */
#line 1992 "cfg.y"
                                           { (yyval.action)=0; yyerror("bad send"
													"argument"); }
#line 6399 "cfg.tab.c"
    break;

  case 400: /* cmd: ASSERT LPAREN exp COMMA STRING RPAREN  */
#line 1994 "cfg.y"
                                                         {
			mk_action2( (yyval.action), ASSERT_T, EXPR_ST, STRING_ST, (yyvsp[-3].expr), (yyvsp[-1].strval));
			}
#line 6407 "cfg.tab.c"
    break;

  case 401: /* cmd: DROP LPAREN RPAREN  */
#line 1997 "cfg.y"
                                        {mk_action2( (yyval.action), DROP_T,0, 0, 0, 0); }
#line 6413 "cfg.tab.c"
    break;

  case 402: /* cmd: DROP  */
#line 1998 "cfg.y"
                                                        {mk_action2( (yyval.action), DROP_T,0, 0, 0, 0); }
#line 6419 "cfg.tab.c"
    break;

  case 403: /* cmd: EXIT LPAREN RPAREN  */
#line 1999 "cfg.y"
                                        {mk_action2( (yyval.action), EXIT_T,0, 0, 0, 0); }
#line 6425 "cfg.tab.c"
    break;

  case 404: /* cmd: EXIT  */
#line 2000 "cfg.y"
                                                        {mk_action2( (yyval.action), EXIT_T,0, 0, 0, 0); }
#line 6431 "cfg.tab.c"
    break;

  case 405: /* cmd: RETURN LPAREN snumber RPAREN  */
#line 2001 "cfg.y"
                                                {mk_action2( (yyval.action), RETURN_T,
																NUMBER_ST,
																0,
																(void*)(yyvsp[-1].intval),
																0);
												}
#line 6442 "cfg.tab.c"
    break;

  case 406: /* cmd: RETURN LPAREN script_var RPAREN  */
#line 2007 "cfg.y"
                                                        {mk_action2( (yyval.action), RETURN_T,
																SCRIPTVAR_ST,
																0,
																(void*)(yyvsp[-1].specval),
																0);
												}
#line 6453 "cfg.tab.c"
    break;

  case 407: /* cmd: RETURN LPAREN RPAREN  */
#line 2013 "cfg.y"
                                        {mk_action2( (yyval.action), RETURN_T,
																NUMBER_ST,
																0,
																(void*)1,
																0);
												}
#line 6464 "cfg.tab.c"
    break;

  case 408: /* cmd: RETURN  */
#line 2019 "cfg.y"
                                                        {mk_action2( (yyval.action), RETURN_T,
																NUMBER_ST,
																0,
																(void*)1,
																0);
												}
#line 6475 "cfg.tab.c"
    break;

  case 409: /* cmd: LOG_TOK LPAREN STRING RPAREN  */
#line 2025 "cfg.y"
                                                {mk_action2( (yyval.action), LOG_T, NUMBER_ST,
													STRING_ST,(void*)4,(yyvsp[-1].strval));
									}
#line 6483 "cfg.tab.c"
    break;

  case 410: /* cmd: LOG_TOK LPAREN snumber COMMA STRING RPAREN  */
#line 2028 "cfg.y"
                                                                {mk_action2( (yyval.action), LOG_T,
																NUMBER_ST,
																STRING_ST,
																(void*)(yyvsp[-3].intval),
																(yyvsp[-1].strval));
												}
#line 6494 "cfg.tab.c"
    break;

  case 411: /* cmd: LOG_TOK error  */
#line 2034 "cfg.y"
                                { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6500 "cfg.tab.c"
    break;

  case 412: /* cmd: LOG_TOK LPAREN error RPAREN  */
#line 2035 "cfg.y"
                                              { (yyval.action)=0; yyerror("bad log"
									"argument"); }
#line 6507 "cfg.tab.c"
    break;

  case 413: /* cmd: SETFLAG LPAREN NUMBER RPAREN  */
#line 2037 "cfg.y"
                                               {
			mk_action2((yyval.action), SETFLAG_T, NUMBER_ST, 0, (void *)(yyvsp[-1].intval), 0 );
			}
#line 6515 "cfg.tab.c"
    break;

  case 414: /* cmd: SETFLAG LPAREN ID RPAREN  */
#line 2040 "cfg.y"
                                           {mk_action2((yyval.action), SETFLAG_T, STR_ST, 0,
													(void *)(yyvsp[-1].strval), 0 ); }
#line 6522 "cfg.tab.c"
    break;

  case 415: /* cmd: SETFLAG error  */
#line 2042 "cfg.y"
                                { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 6528 "cfg.tab.c"
    break;

  case 416: /* cmd: RESETFLAG LPAREN NUMBER RPAREN  */
#line 2043 "cfg.y"
                                                 {mk_action2( (yyval.action), RESETFLAG_T,
										NUMBER_ST, 0, (void *)(yyvsp[-1].intval), 0 ); }
#line 6535 "cfg.tab.c"
    break;

  case 417: /* cmd: RESETFLAG LPAREN ID RPAREN  */
#line 2045 "cfg.y"
                                             {mk_action2( (yyval.action), RESETFLAG_T,
										STR_ST, 0, (void *)(yyvsp[-1].strval), 0 ); }
#line 6542 "cfg.tab.c"
    break;

  case 418: /* cmd: RESETFLAG error  */
#line 2047 "cfg.y"
                                  { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 6548 "cfg.tab.c"
    break;

  case 419: /* cmd: ISFLAGSET LPAREN NUMBER RPAREN  */
#line 2048 "cfg.y"
                                                 {mk_action2( (yyval.action), ISFLAGSET_T,
										NUMBER_ST, 0, (void *)(yyvsp[-1].intval), 0 ); }
#line 6555 "cfg.tab.c"
    break;

  case 420: /* cmd: ISFLAGSET LPAREN ID RPAREN  */
#line 2050 "cfg.y"
                                             {mk_action2( (yyval.action), ISFLAGSET_T,
										STR_ST, 0, (void *)(yyvsp[-1].strval), 0 ); }
#line 6562 "cfg.tab.c"
    break;

  case 421: /* cmd: ISFLAGSET error  */
#line 2052 "cfg.y"
                                  { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 6568 "cfg.tab.c"
    break;

  case 422: /* cmd: SETBFLAG LPAREN NUMBER COMMA NUMBER RPAREN  */
#line 2053 "cfg.y"
                                                             {mk_action2( (yyval.action),
													SETBFLAG_T,
													NUMBER_ST, NUMBER_ST,
													(void *)(yyvsp[-3].intval), (void *)(yyvsp[-1].intval) ); }
#line 6577 "cfg.tab.c"
    break;

  case 423: /* cmd: SETBFLAG LPAREN NUMBER COMMA ID RPAREN  */
#line 2057 "cfg.y"
                                                         {mk_action2( (yyval.action),
													SETBFLAG_T,
													NUMBER_ST, STR_ST,
													(void *)(yyvsp[-3].intval), (void *)(yyvsp[-1].strval) ); }
#line 6586 "cfg.tab.c"
    break;

  case 424: /* cmd: SETBFLAG LPAREN NUMBER RPAREN  */
#line 2061 "cfg.y"
                                                {mk_action2( (yyval.action), SETBFLAG_T,
													NUMBER_ST, NUMBER_ST,
													0, (void *)(yyvsp[-1].intval) ); }
#line 6594 "cfg.tab.c"
    break;

  case 425: /* cmd: SETBFLAG LPAREN ID RPAREN  */
#line 2064 "cfg.y"
                                            {mk_action2( (yyval.action), SETBFLAG_T,
													NUMBER_ST, STR_ST,
													0, (void *)(yyvsp[-1].strval) ); }
#line 6602 "cfg.tab.c"
    break;

  case 426: /* cmd: SETBFLAG error  */
#line 2067 "cfg.y"
                                 { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 6608 "cfg.tab.c"
    break;

  case 427: /* cmd: RESETBFLAG LPAREN NUMBER COMMA NUMBER RPAREN  */
#line 2068 "cfg.y"
                                                               {mk_action2( (yyval.action),
													RESETBFLAG_T,
													NUMBER_ST, NUMBER_ST,
													(void *)(yyvsp[-3].intval), (void *)(yyvsp[-1].intval) ); }
#line 6617 "cfg.tab.c"
    break;

  case 428: /* cmd: RESETBFLAG LPAREN NUMBER COMMA ID RPAREN  */
#line 2072 "cfg.y"
                                                           {mk_action2( (yyval.action),
													RESETBFLAG_T,
													NUMBER_ST, STR_ST,
													(void *)(yyvsp[-3].intval), (void *)(yyvsp[-1].strval) ); }
#line 6626 "cfg.tab.c"
    break;

  case 429: /* cmd: RESETBFLAG LPAREN NUMBER RPAREN  */
#line 2076 "cfg.y"
                                                  {mk_action2( (yyval.action),
													RESETBFLAG_T,
													NUMBER_ST, NUMBER_ST,
													0, (void *)(yyvsp[-1].intval) ); }
#line 6635 "cfg.tab.c"
    break;

  case 430: /* cmd: RESETBFLAG LPAREN ID RPAREN  */
#line 2080 "cfg.y"
                                              {mk_action2( (yyval.action),
													RESETBFLAG_T,
													NUMBER_ST, STR_ST,
													0, (void *)(yyvsp[-1].strval) ); }
#line 6644 "cfg.tab.c"
    break;

  case 431: /* cmd: RESETBFLAG error  */
#line 2084 "cfg.y"
                                   { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 6650 "cfg.tab.c"
    break;

  case 432: /* cmd: ISBFLAGSET LPAREN NUMBER COMMA NUMBER RPAREN  */
#line 2085 "cfg.y"
                                                               {mk_action2( (yyval.action),
													ISBFLAGSET_T,
													NUMBER_ST, NUMBER_ST,
													(void *)(yyvsp[-3].intval), (void *)(yyvsp[-1].intval) ); }
#line 6659 "cfg.tab.c"
    break;

  case 433: /* cmd: ISBFLAGSET LPAREN NUMBER COMMA ID RPAREN  */
#line 2089 "cfg.y"
                                                           {mk_action2( (yyval.action),
													ISBFLAGSET_T,
													NUMBER_ST, STR_ST,
													(void *)(yyvsp[-3].intval), (void *)(yyvsp[-1].strval) ); }
#line 6668 "cfg.tab.c"
    break;

  case 434: /* cmd: ISBFLAGSET LPAREN NUMBER RPAREN  */
#line 2093 "cfg.y"
                                                  {mk_action2( (yyval.action),
													ISBFLAGSET_T,
													NUMBER_ST, NUMBER_ST,
													0, (void *)(yyvsp[-1].intval) ); }
#line 6677 "cfg.tab.c"
    break;

  case 435: /* cmd: ISBFLAGSET LPAREN ID RPAREN  */
#line 2097 "cfg.y"
                                              {mk_action2( (yyval.action),
													ISBFLAGSET_T,
													NUMBER_ST, STR_ST,
													0, (void *)(yyvsp[-1].strval) ); }
#line 6686 "cfg.tab.c"
    break;

  case 436: /* cmd: ISBFLAGSET error  */
#line 2101 "cfg.y"
                                   { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 6692 "cfg.tab.c"
    break;

  case 437: /* cmd: ERROR LPAREN STRING COMMA STRING RPAREN  */
#line 2102 "cfg.y"
                                                          {mk_action2( (yyval.action), ERROR_T,
																STRING_ST,
																STRING_ST,
																(yyvsp[-3].strval),
																(yyvsp[-1].strval));
												  }
#line 6703 "cfg.tab.c"
    break;

  case 438: /* cmd: ERROR error  */
#line 2108 "cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6709 "cfg.tab.c"
    break;

  case 439: /* cmd: ERROR LPAREN error RPAREN  */
#line 2109 "cfg.y"
                                            { (yyval.action)=0; yyerror("bad error"
														"argument"); }
#line 6716 "cfg.tab.c"
    break;

  case 440: /* cmd: ROUTE LPAREN route_name RPAREN  */
#line 2111 "cfg.y"
                                                        {
						i_tmp = get_script_route_idx( (yyvsp[-1].strval), rlist, RT_NO, 0);
						if (i_tmp==-1) yyerror("too many script routes");
						mk_action2( (yyval.action), ROUTE_T, NUMBER_ST,
							0, (void*)(long)i_tmp, 0);
					}
#line 6727 "cfg.tab.c"
    break;

  case 441: /* cmd: ROUTE LPAREN route_name COMMA route_param RPAREN  */
#line 2118 "cfg.y"
                                                                        {
						i_tmp = get_script_route_idx( (yyvsp[-3].strval), rlist, RT_NO, 0);
						if (i_tmp==-1) yyerror("too many script routes");
						if ((yyvsp[-1].intval) <= 0) yyerror("too many route parameters");

						/* duplicate the list */
						a_tmp = pkg_malloc((yyvsp[-1].intval) * sizeof(action_elem_t));
						if (!a_tmp) {
							yyerror("no more pkg memory");
							YYABORT;
						}
						memcpy(a_tmp, route_elems, (yyvsp[-1].intval)*sizeof(action_elem_t));

						mk_action3( (yyval.action), ROUTE_T, NUMBER_ST,	/* route idx */
							NUMBER_ST,					/* number of params */
							SCRIPTVAR_ELEM_ST,			/* parameters */
							(void*)(long)i_tmp,
							(void*)(long)(yyvsp[-1].intval),
							(void*)a_tmp);
					}
#line 6752 "cfg.tab.c"
    break;

  case 442: /* cmd: ROUTE error  */
#line 2139 "cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6758 "cfg.tab.c"
    break;

  case 443: /* cmd: ROUTE LPAREN error RPAREN  */
#line 2140 "cfg.y"
                                            { (yyval.action)=0; yyerror("bad route"
						"argument"); }
#line 6765 "cfg.tab.c"
    break;

  case 444: /* cmd: SET_HOST LPAREN STRING RPAREN  */
#line 2142 "cfg.y"
                                                { mk_action2( (yyval.action), SET_HOST_T, STR_ST,
														0, (yyvsp[-1].strval), 0); }
#line 6772 "cfg.tab.c"
    break;

  case 445: /* cmd: SET_HOST error  */
#line 2144 "cfg.y"
                                 { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6778 "cfg.tab.c"
    break;

  case 446: /* cmd: SET_HOST LPAREN error RPAREN  */
#line 2145 "cfg.y"
                                               { (yyval.action)=0; yyerror("bad argument, "
														"string expected"); }
#line 6785 "cfg.tab.c"
    break;

  case 447: /* cmd: PREFIX LPAREN STRING RPAREN  */
#line 2148 "cfg.y"
                                              { mk_action2( (yyval.action), PREFIX_T, STR_ST,
														0, (yyvsp[-1].strval), 0); }
#line 6792 "cfg.tab.c"
    break;

  case 448: /* cmd: PREFIX error  */
#line 2150 "cfg.y"
                               { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6798 "cfg.tab.c"
    break;

  case 449: /* cmd: PREFIX LPAREN error RPAREN  */
#line 2151 "cfg.y"
                                             { (yyval.action)=0; yyerror("bad argument, "
														"string expected"); }
#line 6805 "cfg.tab.c"
    break;

  case 450: /* cmd: STRIP_TAIL LPAREN NUMBER RPAREN  */
#line 2153 "cfg.y"
                                                  { mk_action2( (yyval.action), STRIP_TAIL_T,
									NUMBER_ST, 0, (void *) (yyvsp[-1].intval), 0); }
#line 6812 "cfg.tab.c"
    break;

  case 451: /* cmd: STRIP_TAIL error  */
#line 2155 "cfg.y"
                                   { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6818 "cfg.tab.c"
    break;

  case 452: /* cmd: STRIP_TAIL LPAREN error RPAREN  */
#line 2156 "cfg.y"
                                                 { (yyval.action)=0; yyerror("bad argument, "
														"number expected"); }
#line 6825 "cfg.tab.c"
    break;

  case 453: /* cmd: STRIP LPAREN NUMBER RPAREN  */
#line 2159 "cfg.y"
                                             { mk_action2( (yyval.action), STRIP_T, NUMBER_ST,
														0, (void *) (yyvsp[-1].intval), 0); }
#line 6832 "cfg.tab.c"
    break;

  case 454: /* cmd: STRIP error  */
#line 2161 "cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6838 "cfg.tab.c"
    break;

  case 455: /* cmd: STRIP LPAREN error RPAREN  */
#line 2162 "cfg.y"
                                            { (yyval.action)=0; yyerror("bad argument, "
														"number expected"); }
#line 6845 "cfg.tab.c"
    break;

  case 456: /* cmd: APPEND_BRANCH LPAREN STRING COMMA STRING RPAREN  */
#line 2164 "cfg.y"
                                                                  {
			{
				qvalue_t q;

				rc = str2q(&q, (yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
				if (rc < 0)
					yyerrorf("bad qvalue (%.*s): %s",
							 strlen((yyvsp[-1].strval)), (yyvsp[-1].strval), qverr2str(rc));

				mk_action2( (yyval.action), APPEND_BRANCH_T, STR_ST, NUMBER_ST, (yyvsp[-3].strval),
						(void *)(long)q);
			}
		}
#line 6863 "cfg.tab.c"
    break;

  case 457: /* cmd: APPEND_BRANCH LPAREN STRING RPAREN  */
#line 2177 "cfg.y"
                                                     { mk_action2( (yyval.action), APPEND_BRANCH_T,
						STR_ST, NUMBER_ST, (yyvsp[-1].strval), (void *)Q_UNSPECIFIED) ; }
#line 6870 "cfg.tab.c"
    break;

  case 458: /* cmd: APPEND_BRANCH LPAREN RPAREN  */
#line 2179 "cfg.y"
                                              { mk_action2( (yyval.action), APPEND_BRANCH_T,
						STR_ST, NUMBER_ST, 0, (void *)Q_UNSPECIFIED) ; }
#line 6877 "cfg.tab.c"
    break;

  case 459: /* cmd: APPEND_BRANCH  */
#line 2181 "cfg.y"
                                { mk_action2( (yyval.action), APPEND_BRANCH_T,
						STR_ST, NUMBER_ST, 0, (void *)Q_UNSPECIFIED ) ; }
#line 6884 "cfg.tab.c"
    break;

  case 460: /* cmd: REMOVE_BRANCH LPAREN NUMBER RPAREN  */
#line 2183 "cfg.y"
                                                     {
						mk_action1((yyval.action), REMOVE_BRANCH_T, NUMBER_ST, (void*)(yyvsp[-1].intval));}
#line 6891 "cfg.tab.c"
    break;

  case 461: /* cmd: REMOVE_BRANCH LPAREN script_var RPAREN  */
#line 2185 "cfg.y"
                                                         {
						mk_action1( (yyval.action), REMOVE_BRANCH_T, SCRIPTVAR_ST, (yyvsp[-1].specval));}
#line 6898 "cfg.tab.c"
    break;

  case 462: /* cmd: PV_PRINTF LPAREN STRING COMMA STRING RPAREN  */
#line 2187 "cfg.y"
                                                              {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[-3].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable in first parameter");
				}
				if(!pv_is_w(spec))
					yyerror("read-only script variable in first parameter");

				pvmodel = 0;
				tstr.s = (yyvsp[-1].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_format(&tstr, &pvmodel)<0)
				{
					yyerror("error in second parameter");
				}

				mk_action2( (yyval.action), PV_PRINTF_T,
						SCRIPTVAR_ST, SCRIPTVAR_ELEM_ST, spec, pvmodel) ;
			}
#line 6926 "cfg.tab.c"
    break;

  case 463: /* cmd: PV_PRINTF LPAREN script_var COMMA STRING RPAREN  */
#line 2210 "cfg.y"
                                                                  {
				if(!pv_is_w((yyvsp[-3].specval)))
					yyerror("read-only script variable in first parameter");
				pvmodel = 0;
				tstr.s = (yyvsp[-1].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_format(&tstr, &pvmodel)<0)
				{
					yyerror("error in second parameter");
				}

				mk_action2( (yyval.action), PV_PRINTF_T,
						SCRIPTVAR_ST, SCRIPTVAR_ELEM_ST, (yyvsp[-3].specval), pvmodel) ;
			}
#line 6945 "cfg.tab.c"
    break;

  case 464: /* cmd: SET_HOSTPORT LPAREN STRING RPAREN  */
#line 2225 "cfg.y"
                                                    { mk_action2( (yyval.action), SET_HOSTPORT_T,
														STR_ST, 0, (yyvsp[-1].strval), 0); }
#line 6952 "cfg.tab.c"
    break;

  case 465: /* cmd: SET_HOSTPORT error  */
#line 2227 "cfg.y"
                                     { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6958 "cfg.tab.c"
    break;

  case 466: /* cmd: SET_HOSTPORT LPAREN error RPAREN  */
#line 2228 "cfg.y"
                                                   { (yyval.action)=0; yyerror("bad argument,"
												" string expected"); }
#line 6965 "cfg.tab.c"
    break;

  case 467: /* cmd: SET_PORT LPAREN STRING RPAREN  */
#line 2230 "cfg.y"
                                                { mk_action2( (yyval.action), SET_PORT_T, STR_ST,
														0, (yyvsp[-1].strval), 0); }
#line 6972 "cfg.tab.c"
    break;

  case 468: /* cmd: SET_PORT error  */
#line 2232 "cfg.y"
                                 { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6978 "cfg.tab.c"
    break;

  case 469: /* cmd: SET_PORT LPAREN error RPAREN  */
#line 2233 "cfg.y"
                                               { (yyval.action)=0; yyerror("bad argument, "
														"string expected"); }
#line 6985 "cfg.tab.c"
    break;

  case 470: /* cmd: SET_USER LPAREN STRING RPAREN  */
#line 2235 "cfg.y"
                                                { mk_action2( (yyval.action), SET_USER_T,
														STR_ST, 0, (yyvsp[-1].strval), 0); }
#line 6992 "cfg.tab.c"
    break;

  case 471: /* cmd: SET_USER error  */
#line 2237 "cfg.y"
                                 { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6998 "cfg.tab.c"
    break;

  case 472: /* cmd: SET_USER LPAREN error RPAREN  */
#line 2238 "cfg.y"
                                               { (yyval.action)=0; yyerror("bad argument, "
														"string expected"); }
#line 7005 "cfg.tab.c"
    break;

  case 473: /* cmd: SET_USERPASS LPAREN STRING RPAREN  */
#line 2240 "cfg.y"
                                                    { mk_action2( (yyval.action), SET_USERPASS_T,
														STR_ST, 0, (yyvsp[-1].strval), 0); }
#line 7012 "cfg.tab.c"
    break;

  case 474: /* cmd: SET_USERPASS error  */
#line 2242 "cfg.y"
                                     { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7018 "cfg.tab.c"
    break;

  case 475: /* cmd: SET_USERPASS LPAREN error RPAREN  */
#line 2243 "cfg.y"
                                                   { (yyval.action)=0; yyerror("bad argument, "
														"string expected"); }
#line 7025 "cfg.tab.c"
    break;

  case 476: /* cmd: SET_URI LPAREN STRING RPAREN  */
#line 2245 "cfg.y"
                                               { mk_action2( (yyval.action), SET_URI_T, STR_ST,
														0, (yyvsp[-1].strval), 0); }
#line 7032 "cfg.tab.c"
    break;

  case 477: /* cmd: SET_URI error  */
#line 2247 "cfg.y"
                                { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7038 "cfg.tab.c"
    break;

  case 478: /* cmd: SET_URI LPAREN error RPAREN  */
#line 2248 "cfg.y"
                                              { (yyval.action)=0; yyerror("bad argument, "
										"string expected"); }
#line 7045 "cfg.tab.c"
    break;

  case 479: /* cmd: REVERT_URI LPAREN RPAREN  */
#line 2250 "cfg.y"
                                           { mk_action2( (yyval.action), REVERT_URI_T, 0,0,0,0); }
#line 7051 "cfg.tab.c"
    break;

  case 480: /* cmd: REVERT_URI  */
#line 2251 "cfg.y"
                             { mk_action2( (yyval.action), REVERT_URI_T, 0,0,0,0); }
#line 7057 "cfg.tab.c"
    break;

  case 481: /* cmd: SET_DSTURI LPAREN STRING RPAREN  */
#line 2252 "cfg.y"
                                                  { mk_action2( (yyval.action), SET_DSTURI_T,
													STR_ST, 0, (yyvsp[-1].strval), 0); }
#line 7064 "cfg.tab.c"
    break;

  case 482: /* cmd: SET_DSTURI error  */
#line 2254 "cfg.y"
                                   { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7070 "cfg.tab.c"
    break;

  case 483: /* cmd: SET_DSTURI LPAREN error RPAREN  */
#line 2255 "cfg.y"
                                                 { (yyval.action)=0; yyerror("bad argument, "
										"string expected"); }
#line 7077 "cfg.tab.c"
    break;

  case 484: /* cmd: RESET_DSTURI LPAREN RPAREN  */
#line 2257 "cfg.y"
                                             { mk_action2( (yyval.action), RESET_DSTURI_T,
															0,0,0,0); }
#line 7084 "cfg.tab.c"
    break;

  case 485: /* cmd: RESET_DSTURI  */
#line 2259 "cfg.y"
                               { mk_action2( (yyval.action), RESET_DSTURI_T, 0,0,0,0); }
#line 7090 "cfg.tab.c"
    break;

  case 486: /* cmd: ISDSTURISET LPAREN RPAREN  */
#line 2260 "cfg.y"
                                            { mk_action2( (yyval.action), ISDSTURISET_T, 0,0,0,0);}
#line 7096 "cfg.tab.c"
    break;

  case 487: /* cmd: ISDSTURISET  */
#line 2261 "cfg.y"
                              { mk_action2( (yyval.action), ISDSTURISET_T, 0,0,0,0); }
#line 7102 "cfg.tab.c"
    break;

  case 488: /* cmd: FORCE_RPORT LPAREN RPAREN  */
#line 2262 "cfg.y"
                                                { mk_action2( (yyval.action), FORCE_RPORT_T,
															0, 0, 0, 0); }
#line 7109 "cfg.tab.c"
    break;

  case 489: /* cmd: FORCE_RPORT  */
#line 2264 "cfg.y"
                                        { mk_action2( (yyval.action), FORCE_RPORT_T,0, 0, 0, 0); }
#line 7115 "cfg.tab.c"
    break;

  case 490: /* cmd: FORCE_LOCAL_RPORT LPAREN RPAREN  */
#line 2265 "cfg.y"
                                                        {
					mk_action2( (yyval.action), FORCE_LOCAL_RPORT_T,0, 0, 0, 0); }
#line 7122 "cfg.tab.c"
    break;

  case 491: /* cmd: FORCE_LOCAL_RPORT  */
#line 2267 "cfg.y"
                                                                {
					mk_action2( (yyval.action), FORCE_LOCAL_RPORT_T,0, 0, 0, 0); }
#line 7129 "cfg.tab.c"
    break;

  case 492: /* cmd: FORCE_TCP_ALIAS LPAREN NUMBER RPAREN  */
#line 2269 "cfg.y"
                                                        {
				mk_action2( (yyval.action), FORCE_TCP_ALIAS_T,NUMBER_ST, 0,
					(void*)(yyvsp[-1].intval), 0);
		}
#line 7138 "cfg.tab.c"
    break;

  case 493: /* cmd: FORCE_TCP_ALIAS LPAREN RPAREN  */
#line 2273 "cfg.y"
                                                {
				mk_action2( (yyval.action), FORCE_TCP_ALIAS_T,0, 0, 0, 0);
		}
#line 7146 "cfg.tab.c"
    break;

  case 494: /* cmd: FORCE_TCP_ALIAS  */
#line 2276 "cfg.y"
                                                                {
				mk_action2( (yyval.action), FORCE_TCP_ALIAS_T,0, 0, 0, 0);
		}
#line 7154 "cfg.tab.c"
    break;

  case 495: /* cmd: FORCE_TCP_ALIAS LPAREN error RPAREN  */
#line 2279 "cfg.y"
                                                        {(yyval.action)=0;
					yyerror("bad argument, number expected");
					}
#line 7162 "cfg.tab.c"
    break;

  case 496: /* cmd: SET_ADV_ADDRESS LPAREN listen_id RPAREN  */
#line 2282 "cfg.y"
                                                          {
								mk_action2( (yyval.action), SET_ADV_ADDR_T, STR_ST,
											0, (yyvsp[-1].strval), 0);
								}
#line 7171 "cfg.tab.c"
    break;

  case 497: /* cmd: SET_ADV_ADDRESS LPAREN error RPAREN  */
#line 2286 "cfg.y"
                                                      { (yyval.action)=0; yyerror("bad argument, "
														"string expected"); }
#line 7178 "cfg.tab.c"
    break;

  case 498: /* cmd: SET_ADV_ADDRESS error  */
#line 2288 "cfg.y"
                                        {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7184 "cfg.tab.c"
    break;

  case 499: /* cmd: SET_ADV_PORT LPAREN NUMBER RPAREN  */
#line 2289 "cfg.y"
                                                    {
								tstr.s = int2str((yyvsp[-1].intval), &tstr.len);
								if (!(tmp = pkg_malloc(tstr.len + 1))) {
										LM_CRIT("out of pkg memory\n");
										(yyval.action) = 0;
										YYABORT;
								} else {
									memcpy(tmp, tstr.s, tstr.len);
									tmp[tstr.len] = '\0';
									mk_action2((yyval.action), SET_ADV_PORT_T, STR_ST,
											   0, tmp, 0);
								}
								            }
#line 7202 "cfg.tab.c"
    break;

  case 500: /* cmd: SET_ADV_PORT LPAREN STRING RPAREN  */
#line 2302 "cfg.y"
                                                    {
								mk_action2((yyval.action), SET_ADV_PORT_T,
										   STR_ST, NOSUBTYPE,
										   (yyvsp[-1].strval), NULL);
								}
#line 7212 "cfg.tab.c"
    break;

  case 501: /* cmd: SET_ADV_PORT LPAREN error RPAREN  */
#line 2307 "cfg.y"
                                                   { (yyval.action)=0; yyerror("bad argument "
						"(string or integer expected)"); }
#line 7219 "cfg.tab.c"
    break;

  case 502: /* cmd: SET_ADV_PORT error  */
#line 2309 "cfg.y"
                                      {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7225 "cfg.tab.c"
    break;

  case 503: /* cmd: FORCE_SEND_SOCKET LPAREN phostport RPAREN  */
#line 2310 "cfg.y"
                                                            {
								mk_action2( (yyval.action), FORCE_SEND_SOCKET_T,
									SOCKID_ST, 0, (yyvsp[-1].sockid), 0);
								}
#line 7234 "cfg.tab.c"
    break;

  case 504: /* cmd: FORCE_SEND_SOCKET LPAREN error RPAREN  */
#line 2314 "cfg.y"
                                                        { (yyval.action)=0; yyerror("bad argument,"
								" proto:host[:port] expected");
								}
#line 7242 "cfg.tab.c"
    break;

  case 505: /* cmd: FORCE_SEND_SOCKET error  */
#line 2317 "cfg.y"
                                          {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7248 "cfg.tab.c"
    break;

  case 506: /* cmd: SERIALIZE_BRANCHES LPAREN NUMBER RPAREN  */
#line 2318 "cfg.y"
                                                          {
								mk_action1( (yyval.action), SERIALIZE_BRANCHES_T,
									NUMBER_ST, (void*)(long)(yyvsp[-1].intval));
								}
#line 7257 "cfg.tab.c"
    break;

  case 507: /* cmd: SERIALIZE_BRANCHES LPAREN NUMBER COMMA NUMBER RPAREN  */
#line 2322 "cfg.y"
                                                                       {
								mk_action2( (yyval.action), SERIALIZE_BRANCHES_T,
									NUMBER_ST, NUMBER_ST,
									(void*)(long)(yyvsp[-3].intval), (void*)(long)(yyvsp[-1].intval));
								}
#line 7267 "cfg.tab.c"
    break;

  case 508: /* cmd: SERIALIZE_BRANCHES LPAREN error RPAREN  */
#line 2327 "cfg.y"
                                                         {(yyval.action)=0; yyerror("bad argument,"
								" number expected");
								}
#line 7275 "cfg.tab.c"
    break;

  case 509: /* cmd: SERIALIZE_BRANCHES error  */
#line 2330 "cfg.y"
                                           {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7281 "cfg.tab.c"
    break;

  case 510: /* cmd: NEXT_BRANCHES LPAREN RPAREN  */
#line 2331 "cfg.y"
                                              {
								mk_action2( (yyval.action), NEXT_BRANCHES_T, 0, 0, 0, 0);
								}
#line 7289 "cfg.tab.c"
    break;

  case 511: /* cmd: NEXT_BRANCHES LPAREN error RPAREN  */
#line 2334 "cfg.y"
                                                    {(yyval.action)=0; yyerror("no argument is"
								" expected");
								}
#line 7297 "cfg.tab.c"
    break;

  case 512: /* cmd: NEXT_BRANCHES error  */
#line 2337 "cfg.y"
                                      {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7303 "cfg.tab.c"
    break;

  case 513: /* cmd: USE_BLACKLIST LPAREN STRING RPAREN  */
#line 2338 "cfg.y"
                                                     {
								mk_action2( (yyval.action), USE_BLACKLIST_T,
									STRING_ST, 0, (yyvsp[-1].strval), 0);
								}
#line 7312 "cfg.tab.c"
    break;

  case 514: /* cmd: USE_BLACKLIST LPAREN error RPAREN  */
#line 2342 "cfg.y"
                                                    {(yyval.action)=0; yyerror("bad argument,"
								" string expected");
								}
#line 7320 "cfg.tab.c"
    break;

  case 515: /* cmd: USE_BLACKLIST error  */
#line 2345 "cfg.y"
                                      {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7326 "cfg.tab.c"
    break;

  case 516: /* cmd: UNUSE_BLACKLIST LPAREN STRING RPAREN  */
#line 2346 "cfg.y"
                                                       {
								mk_action2( (yyval.action), UNUSE_BLACKLIST_T,
									STRING_ST, 0, (yyvsp[-1].strval), 0);
								}
#line 7335 "cfg.tab.c"
    break;

  case 517: /* cmd: UNUSE_BLACKLIST LPAREN error RPAREN  */
#line 2350 "cfg.y"
                                                      {(yyval.action)=0; yyerror("bad argument,"
								" string expected");
								}
#line 7343 "cfg.tab.c"
    break;

  case 518: /* cmd: UNUSE_BLACKLIST error  */
#line 2353 "cfg.y"
                                        {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7349 "cfg.tab.c"
    break;

  case 519: /* cmd: CACHE_STORE LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 2354 "cfg.y"
                                                                             {
									mk_action3( (yyval.action), CACHE_STORE_T,
													STR_ST,
													STR_ST,
													STR_ST,
													(yyvsp[-5].strval),
													(yyvsp[-3].strval),
													(yyvsp[-1].strval));
							}
#line 7363 "cfg.tab.c"
    break;

  case 520: /* cmd: CACHE_STORE LPAREN STRING COMMA STRING COMMA STRING COMMA NUMBER RPAREN  */
#line 2364 "cfg.y"
                                                                       {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-7].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-5].strval);
								elems[2].type = STR_ST;
								elems[2].u.data = (yyvsp[-3].strval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-1].intval);
								mk_action_((yyval.action), CACHE_STORE_T, 4, elems);
							}
#line 7379 "cfg.tab.c"
    break;

  case 521: /* cmd: CACHE_STORE LPAREN STRING COMMA STRING COMMA STRING COMMA script_var RPAREN  */
#line 2376 "cfg.y"
                                                                       {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-7].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-5].strval);
								elems[2].type = STR_ST;
								elems[2].u.data = (yyvsp[-3].strval);
								elems[3].type = SCRIPTVAR_ST;
								elems[3].u.data = (yyvsp[-1].specval);
								mk_action_((yyval.action), CACHE_STORE_T, 4, elems);
							}
#line 7395 "cfg.tab.c"
    break;

  case 522: /* cmd: CACHE_REMOVE LPAREN STRING COMMA STRING RPAREN  */
#line 2388 "cfg.y"
                                                                 {
									mk_action2( (yyval.action), CACHE_REMOVE_T,
													STR_ST,
													STR_ST,
													(yyvsp[-3].strval),
													(yyvsp[-1].strval));
							}
#line 7407 "cfg.tab.c"
    break;

  case 523: /* cmd: CACHE_FETCH LPAREN STRING COMMA STRING COMMA script_var RPAREN  */
#line 2395 "cfg.y"
                                                                                 {
									mk_action3( (yyval.action), CACHE_FETCH_T,
													STR_ST,
													STR_ST,
													SCRIPTVAR_ST,
													(yyvsp[-5].strval),
													(yyvsp[-3].strval),
													(yyvsp[-1].specval));
							}
#line 7421 "cfg.tab.c"
    break;

  case 524: /* cmd: CACHE_COUNTER_FETCH LPAREN STRING COMMA STRING COMMA script_var RPAREN  */
#line 2404 "cfg.y"
                                                                                         {
									mk_action3( (yyval.action), CACHE_COUNTER_FETCH_T,
													STR_ST,
													STR_ST,
													SCRIPTVAR_ST,
													(yyvsp[-5].strval),
													(yyvsp[-3].strval),
													(yyvsp[-1].specval));
							}
#line 7435 "cfg.tab.c"
    break;

  case 525: /* cmd: CACHE_ADD LPAREN STRING COMMA STRING COMMA NUMBER COMMA NUMBER RPAREN  */
#line 2413 "cfg.y"
                                                                                        {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-7].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-5].strval);
								elems[2].type = NUMBER_ST;
								elems[2].u.number = (yyvsp[-3].intval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-1].intval);
								mk_action_((yyval.action), CACHE_ADD_T, 4, elems);
							}
#line 7451 "cfg.tab.c"
    break;

  case 526: /* cmd: CACHE_ADD LPAREN STRING COMMA STRING COMMA script_var COMMA NUMBER RPAREN  */
#line 2424 "cfg.y"
                                                                                            {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-7].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-5].strval);
								elems[2].type = SCRIPTVAR_ST;
								elems[2].u.data = (yyvsp[-3].specval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-1].intval);
								mk_action_((yyval.action), CACHE_ADD_T, 4, elems);
							}
#line 7467 "cfg.tab.c"
    break;

  case 527: /* cmd: CACHE_ADD LPAREN STRING COMMA STRING COMMA NUMBER COMMA NUMBER COMMA script_var RPAREN  */
#line 2435 "cfg.y"
                                                                                                         {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-9].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-7].strval);
								elems[2].type = NUMBER_ST;
								elems[2].u.number = (yyvsp[-5].intval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-3].intval);
								elems[4].type = SCRIPTVAR_ST;
								elems[4].u.data = (yyvsp[-1].specval);
								mk_action_((yyval.action), CACHE_ADD_T, 5, elems);
							}
#line 7485 "cfg.tab.c"
    break;

  case 528: /* cmd: CACHE_ADD LPAREN STRING COMMA STRING COMMA script_var COMMA NUMBER COMMA script_var RPAREN  */
#line 2448 "cfg.y"
                                                                                                             {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-9].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-7].strval);
								elems[2].type = SCRIPTVAR_ST;
								elems[2].u.data = (yyvsp[-5].specval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-3].intval);
								elems[4].type = SCRIPTVAR_ST;
								elems[4].u.data = (yyvsp[-1].specval);
								mk_action_((yyval.action), CACHE_ADD_T, 5, elems);
							}
#line 7503 "cfg.tab.c"
    break;

  case 529: /* cmd: CACHE_SUB LPAREN STRING COMMA STRING COMMA NUMBER COMMA NUMBER RPAREN  */
#line 2461 "cfg.y"
                                                                                        {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-7].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-5].strval);
								elems[2].type = NUMBER_ST;
								elems[2].u.number = (yyvsp[-3].intval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-1].intval);
								mk_action_((yyval.action), CACHE_SUB_T, 4, elems);
							}
#line 7519 "cfg.tab.c"
    break;

  case 530: /* cmd: CACHE_SUB LPAREN STRING COMMA STRING COMMA script_var COMMA NUMBER RPAREN  */
#line 2472 "cfg.y"
                                                                                            {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-7].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-5].strval);
								elems[2].type = SCRIPTVAR_ST;
								elems[2].u.data = (yyvsp[-3].specval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-1].intval);
								mk_action_((yyval.action), CACHE_SUB_T, 4, elems);
							}
#line 7535 "cfg.tab.c"
    break;

  case 531: /* cmd: CACHE_SUB LPAREN STRING COMMA STRING COMMA NUMBER COMMA NUMBER COMMA script_var RPAREN  */
#line 2483 "cfg.y"
                                                                                                         {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-9].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-7].strval);
								elems[2].type = NUMBER_ST;
								elems[2].u.number = (yyvsp[-5].intval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-3].intval);
								elems[4].type = SCRIPTVAR_ST;
								elems[4].u.data = (yyvsp[-1].specval);
								mk_action_((yyval.action), CACHE_SUB_T, 5, elems);
							}
#line 7553 "cfg.tab.c"
    break;

  case 532: /* cmd: CACHE_SUB LPAREN STRING COMMA STRING COMMA script_var COMMA NUMBER COMMA script_var RPAREN  */
#line 2496 "cfg.y"
                                                                                                             {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-9].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-7].strval);
								elems[2].type = SCRIPTVAR_ST;
								elems[2].u.data = (yyvsp[-5].specval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-3].intval);
								elems[4].type = SCRIPTVAR_ST;
								elems[4].u.data = (yyvsp[-1].specval);
								mk_action_((yyval.action), CACHE_SUB_T, 5, elems);
							}
#line 7571 "cfg.tab.c"
    break;

  case 533: /* cmd: CACHE_RAW_QUERY LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 2509 "cfg.y"
                                                                                 {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-5].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-3].strval);
								elems[2].type = STR_ST;
								elems[2].u.data = (yyvsp[-1].strval);
								mk_action_((yyval.action), CACHE_RAW_QUERY_T, 3, elems);
							}
#line 7585 "cfg.tab.c"
    break;

  case 534: /* cmd: CACHE_RAW_QUERY LPAREN STRING COMMA STRING RPAREN  */
#line 2518 "cfg.y"
                                                                    {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-3].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-1].strval);
								mk_action_((yyval.action), CACHE_RAW_QUERY_T, 2, elems);
							}
#line 7597 "cfg.tab.c"
    break;

  case 535: /* cmd: ID LPAREN RPAREN  */
#line 2525 "cfg.y"
                                                {
						 			cmd_tmp=(void*)find_cmd_export_t((yyvsp[-2].strval), 0, rt);
									if (cmd_tmp==0){
										if (find_cmd_export_t((yyvsp[-2].strval), 0, 0)) {
											yyerror("Command cannot be "
												"used in the block\n");
										} else {
											yyerrorf("unknown command <%s>, "
												"missing loadmodule?", (yyvsp[-2].strval));
										}
										(yyval.action)=0;
									}else{
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), MODULE_T, 1, elems);
									}
								}
#line 7619 "cfg.tab.c"
    break;

  case 536: /* cmd: ID LPAREN module_func_param RPAREN  */
#line 2542 "cfg.y"
                                                                {
									cmd_tmp=(void*)find_cmd_export_t((yyvsp[-3].strval),(yyvsp[-1].intval),rt);
									if (cmd_tmp==0){
										if (find_cmd_export_t((yyvsp[-3].strval), (yyvsp[-1].intval), 0)) {
											yyerror("Command cannot be "
												"used in the block\n");
										} else {
											yyerrorf("unknown command <%s>, "
												"missing loadmodule?", (yyvsp[-3].strval));
										}
										(yyval.action)=0;
									}else{
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), MODULE_T, (yyvsp[-1].intval)+1, elems);
									}
								}
#line 7641 "cfg.tab.c"
    break;

  case 537: /* cmd: ID LPAREN error RPAREN  */
#line 2559 "cfg.y"
                                         { (yyval.action)=0; yyerrorf("bad arguments for "
												"command <%s>", (yyvsp[-3].strval)); }
#line 7648 "cfg.tab.c"
    break;

  case 538: /* cmd: ID error  */
#line 2561 "cfg.y"
                           { (yyval.action)=0;
			yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 7656 "cfg.tab.c"
    break;

  case 539: /* cmd: XDBG LPAREN STRING RPAREN  */
#line 2564 "cfg.y"
                                            {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 7663 "cfg.tab.c"
    break;

  case 540: /* cmd: XDBG LPAREN folded_string RPAREN  */
#line 2566 "cfg.y"
                                                   {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 7670 "cfg.tab.c"
    break;

  case 541: /* cmd: XLOG LPAREN STRING RPAREN  */
#line 2568 "cfg.y"
                                            {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 7677 "cfg.tab.c"
    break;

  case 542: /* cmd: XLOG LPAREN folded_string RPAREN  */
#line 2570 "cfg.y"
                                                   {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 7684 "cfg.tab.c"
    break;

  case 543: /* cmd: XLOG LPAREN STRING COMMA STRING RPAREN  */
#line 2572 "cfg.y"
                                                         {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 7691 "cfg.tab.c"
    break;

  case 544: /* cmd: XLOG LPAREN STRING COMMA folded_string RPAREN  */
#line 2574 "cfg.y"
                                                                {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 7698 "cfg.tab.c"
    break;

  case 545: /* cmd: RAISE_EVENT LPAREN STRING RPAREN  */
#line 2576 "cfg.y"
                                                   {
				mk_action1((yyval.action), RAISE_EVENT_T, STR_ST, (yyvsp[-1].strval)); }
#line 7705 "cfg.tab.c"
    break;

  case 546: /* cmd: RAISE_EVENT LPAREN STRING COMMA script_var RPAREN  */
#line 2578 "cfg.y"
                                                                    {
				mk_action2((yyval.action), RAISE_EVENT_T, STR_ST, SCRIPTVAR_ST, (yyvsp[-3].strval), (yyvsp[-1].specval)); }
#line 7712 "cfg.tab.c"
    break;

  case 547: /* cmd: RAISE_EVENT LPAREN STRING COMMA script_var COMMA script_var RPAREN  */
#line 2580 "cfg.y"
                                                                                     {
				mk_action3((yyval.action), RAISE_EVENT_T, STR_ST, SCRIPTVAR_ST,
					SCRIPTVAR_ST, (yyvsp[-5].strval), (yyvsp[-3].specval), (yyvsp[-1].specval)); }
#line 7720 "cfg.tab.c"
    break;

  case 548: /* cmd: SUBSCRIBE_EVENT LPAREN STRING COMMA STRING RPAREN  */
#line 2583 "cfg.y"
                                                                    {
				mk_action2((yyval.action), SUBSCRIBE_EVENT_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 7727 "cfg.tab.c"
    break;

  case 549: /* cmd: SUBSCRIBE_EVENT LPAREN STRING COMMA STRING COMMA NUMBER RPAREN  */
#line 2585 "cfg.y"
                                                                                 {
				mk_action3((yyval.action), SUBSCRIBE_EVENT_T, STR_ST, STR_ST,
					NUMBER_ST, (yyvsp[-5].strval), (yyvsp[-3].strval), (void*)(long)(yyvsp[-1].intval)); }
#line 7735 "cfg.tab.c"
    break;

  case 550: /* cmd: CONSTRUCT_URI LPAREN STRING COMMA STRING COMMA STRING COMMA STRING COMMA STRING COMMA script_var RPAREN  */
#line 2588 "cfg.y"
                                                                                                                          {
				elems[0].type = STR_ST;
				elems[0].u.data = (yyvsp[-11].strval);
				elems[1].type = STR_ST;
				elems[1].u.data = (yyvsp[-9].strval);
				elems[2].type = STR_ST;
				elems[2].u.data = (yyvsp[-7].strval);
				elems[3].type = STR_ST;
				elems[3].u.data = (yyvsp[-5].strval);
				elems[4].type = STR_ST;
				elems[4].u.data = (yyvsp[-3].strval);
				elems[5].type = SCRIPTVAR_ST;
				elems[5].u.data = (yyvsp[-1].specval);
				mk_action_((yyval.action), CONSTRUCT_URI_T,6,elems); }
#line 7754 "cfg.tab.c"
    break;

  case 551: /* cmd: GET_TIMESTAMP LPAREN script_var COMMA script_var RPAREN  */
#line 2602 "cfg.y"
                                                                          {
				elems[0].type = SCRIPTVAR_ST;
				elems[0].u.data = (yyvsp[-3].specval);
				elems[1].type = SCRIPTVAR_ST;
				elems[1].u.data = (yyvsp[-1].specval);
				mk_action_((yyval.action), GET_TIMESTAMP_T,2,elems); }
#line 7765 "cfg.tab.c"
    break;

  case 552: /* cmd: SCRIPT_TRACE LPAREN RPAREN  */
#line 2608 "cfg.y"
                                             {
				mk_action2((yyval.action), SCRIPT_TRACE_T, 0, 0, 0, 0); }
#line 7772 "cfg.tab.c"
    break;

  case 553: /* cmd: SCRIPT_TRACE LPAREN NUMBER COMMA STRING RPAREN  */
#line 2610 "cfg.y"
                                                                 {
				pvmodel = 0;
				tstr.s = (yyvsp[-1].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_format(&tstr, &pvmodel)<0)
					yyerror("error in second parameter");
				mk_action2((yyval.action), SCRIPT_TRACE_T, NUMBER_ST,
						   SCRIPTVAR_ELEM_ST, (void *)(yyvsp[-3].intval), pvmodel); }
#line 7785 "cfg.tab.c"
    break;

  case 554: /* cmd: SCRIPT_TRACE LPAREN NUMBER COMMA STRING COMMA STRING RPAREN  */
#line 2618 "cfg.y"
                                                                              {
				pvmodel = 0;
				tstr.s = (yyvsp[-3].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_format(&tstr, &pvmodel)<0)
					yyerror("error in second parameter");
				mk_action3((yyval.action), SCRIPT_TRACE_T, NUMBER_ST,
						SCRIPTVAR_ELEM_ST, STR_ST, (void *)(yyvsp[-5].intval), pvmodel, (yyvsp[-1].strval)); }
#line 7798 "cfg.tab.c"
    break;

  case 555: /* cmd: ASYNC_TOKEN LPAREN async_func COMMA route_name RPAREN  */
#line 2626 "cfg.y"
                                                                        {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), rlist, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 7809 "cfg.tab.c"
    break;

  case 556: /* cmd: LAUNCH_TOKEN LPAREN async_func COMMA route_name RPAREN  */
#line 2632 "cfg.y"
                                                                         {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), rlist, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 7820 "cfg.tab.c"
    break;

  case 557: /* cmd: LAUNCH_TOKEN LPAREN async_func RPAREN  */
#line 2638 "cfg.y"
                                                        {
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-1].action), (void*)(long)-1);
				}
#line 7829 "cfg.tab.c"
    break;

  case 558: /* cmd: IS_MYSELF LPAREN STRING RPAREN  */
#line 2642 "cfg.y"
                                                 {
				mk_action2((yyval.action), IS_MYSELF_T, STR_ST, 0, (yyvsp[-1].strval), 0);
				}
#line 7837 "cfg.tab.c"
    break;

  case 559: /* cmd: IS_MYSELF LPAREN STRING COMMA STRING RPAREN  */
#line 2645 "cfg.y"
                                                              {
				mk_action2((yyval.action), IS_MYSELF_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval));
				}
#line 7845 "cfg.tab.c"
    break;


#line 7849 "cfg.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2651 "cfg.y"


static inline void ALLOW_UNUSED warn(char* s)
{
	LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
}

static void yyerror(char* s)
{
	LM_CRIT("parse error in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
	cfg_errors++;
}

#define ERROR_MAXLEN 1024
static void yyerrorf(char *fmt, ...)
{
	char *tmp = pkg_malloc(ERROR_MAXLEN);
	va_list ap;
	va_start(ap, fmt);

	vsnprintf(tmp, ERROR_MAXLEN, fmt, ap);
	yyerror(tmp);

	pkg_free(tmp);
	va_end(ap);
}


static struct socket_id* mk_listen_id(char* host, enum sip_protos proto,
																	int port)
{
	struct socket_id* l;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0){
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		l->name     = host;
		l->adv_name = NULL;
		l->adv_port = 0;
		l->proto    = proto;
		l->port     = port;
		l->children = 0;
		l->next     = NULL;
	}

	return l;
}

static struct multi_str *new_string(char *s)
{
	struct multi_str *ms = pkg_malloc(sizeof(struct multi_str));
	if (!ms) {
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		ms->s    = s;
		ms->next = NULL;
	}
	return ms;
}

static struct socket_id* set_listen_id_adv(struct socket_id* sock,
											char *adv_name,
											int adv_port)
{
	sock->adv_name=adv_name;
	sock->adv_port=adv_port;
	return sock;
}

static int parse_ipnet(char *in, int len, struct net **ipnet)
{
	char *p = NULL;
	str ip_s, mask_s;
	struct ip_addr *ip = NULL, *mask = NULL, *ip_tmp;
	int af;
	unsigned int bitlen;

	p = q_memchr(in, '.', len);
	if (p)
		af = AF_INET;
	else if (q_memchr(in, ':', len)) {
		af = AF_INET6;
	} else {
		LM_ERR("Not an IP");
		return -1;
	}

	p = q_memchr(in, '/', len);
	if (!p) {
		LM_ERR("No netmask\n");
		return -1;
	}
	ip_s.s = in;
	ip_s.len = p - in;

	mask_s.s = p + 1;
	mask_s.len = len - ip_s.len - 1;
	if (!mask_s.s || mask_s.len == 0) {
		LM_ERR("Empty netmask\n");
		return -1;
	}

	ip_tmp = (af == AF_INET) ? str2ip(&ip_s) : str2ip6(&ip_s);
	if (!ip_tmp) {
		LM_ERR("Invalid IP\n");
		return -1;
	}
	ip = pkg_malloc(sizeof *ip);
	if (!ip) {
		LM_CRIT("No more pkg memory\n");
		return -1;
	}
	memcpy(ip, ip_tmp, sizeof *ip);

	p = (af == AF_INET) ? q_memchr(p, '.', len-(p-in)+1) : q_memchr(p, ':', len-(p-in)+1);
	if (p) {
		ip_tmp = (af == AF_INET) ? str2ip(&mask_s) : str2ip6(&mask_s);
		if (!ip_tmp) {
			LM_ERR("Invalid netmask\n");
			return -1;
		}
		mask = pkg_malloc(sizeof *mask);
		if (!mask) {
			LM_CRIT("No more pkg memory\n");
			return -1;
		}
		memcpy(mask, ip_tmp, sizeof *mask);

		*ipnet = mk_net(ip, mask);
	} else {
		if (str2int(&mask_s, &bitlen) < 0) {
			LM_ERR("Invalid netmask bitlen\n");
			return -1;
		}

		*ipnet = mk_net_bitlen(ip, bitlen);
	}

	pkg_free(ip);
	pkg_free(mask);

	if (*ipnet == NULL)
			return -1;

	return 0;
}
